SystemOrganization addCategory: #Deprecated13!

SourceFileArray subclass: #StandardSourceFileArray
	instanceVariableNames: 'files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!StandardSourceFileArray commentStamp: 'VeronicaUquillas 6/11/2010 13:29' prior: 0!
This class implements the source file management behavior of traditional Pharo, with a sources file and a changes file. File positions are mapped such that those files can be up to 32MBytes in size.

Structure:
 files		Array -- storing the actual source files
!

!StandardSourceFileArray class methodsFor: 'initialization' stamp: 'ar 5/17/2000 18:27'!
new: nFiles
	^self new initialize: nFiles.! !

!StandardSourceFileArray methodsFor: 'accessing' stamp: 'hmm 4/25/2000 21:20'!
at: index
	^files at: index! !

!StandardSourceFileArray methodsFor: 'accessing' stamp: 'StephaneDucasse 5/6/2010 08:50'!
at: index put: aFile
	^ files at: index put: aFile! !

!StandardSourceFileArray methodsFor: 'sourcePointer conversion' stamp: 'dtl 12/24/2009 10:04'!
checkOKToAdd: size at: filePosition
	"Issue several warnings as the end of the changes file approaches its limit,
	and finally halt with an error when the end is reached."

	| fileSizeLimit margin |
	fileSizeLimit := 16r2000000.
	3 to: 1 by: -1 do:
		[:i | margin := i*100000.
		(filePosition + size + margin) > fileSizeLimit
			ifTrue: [(filePosition + margin) > fileSizeLimit ifFalse:
						[self inform: 'WARNING: your changes file is within
' , margin printString , ' characters of its size limit.
You should take action soon to reduce its size.
You may proceed.']]
			ifFalse: [^ self]].
	(filePosition + size > fileSizeLimit) ifFalse: [^ self].
	self error: 'You have reached the size limit of the changes file.
You must take action now to reduce it.
Close this error.  Do not attempt to proceed.'! !

!StandardSourceFileArray methodsFor: 'sourcepointer conversion' stamp: 'stephaneducasse 2/4/2006 20:32'!
fileIndexFromSourcePointer: anInteger
	"Return the index of the source file which contains the source chunk addressed by anInteger"
	"This implements the recent 32M source file algorithm"

	| hi |
	hi := anInteger // 16r1000000.
	^hi < 3
		ifTrue: [hi]
		ifFalse: [hi - 2]! !

!StandardSourceFileArray methodsFor: 'sourcepointer conversion' stamp: 'stephaneducasse 2/4/2006 20:32'!
filePositionFromSourcePointer: anInteger
	"Return the position of the source chunk addressed by anInteger"
	"This implements the recent 32M source file algorithm"

	| hi lo |
	hi := anInteger // 16r1000000.
	lo := anInteger \\ 16r1000000.
	^hi < 3
		ifTrue: [lo]
		ifFalse: [lo + 16r1000000]! !

!StandardSourceFileArray methodsFor: 'initialization' stamp: 'alain.plantec 5/28/2009 11:06'!
initialize
	super initialize.
	files := Array new: 2.
	files at: 1 put: (SourceFiles at: 1).
	files at: 2 put: (SourceFiles at: 2)! !

!StandardSourceFileArray methodsFor: 'initialization' stamp: 'stephaneducasse 2/4/2006 20:32'!
initialize: nFiles
	files := Array new: nFiles! !

!StandardSourceFileArray methodsFor: 'accessing' stamp: 'hmm 4/25/2000 21:20'!
size
	^files size! !

!StandardSourceFileArray methodsFor: 'sourcepointer conversion' stamp: 'stephaneducasse 2/4/2006 20:32'!
sourcePointerFromFileIndex: index andPosition: position
	| hi lo |
	"Return a source pointer according to the new 32M algorithm"
	((index between: 1 and: 2) and: [position between: 0 and: 16r1FFFFFF])
		ifFalse: [self error: 'invalid source code pointer'].
	hi := index.
	lo := position.
	lo >= 16r1000000 ifTrue: [
		hi := hi+2.
		lo := lo - 16r1000000].
	^hi * 16r1000000 + lo! !

MultiNewParagraph subclass: #MultiNewParagraphWithSelectionColor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!MultiNewParagraphWithSelectionColor commentStamp: 'AlainPlantec 11/18/2010 08:29' prior: 0!
Paragraph supporting custom selection colour.
DEPRECATED in 1.2
selectionColor is stored in NewParagraph now!

!DirectoryEntry methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
at: index
	"compatibility interface"

	self deprecated: 'old-style access to DirectoryEntry' on: '15 February 2010' in: 'Pharo1.2'.
	index = 1
		ifTrue: [ ^ self name ].
	index = 2
		ifTrue: [ ^ self creationTime ].
	index = 3
		ifTrue: [ ^ self modificationTime ].
	index = 4
		ifTrue: [ ^ self isDirectory ].
	index = 5
		ifTrue: [ ^ self fileSize ].
	self error: 'invalid index specified'! !

OrderedCollection subclass: #UrlArgumentList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!UrlArgumentList commentStamp: 'LaurentLaffont 6/8/2011 22:20' prior: 0!
To deprecate, see http://code.google.com/p/pharo/issues/detail?id=4377!

!UrlArgumentList class methodsFor: 'instance creation' stamp: 'mir 7/27/1999 16:25'!
with: argAssoc
	| argList |
	argList := self new.
	argList add: argAssoc key value: argAssoc value.
	^argList! !

!UrlArgumentList class methodsFor: 'instance creation' stamp: 'mir 7/27/1999 16:26'!
with: firstArgAssoc with: secondArgAssoc
	| argList |
	argList := self with: firstArgAssoc.
	argList add: secondArgAssoc key value: secondArgAssoc value.
	^argList! !

!UrlArgumentList class methodsFor: 'instance creation' stamp: 'mir 7/27/1999 16:26'!
with: firstArgAssoc with: secondArgAssoc with: thirdArgAssoc
	| argList |
	argList := self with: firstArgAssoc with: secondArgAssoc.
	argList add: thirdArgAssoc key value: thirdArgAssoc value.
	^argList! !

!UrlArgumentList methodsFor: 'adding' stamp: 'mir 7/27/1999 16:19'!
add: argName value: argValue
	| argAssociation |
	argAssociation := self argumentNamed: argName.
	argAssociation isNil
		ifTrue: [self add: (argName -> (OrderedCollection with: argValue))]
		ifFalse: [argAssociation value add: argValue]! !

!UrlArgumentList methodsFor: 'private' stamp: 'mir 7/27/1999 16:20'!
argumentNamed: argName
	^self
		detect: [:each | each key = argName]
		ifNone: [nil]! !

!Parser methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
method: doit context: ctxt encoder: encoderToUse
	" pattern [ | temporaries ] block => MethodNode."

	self deprecated: 'Parsing no longer uses encoder as argument' on: '31 May 2010' in: 'Pharo1.2'.
	^ self method: doit context: ctxt! !

!String methodsFor: '*deprecated13' stamp: 'StephaneDucasse 2/13/2010 12:20'!
asDefaultDecodedString
	self deprecated: 'does not seem to be used anymore'  on: '13 February 2010' in: 'Pharo1.1'.
	
	^ self
! !

!String methodsFor: '*deprecated13' stamp: 'MarcusDenker 3/26/2011 17:14'!
asParagraph
	"Answer a Paragraph whose text string is the receiver."
	self deprecated: 'ST80 lefover' on:  '21 March 2011' in: 'Pharo1.3'.
	^Paragraph withText: self asText! !

!String methodsFor: '*deprecated13' stamp: 'MarcusDenker 3/24/2011 11:49'!
getInteger32: location
	| integer |
	self deprecated: 'nebraska leftover' on: '24 March 2011' in: 'Pharo1.3'.
	
	"<primitive: 'getInteger' module: 'IntegerPokerPlugin'>"
	"^IntegerPokerPlugin doPrimitive: #getInteger"

	"the following is about 7x faster than interpreting the plugin if not compiled"

	integer := 
		((self at: location) asInteger bitShift: 24) +
		((self at: location+1) asInteger bitShift: 16) +
		((self at: location+2) asInteger bitShift: 8) +
		(self at: location+3) asInteger.

	integer > 1073741824 ifTrue: [^1073741824 - integer ].
	^integer
! !

!String methodsFor: '*deprecated13' stamp: 'MarcusDenker 3/24/2011 11:49'!
putInteger32: anInteger at: location
	| integer |
	self deprecated: 'nebraska leftover' on: '24 March 2011' in: 'Pharo1.3'.
	
	"<primitive: 'putInteger' module: 'IntegerPokerPlugin'>"
	"IntegerPokerPlugin doPrimitive: #putInteger"

	"the following is close to 20x faster than the above if the primitive is not compiled"
	"PUTCOUNTER := PUTCOUNTER + 1."
	integer := anInteger.
	integer < 0 ifTrue: [integer :=  1073741824 - integer. ].
	self at: location+3 put: (Character value: (integer \\ 256)).
	self at: location+2 put: (Character value: (integer bitShift: -8) \\ 256).
	self at: location+1 put: (Character value: (integer bitShift: -16) \\ 256).
	self at: location put: (Character value: (integer bitShift: -24) \\ 256).

"Smalltalk at: #PUTCOUNTER put: 0"! !

!String methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
sansPeriodSuffix
	"Return a copy of the receiver up to, but not including, the first period.  If the receiver's *first* character is a period, then just return the entire receiver. "

	self deprecated: 'Use withoutPeriodSuffix' on: '16 April 2010' in: 'Pharo1.2'.
	^ self withoutPeriodSuffix! !

Notification subclass: #PickAFileToWriteNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!PickAFileToWriteNotification commentStamp: 'LaurentLaffont 3/15/2011 20:47' prior: 0!
I provide a way to indicate that an object would like a file to write to.

(Note: not referenced, may be removed).

You can use me as follows:
        | file |
        [file := PickAFileToWriteNotification signal.
        file inspect]
                on: PickAFileToWriteNotification
                do: [:ex | 
                        | newFileName stream | 
                        newFileName := FillInTheBlankMorph request: 'Name of file to write:' translated initialAnswer: 'xxx'.
                        stream := FileStream fileNamed: newFileName.
                        stream
                                ifNotNil: [ex resume: stream]].!

StandardFileStream subclass: #CrLfFileStream
	instanceVariableNames: 'lineEndConvention'
	classVariableNames: 'Cr CrLf Lf LineEndDefault LineEndStrings LookAheadCount'
	poolDictionaries: ''
	category: 'Deprecated13'!

!CrLfFileStream commentStamp: 'MarcusDenker 5/1/2011 14:04' prior: 0!
** in Compatibility Package as VMMaker needs is (why?)"

I have been deprecated in favour of a MultiByteFileStream with lineending conversion. The main difference is MultiByte supporting encoders other than the default for ascii mode.
The instance side methods have been left for posterity, but instance creation should now return a MultiByteFileStream with latin1 encoding, and default lineEndConvention.

I was the same as a regular file stream, except that when I was in text mode, I would automatically convert line endings between the underlying platform's convention, and Squeak's convention of carriage-return only.  The goal was that Squeak text files could be treated as OS text files, and vice versa.

In binary mode, I behaved identically to a StandardFileStream.


There were two caveats on programming with CrLfFileStream.

First, the choice of text mode versus binary mode affects which characters are visible in Squeak, and no longer just affects whether those characters are returned as Character's or as Integer's.  Thus the choice of mode needs to be made very carefully, and must be based on intent instead of convenience of representation.  The methods asString, asByteArray, asCharacter, and asInteger can be used to convert between character and integer representations.  (Arguably, file streams should accept either strings or characters in nextPut: and nextPutAll:, but that is not the case right now.)

Second, arithmetic on positions no longer worked, because one character that Squeak sees (carriage return) could map to two characters in the underlying file (carriage return plus line feed, on MS Windows and MS DOS).  Comparison between positions still works.  (This caveat could perhaps be fixed by maintaining a map between Squeak positions and positions in the underlying file, but it is complicated.  Consider, for example, updates to the middle of the file.  Also, consider that text files are rarely updated in the middle of the file, and that general random access to a text file is rarely very useful.  If general random access with specific file counts is desired, then the file is starting to sound like a binary file instead of a text file.)

!

!CrLfFileStream class methodsFor: 'initialization' stamp: 'SeanDeNigris 8/31/2011 14:20'!
basicNew
	self deprecated: 'MultiByteFileStream should now be used for my functionality.' on: '10 March 2010' in: 'Pharo1.2'.	"Return the old value if ignored. Can't say we didn't warn them"
	^ super basicNew! !

!CrLfFileStream class methodsFor: 'initialization' stamp: 'HenrikSperreJohansen 3/10/2010 00:55'!
defaultToCR
	"CrLfFileStream defaultToCR"
	self substituteClass defaultToCR! !

!CrLfFileStream class methodsFor: 'initialization' stamp: 'HenrikSperreJohansen 3/10/2010 00:55'!
defaultToCRLF
	"CrLfFileStream defaultToCRLF"
	self substituteClass defaultToCRLF! !

!CrLfFileStream class methodsFor: 'initialization' stamp: 'HenrikSperreJohansen 3/10/2010 00:56'!
defaultToLF
	"CrLfFileStream defaultToLF"
	self substituteClass defaultToLF! !

!CrLfFileStream class methodsFor: 'class initialization' stamp: 'StephaneDucasse 8/3/2010 22:56'!
guessDefaultLineEndConvention
	^ self substituteClass guessDefaultLineEndConvention! !

!CrLfFileStream class methodsFor: 'initialization' stamp: 'MarcusDenker 5/1/2011 14:00'!
initialize
	"Don't bother, we are deprecated"
	"CrLfFileStream initialize"
	
	"Cr := Character cr.
	Lf := Character lf.
	CrLf := String with: Cr with: Lf.
	LineEndStrings := Dictionary new.
	LineEndStrings at: #cr put: (String with: Character cr).
	LineEndStrings at: #lf put: (String with: Character lf).
	LineEndStrings at: #crlf put: (String with: Character cr with: Character lf).
	LookAheadCount := 2048.
	Smalltalk addToStartUpList: self." "MultiByteFileStream is now there, we forward to it.
	self startUp."! !

!CrLfFileStream class methodsFor: 'initialization' stamp: 'SeanDeNigris 8/31/2011 14:20'!
new
	"I have been deprecated in favour of the equivalent MultiByteFileStream"

	self deprecated: 'This class is now obsolete, use MultiByteFileStream' on: '18 May 2011' in: 'Pharo1.3'.
	^ MultiByteFileStream new
		wantsLineEndConversion: true;
		yourself! !

!CrLfFileStream class methodsFor: 'deprecation' stamp: 'HenrikSperreJohansen 3/10/2010 00:55'!
substituteClass
	"The class which now provides my functionality"
	^MultiByteFileStream! !

!CrLfFileStream methodsFor: 'access' stamp: 'ar 1/20/98 16:16'!
ascii
	super ascii.
	self detectLineEndConvention! !

!CrLfFileStream methodsFor: 'access' stamp: 'stephaneducasse 2/4/2006 20:31'!
binary
	super binary.
	lineEndConvention := nil! !

!CrLfFileStream methodsFor: 'private' stamp: 'PeterHugossonMiller 9/3/2009 01:04'!
convertStringFromCr: aString 
	| inStream outStream |
	lineEndConvention ifNil: [^ aString].
	lineEndConvention == #cr ifTrue: [^ aString].
	lineEndConvention == #lf ifTrue: [^ aString copy replaceAll: Cr with: Lf].
	"lineEndConvention == #crlf"
	inStream := aString readStream.
	outStream := (String new: aString size) writeStream.
	[inStream atEnd]
		whileFalse: 
			[outStream nextPutAll: (inStream upTo: Cr).
			(inStream atEnd not or: [aString last = Cr])
				ifTrue: [outStream nextPutAll: CrLf]].
	^ outStream contents! !

!CrLfFileStream methodsFor: 'private' stamp: 'PeterHugossonMiller 9/3/2009 01:04'!
convertStringToCr: aString 
	| inStream outStream |
	lineEndConvention ifNil: [^ aString].
	lineEndConvention == #cr ifTrue: [^ aString].
	lineEndConvention == #lf ifTrue: [^ aString copy replaceAll: Lf with: Cr].
	"lineEndConvention == #crlf"
	inStream := aString readStream.
	outStream := (String new: aString size) writeStream.
	[inStream atEnd]
		whileFalse: 
			[outStream nextPutAll: (inStream upTo: Cr).
			(inStream atEnd not or: [aString last = Cr])
				ifTrue: 
					[outStream nextPut: Cr.
					inStream peek = Lf ifTrue: [inStream next]]].
	^ outStream contents! !

!CrLfFileStream methodsFor: 'access' stamp: 'stephaneducasse 2/4/2006 20:31'!
detectLineEndConvention
	"Detect the line end convention used in this stream. The result may be either #cr, #lf or #crlf."
	| char numRead pos |
	self isBinary ifTrue: [^ self error: 'Line end conventions are not used on binary streams'].
	lineEndConvention := LineEndDefault.
	"Default if nothing else found"
	numRead := 0.
	pos := super position.
	[super atEnd not and: [numRead < LookAheadCount]]
		whileTrue: 
			[char := super next.
			char = Lf
				ifTrue: 
					[super position: pos.
					^ lineEndConvention := #lf].
			char = Cr
				ifTrue: 
					[super peek = Lf
						ifTrue: [lineEndConvention := #crlf]
						ifFalse: [lineEndConvention := #cr].
					super position: pos.
					^ lineEndConvention].
			numRead := numRead + 1].
	super position: pos.
	^ lineEndConvention! !

!CrLfFileStream methodsFor: 'access' stamp: 'nk 9/5/2004 12:58'!
lineEndConvention

	^lineEndConvention! !

!CrLfFileStream methodsFor: 'access' stamp: 'stephaneducasse 2/4/2006 20:31'!
next
    | char secondChar |
    char := super next.
    self isBinary ifTrue: [^char].
    char == Cr ifTrue:
        [secondChar := super next.
        secondChar ifNotNil: [secondChar == Lf ifFalse: [self skip: -1]].
        ^Cr].
    char == Lf ifTrue: [^Cr].
    ^char! !

!CrLfFileStream methodsFor: 'access' stamp: 'stephaneducasse 2/4/2006 20:31'!
next: n

		| string peekChar |
		string := super next: n.
		string size = 0 ifTrue: [ ^string ].
		self isBinary ifTrue: [ ^string ].

		"if we just read a CR, and the next character is an LF, then skip the LF"
		( string last = Character cr ) ifTrue: [
			peekChar := super next.		"super peek doesn't work because it relies on #next"
			peekChar ~= Character lf ifTrue: [
				super position: (super position - 1) ]. ].
 
		string := string withSqueakLineEndings.

		string size = n ifTrue: [ ^string ].

		"string shrunk due to embedded crlfs; make up the difference"
		^string, (self next: n - string size)! !

!CrLfFileStream methodsFor: 'access' stamp: 'ar 1/20/98 16:18'!
nextPut: char 
	(lineEndConvention notNil and: [char = Cr])
		ifTrue: [super nextPutAll: (LineEndStrings at: lineEndConvention)]
		ifFalse: [super nextPut: char].
	^ char! !

!CrLfFileStream methodsFor: 'access' stamp: 'ar 1/20/98 16:18'!
nextPutAll: aString 
	super nextPutAll: (self convertStringFromCr: aString).
	^ aString
! !

!CrLfFileStream methodsFor: 'open/close' stamp: 'stephaneducasse 2/4/2006 20:31'!
open: aFileName forWrite: writeMode 
	"Open the receiver.  If writeMode is true, allow write, else access will be 
	read-only. "
	| result |
	result := super open: aFileName forWrite: writeMode.
	result ifNotNil: [self detectLineEndConvention].
	^ result! !

!CrLfFileStream methodsFor: 'access' stamp: 'stephaneducasse 2/4/2006 20:31'!
peek
	"Answer what would be returned if the message next were sent to the receiver. If the receiver is at the end, answer nil.  "
	| next pos |
	self atEnd ifTrue: [^ nil].
	pos := self position.
	next := self next.
	self position: pos.
	^ next! !

!CrLfFileStream methodsFor: 'access' stamp: 'PeterHugossonMiller 9/3/2009 01:05'!
upTo: aCharacter
	| newStream char |
	newStream := (String new: 100) writeStream.
	[(char := self next) isNil or: [char == aCharacter]]
		whileFalse: [newStream nextPut: char].
	^ newStream contents
! !

!CrLfFileStream methodsFor: 'access' stamp: 'nice 12/7/2009 08:26'!
upToAnyOf: delimiters do: aBlock

	^String new: 1000 streamContents: [ :stream |
		| ch |
		[ (ch := self next) == nil or: [ (delimiters includes: ch) and: [aBlock value: ch. true] ] ] 
			whileFalse: [ stream nextPut: ch ] ]! !

!CrLfFileStream methodsFor: 'access' stamp: 'ar 1/20/98 16:18'!
verbatim: aString 
	super verbatim: (self convertStringFromCr: aString).
	^ aString! !

Morph subclass: #TranslucentProgessMorph
	instanceVariableNames: 'opaqueBackgroundColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!TranslucentProgessMorph methodsFor: 'drawing' stamp: 'AlainPlantec 11/29/2009 21:36'!
drawOn: aCanvas

	| revealPercentage revealingStyle revealingColor revealingBounds revealToggle x baseColor revealTimes secondsRemaining stringToDraw where fontToUse innerBounds |
	
	innerBounds := bounds.
	opaqueBackgroundColor ifNotNil: [
		aCanvas 
			frameAndFillRectangle: bounds
			fillColor: opaqueBackgroundColor
			borderWidth: 8
			borderColor: Color blue.
		innerBounds := innerBounds insetBy: 8.
	].
	revealTimes := (self valueOfProperty: #revealTimes) ifNil: [^self].
	revealPercentage := (revealTimes first / revealTimes second) asFloat.
	revealingStyle := self revealingStyle.
	x := self valueOfProperty: #progressStageNumber ifAbsent: [1].
	baseColor := Color perform: (#(red blue green magenta cyan yellow) atPin: x).
	revealingColor := baseColor alpha: 0.2.
	revealingStyle = 3 ifTrue: [	"wrap and change color"
		revealPercentage > 1.0 ifTrue: [
			revealingColor := baseColor alpha: (0.2 + (revealingStyle / 10) min: 0.5).
		].
		revealPercentage := revealPercentage fractionPart.
	].
	revealingStyle = 2 ifTrue: [	"peg at 75 and blink"
		revealPercentage > 0.75 ifTrue: [
			revealToggle := self valueOfProperty: #revealToggle ifAbsent: [true].
			self setProperty: #revealToggle toValue: revealToggle not.
			revealToggle ifTrue: [revealingColor := baseColor alpha: 0.8.].
		].
		revealPercentage := revealPercentage min: 0.75.
	].
	revealingBounds := innerBounds withLeft: innerBounds left + (innerBounds width * revealPercentage) truncated.
	aCanvas 
		fillRectangle: revealingBounds
		color: revealingColor.
	secondsRemaining := (revealTimes second - revealTimes first / 1000) rounded.
	secondsRemaining > 0 ifTrue: [
		fontToUse := StrikeFont familyName: StandardFonts buttonFont familyName size: 24.
		stringToDraw := secondsRemaining printString.
		where := innerBounds corner - ((fontToUse widthOfString: stringToDraw) @ fontToUse height).
		aCanvas 
			drawString: stringToDraw 
			in: (where corner: innerBounds corner)
			font: fontToUse
			color: Color black.
		aCanvas
			drawString: stringToDraw 
			in: (where - (1@1) corner: innerBounds corner)
			font: fontToUse
			color: Color white.
	]. 


! !

!TranslucentProgessMorph methodsFor: 'wiw support' stamp: 'RAA 7/19/2000 18:52'!
morphicLayerNumber

	"helpful for insuring some morphs always appear in front of or behind others.
	smaller numbers are in front"

	^self valueOfProperty: #morphicLayerNumber ifAbsent: [12].

	"progress morphs are behind menus and balloons, but in front of most other stuff"! !

!TranslucentProgessMorph methodsFor: 'as yet unclassified' stamp: 'RAA 6/29/2000 11:35'!
opaqueBackgroundColor: aColor

	opaqueBackgroundColor := aColor! !

!TranslucentProgessMorph methodsFor: 'as yet unclassified' stamp: 'RAA 5/23/2000 11:19'!
revealingStyle

">>>>
	1 = original, no change after 100%
	2 = hold at last 25% and blink until done
	3 = wrap around from 100% back to 0 and go again. change color after first
<<<<"
	^3
! !

!Canvas methodsFor: '*deprecated13' stamp: 'ar 2/12/2000 18:10'!
image: aForm at: aPoint
	"Note: This protocol is deprecated. Use #paintImage: instead."
	self image: aForm
		at: aPoint
		sourceRect: aForm boundingBox
		rule: Form paint.
! !

!Canvas methodsFor: '*deprecated13' stamp: 'ar 2/12/2000 18:11'!
image: aForm at: aPoint rule: combinationRule
	"Note: This protocol is deprecated. Use one of the explicit image drawing messages (#paintImage, #drawImage) instead."
	self image: aForm
		at: aPoint
		sourceRect: aForm boundingBox
		rule: combinationRule.
! !

!Message methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
createStubMethod
	| argNames |
	self deprecated: 'Use DynamicMessageImplementor instead' on: '13 October 2010' in: 'Pharo1.2'.
	argNames := Set new.
	^ String
		streamContents: [ :s | 
			self selector keywords
				doWithIndex: [ :key :i | 
					| aOrAn argName arg argClassName |
					s nextPutAll: key.
					(key last = $: or: [ self selector isInfix ])
						ifTrue: [ 
							arg := self arguments at: i.
							argClassName := (arg isKindOf: Class)
								ifTrue: [ 'Class' ]
								ifFalse: [ arg class name ].
							aOrAn := argClassName first isVowel
								ifTrue: [ 'an' ]
								ifFalse: [ 'a' ].
							argName := aOrAn , argClassName.
							[ argNames includes: argName ] whileTrue: [ argName := argName , i asString ].
							argNames add: argName.
							s
								nextPutAll: ' ';
								nextPutAll: argName;
								space ] ].
			s
				cr;
				tab.
			s nextPutAll: 'self shouldBeImplemented' ]! !

!EditableTextMorph methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
enableTextChange
	self deprecated: 'The name is misleading, use #canChangeText instead ' on: '29 March 2011' in: 'Pharo1.3'.
	^ self canChangeText! !

WriteStream subclass: #TranscriptStream
	instanceVariableNames: ''
	classVariableNames: 'AccessSema'
	poolDictionaries: ''
	category: 'Deprecated13'!

!TranscriptStream commentStamp: '<historical>' prior: 0!
This class is a much simpler implementation of Transcript protocol that supports multiple views and very simple conversion to morphic.  Because it inherits from Stream, it is automatically compatible with code that is designe to write to streams.!

!TranscriptStream class methodsFor: 'toolbuilder' stamp: 'ar 2/11/2005 18:10'!
buildWith: aBuilder
	^self new buildWith: aBuilder! !

!TranscriptStream class methodsFor: 'as yet unclassified' stamp: 'di 5/8/1998 13:51'!
new
	^ self on: (String new: 1000)
"
INSTALLING:
TextCollector allInstances do:
	[:t | t breakDependents.
	t become: TranscriptStream new].

TESTING: (Execute this text in a workspace)
Do this first...
	tt := TranscriptStream new.
	tt openLabel: 'Transcript test 1'.
Then this will open a second view -- ooooh...
	tt openLabel: 'Transcript test 2'.
And finally make them do something...
	tt clear.
	[Sensor anyButtonPressed] whileFalse:
		[1 to: 20 do: [:i | tt print: (2 raisedTo: i-1); cr; endEntry]].
"! !

!TranscriptStream class methodsFor: 'as yet unclassified' stamp: 'simon.denier 6/11/2010 14:51'!
newTranscript: aTextCollector 
	"Store aTextCollector as the value of the system global Transcript."
	Smalltalk globals at: #Transcript put: aTextCollector! !

!TranscriptStream class methodsFor: 'window color' stamp: 'AlainPlantec 12/16/2009 22:10'!
patchworkUIThemeColor
	"Answer a default color for UI themes that make use of different colors for Browser, MessageList etc..."

	^ Color orange
! !

!TranscriptStream methodsFor: 'stream extensions' stamp: 'sma 3/15/2000 21:28'!
bs
	self position > 0 ifTrue: [^ self skip: -1].
	self changed: #bs! !

!TranscriptStream methodsFor: 'access' stamp: 'di 3/16/1999 21:38'!
characterLimit
	"Tell the views how much to retain on screen"
	^ 20000! !

!TranscriptStream methodsFor: 'stream extensions' stamp: 'gvc 7/6/2007 11:50'!
clear
	"Clear all characters and redisplay the view."
	
	self changed: #clearText.
	"clear the buffer entirely since it may become quite large and hang around"
	self on: (String new: 1000)! !

!TranscriptStream methodsFor: 'stream extensions' stamp: 'Noury 8/3/2008 20:04'!
close
	super close.
	self flush ! !

!TranscriptStream methodsFor: 'stream extensions' stamp: 'mir 1/11/2000 11:41'!
endEntry
	"Display all the characters since the last endEntry, and reset the stream"
	self semaphore critical:[
		self changed: #appendEntry.
		self reset.
	].! !

!TranscriptStream methodsFor: 'stream extensions' stamp: 'md 8/2/2005 23:09'!
flush
	self endEntry
! !

!TranscriptStream methodsFor: 'printing' stamp: 'Noury 8/26/2008 08:53'!
isSelfEvaluating
	self == Transcript ifTrue: [^true].
	^super isSelfEvaluating! !

!TranscriptStream methodsFor: 'stream extensions' stamp: 'di 5/8/1998 12:35'!
pastEndPut: anObject
	"If the stream reaches its limit, just output the contents and reset."
	self endEntry.
	^ self nextPut: anObject! !

!TranscriptStream methodsFor: 'model protocol' stamp: 'di 5/29/1998 17:13'!
perform: selector orSendTo: otherTarget
	"Selector was just chosen from a menu by a user.  If can respond, then
perform it on myself. If not, send it to otherTarget, presumably the
editPane from which the menu was invoked."

	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!TranscriptStream methodsFor: 'printing' stamp: 'Noury 7/19/2008 00:27'!
printOn: aStream
	self == Transcript ifFalse: [^super printOn: aStream].
	aStream nextPutAll: 'Transcript'! !

!TranscriptStream methodsFor: 'model protocol' stamp: 'di 5/3/1999 22:49'!
release

	self dependents do:
		[:view | (view isMorph and: [view isInWorld not])
					ifTrue: [self removeDependent: view]]! !

!TranscriptStream methodsFor: 'private' stamp: 'mir 1/11/2000 11:41'!
semaphore
	^AccessSema ifNil:[AccessSema := Semaphore forMutualExclusion]! !

!TranscriptStream methodsFor: 'stream extensions' stamp: 'sma 2/26/2000 19:31'!
show: anObject  "TextCollector compatibility"
	self nextPutAll: anObject asString; endEntry! !

!TranscriptStream methodsFor: 'model protocol' stamp: 'sw 3/2/2001 10:18'!
step
	"Objects that may be models of SystemWindows need to respond to this, albeit vacuously"! !

HierarchicalURI subclass: #DirectoryURI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

AppRegistry subclass: #ToolSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!ToolSet commentStamp: 'ar 7/15/2005 17:58' prior: 0!
ToolSet defines an interface that clients can use to request programmer facilities such as browsers, inspectors, debuggers, message sets etc.!

!ToolSet class methodsFor: 'inspecting' stamp: 'ar 7/17/2005 10:54'!
basicInspect: anObject
	"Open an inspector on the given object. The tool set must know which inspector type to use for which object - the object cannot possibly know what kind of inspectors the toolset provides."
	self default ifNil:[^self inform: 'Cannot inspect -- no Inspector present'].
	^self default basicInspect: anObject! !

!ToolSet class methodsFor: 'browsing' stamp: 'ar 7/17/2005 10:54'!
browse: aClass selector: aSelector
	"Open a browser"
	self default ifNil:[^self inform: 'Cannot open Browser'].
	^self default browse: aClass selector: aSelector! !

!ToolSet class methodsFor: 'browsing' stamp: 'ar 7/17/2005 10:54'!
browseChangeSetsWithClass: aClass selector: aSelector
	"Browse all the change sets with the given class/selector"
	self default ifNil:[^self inform: 'No ChangeSorter present'].
	^self default browseChangeSetsWithClass: aClass selector: aSelector! !

!ToolSet class methodsFor: 'browsing' stamp: 'ar 7/17/2005 11:14'!
browseHierarchy: aClass selector: aSelector
	"Open a browser"
	self default ifNil:[^self inform: 'No browser present'].
	^self default browseHierarchy: aClass selector: aSelector! !

!ToolSet class methodsFor: 'browsing' stamp: 'davidroethlisberger 2/11/2009 12:06'!
browseImplementorsOf: aSymbol name: titleString autoSelect: autoSelectString
	"Open a implementors browser"
	self default ifNil:[^self inform: 'Cannot open ImplementorsBrowser'].
	^self default browseImplementorsOf: aSymbol name: titleString autoSelect: autoSelectString! !

!ToolSet class methodsFor: 'browsing' stamp: 'ar 7/17/2005 11:12'!
browseMessageNames: aString
	"Open a MessageNames browser"
	self default ifNil:[^self inform: 'No MessageNames present'].
	^self default browseMessageNames: aString! !

!ToolSet class methodsFor: 'browsing' stamp: 'ar 7/17/2005 11:13'!
browseMessageSet: messageList name: title autoSelect: autoSelectString
	"Open a message set browser"
	self default ifNil:[^self inform: 'Cannot open MessageSet'].
	^self default browseMessageSet: messageList name: title autoSelect: autoSelectString! !

!ToolSet class methodsFor: 'browsing' stamp: 'davidroethlisberger 2/11/2009 12:06'!
browseSendersOf: aSymbol name: titleString autoSelect: autoSelectString
	"Open a senders browser"
	self default ifNil:[^self inform: 'Cannot open SendersBrowser'].
	^self default browseSendersOf: aSymbol name: titleString autoSelect: autoSelectString! !

!ToolSet class methodsFor: 'browsing' stamp: 'ar 7/17/2005 10:54'!
browseVersionsOf: aClass selector: aSelector
	"Open a browser"
	self default ifNil:[^self inform: 'Cannot open Browser'].
	^self default browseVersionsOf: aClass selector: aSelector! !

!ToolSet class methodsFor: 'completion' stamp: 'damiencassou 7/29/2009 16:24'!
codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: evt
	self default ifNil: [aBlock value. ^ self].
	self default codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: evt! !

!ToolSet class methodsFor: 'debugging' stamp: 'ar 7/17/2005 10:37'!
debug: aProcess context: aContext label: aString contents: contents fullView: aBool
	"Open a debugger on the given process and context."
	self default ifNil:[
		(self confirm: 'Debugger request -- proceed?')
			ifFalse:[Processor terminateActive].
		^self].
	^self default debug: aProcess context: aContext label: aString contents: contents fullView: aBool! !

!ToolSet class methodsFor: 'debugging' stamp: 'MarianoMartinezPeck 1/19/2010 19:18'!
debug: aGuineaPig controller: aController context: aContext

	^self default debug: aGuineaPig controller: aController context: aContext
! !

!ToolSet class methodsFor: 'debugging' stamp: 'MikeRoberts 4/1/2009 21:32'!
debugContext: aContext

	self default ifNil:[
		(self confirm: 'Debugger request -- proceed?')
			ifFalse:[Processor terminateActive].
		^self].
	^self default debugContext: aContext! !

!ToolSet class methodsFor: 'debugging' stamp: 'ar 7/17/2005 10:37'!
debugContext: aContext label: aString contents: contents
	"Open a debugger on the given context."
	self default ifNil:[
		(self confirm: 'Debugger request -- proceed?')
			ifFalse:[Processor terminateActive].
		^self].
	^self default debugContext: aContext label: aString contents: contents! !

!ToolSet class methodsFor: 'debugging' stamp: 'IgorStasenko 1/21/2011 19:07'!
debugError: anError
	"Handle an otherwise unhandled error"
	self default ifNil:[ | ctx |
		Smalltalk 
			logError: anError description 
			inContext: (ctx := anError signalerContext).
		self inform: (anError description, String cr, ctx shortStack).
		^anError return].
	^self default debugError: anError! !

!ToolSet class methodsFor: 'debugging' stamp: 'ar 9/27/2005 19:12'!
debugSyntaxError: anError
	"Handle a syntax error"
	self default ifNil:[^self debugError: anError]. "handle as usual error"
	^self default debugSyntaxError: anError! !

!ToolSet class methodsFor: 'inspecting' stamp: 'al 11/28/2005 20:32'!
explore: anObject
	"Open an explorer on the given object."
	self default ifNil:[^self inform: 'Cannot explore - no ToolSet present'].
	^self default explore: anObject! !

!ToolSet class methodsFor: 'inspecting' stamp: 'ar 7/17/2005 10:55'!
inspect: anObject
	"Open an inspector on the given object. The tool set must know which inspector type to use for which object - the object cannot possibly know what kind of inspectors the toolset provides."
	self default ifNil:[^self inform: 'Cannot inspect - no ToolSet present'].
	^self default inspect: anObject! !

!ToolSet class methodsFor: 'inspecting' stamp: 'ar 7/17/2005 10:55'!
inspect: anObject label: aString
	"Open an inspector on the given object. The tool set must know which inspector type to use for which object - the object cannot possibly know what kind of inspectors the toolset provides."
	self default ifNil:[^self inform: 'Cannot inspect - no ToolSet present'].
	^self default inspect: anObject label: aString! !

!ToolSet class methodsFor: 'inspecting' stamp: 'ar 7/17/2005 10:43'!
inspectorClassOf: anObject
	"Answer the inspector class for the given object. The tool set must know which inspector type to use for which object - the object cannot possibly know what kind of inspectors the toolset provides."
	self default ifNil:[^nil].
	^self default inspectorClassOf: anObject! !

!ToolSet class methodsFor: 'debugging' stamp: 'ar 7/17/2005 10:37'!
interrupt: aProcess label: aString
	"Open a debugger on the given process and context."
	self default ifNil:[
		(self confirm: 'Debugger request -- proceed?')
			ifFalse:[aProcess terminate].
		^self].
	^self default interrupt: aProcess label: aString! !

!ToolSet class methodsFor: 'menu' stamp: 'ar 7/17/2005 13:19'!
menuItems
	"Answer the menu items available for this tool set"
	self default ifNil:[^#()].
	^self default menuItems! !

!ToolSet class methodsFor: 'browsing' stamp: 'ar 7/17/2005 10:44'!
openChangedMessageSet: aChangeSet
	"Open a ChangedMessageSet for aChangeSet"
	self default ifNil:[^self inform: 'Cannot open MessageSet'].
	^self default openChangedMessageSet: aChangeSet! !

!ToolSet class methodsFor: 'browsing' stamp: 'ar 7/17/2005 10:44'!
openClassListBrowser: anArray title: aString
	"Open a class list browser"
	self default ifNil:[^self inform: 'Cannot open ClassListBrowser'].
	^self default openClassListBrowser: anArray title: aString! !

!ToolSet class methodsFor: 'menu' stamp: 'DamienCassou 5/14/2011 16:59'!
openTranscript
	^ self default openTranscript.! !

!ToolSet class methodsFor: 'menu' stamp: 'DamienCassou 4/12/2011 10:48'!
openWorkspace
	^ self default openWorkspace! !

PluggableListMorph subclass: #PluggableListMorphOfMany
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!PluggableListMorphOfMany commentStamp: '<historical>' prior: 0!
A variant of its superclass that allows multiple items to be selected simultaneously.  There is still a distinguished element which is selected, but each other element in the list may be flagged on or off.

DEPRECATED!

!PluggableListMorphOfMany methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/1/2011 11:50'!
defaultMultipleSelectionValue

	^ true! !

PluggableListMorphOfMany subclass: #PluggableMorphListMorphOfMany
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!PluggableMorphListMorphOfMany commentStamp: '<historical>' prior: 0!
DEPRECATED!

PluggableMorphListMorphOfMany subclass: #PluggableIconListMorphOfMany
	instanceVariableNames: 'getIconSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!PluggableIconListMorphOfMany commentStamp: '<historical>' prior: 0!
DEPRECATED!

!PluggableIconListMorphOfMany methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/30/2011 10:46'!
getIconSelector
	"Answer the value of getIconSelector"

	^ getIconSelector! !

!PluggableIconListMorphOfMany methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/30/2011 10:46'!
getIconSelector: anObject
	"Set the value of getIconSelector"

	getIconSelector := anObject! !

!PluggableIconListMorphOfMany methodsFor: 'model access' stamp: 'BenjaminVanRyseghem 3/30/2011 10:46'!
getList
	"Answer the list to be displayed.  Caches the returned list in the 'list' ivar"

	getListSelector isNil ifTrue: [^#()].
	list := model perform: getListSelector.
	list isNil ifTrue: [^ #()].
	list := list collect: [ :item | self itemMorphFor: item].
	^list! !

!PluggableIconListMorphOfMany methodsFor: 'model access' stamp: 'BenjaminVanRyseghem 3/30/2011 10:46'!
getListItem: index
	"get the index-th item in the displayed list"

	getListElementSelector ifNotNil: [
		^self itemMorphFor: (model perform: getListElementSelector with: index)].
	(list notNil and: [list size >= index]) ifTrue: [ ^list at: index ].
	^ self wrapItem: (self getList at: index)! !

!PluggableIconListMorphOfMany methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/31/2011 15:35'!
itemMorphFor: anObject
	"Answer a morph for the object with the appropriate icon."

	|item icon|
	item := RectangleMorph new
		changeTableLayout;
		listDirection: #leftToRight;
		cellPositioning: #center;
		cellInset: 2;
		borderWidth: 0;
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		extent: 20@16.
	icon := self getIconSelector ifNotNil: [self model perform: self getIconSelector withEnoughArguments: {anObject}].
	icon ifNotNil: [
		item addMorphBack: icon asMorph].
	item addMorphBack: (StringMorph contents: (self wrapItem: anObject)).
	^item! !

!PluggableMorphListMorphOfMany methodsFor: 'event handling' stamp: 'BenjaminVanRyseghem 5/9/2011 17:17'!
basicKeyPressed: aChar 
	| oldSelection nextSelection max milliSeconds nextSelectionList nextSelectionText s|
	nextSelection := oldSelection := self getCurrentSelectionIndex.
	
	self searchedElement: nil.
	
	max := self maximumSelection.
	milliSeconds := Time millisecondClockValue.
	milliSeconds - lastKeystrokeTime > 500 ifTrue: ["just use the one current character for selecting"
		lastKeystrokes := ''].
	lastKeystrokes := lastKeystrokes , aChar asLowercase asString.
	lastKeystrokeTime := milliSeconds.
	nextSelectionList := OrderedCollection newFrom: (list copyFrom: oldSelection + 1 to: max).
	nextSelectionList addAll: (list copyFrom: 1 to: oldSelection).
	"Get rid of blanks and style used in some lists"
	nextSelectionText := nextSelectionList detect: [:a |
		s := a userString ifNil: [(a submorphs collect: [:m | m userString]) detect: [:us | us notNil] ifNone: ['']].
		s withBlanksTrimmed asLowercase beginsWith: lastKeystrokes]
				ifNone: [^ self flash"match not found"].
	model okToChange ifFalse: [^ self].
	nextSelection := list findFirst: [:a |
		s := a userString ifNil: [(a submorphs collect: [:m | m userString]) detect: [:us | us notNil] ifNone: ['']].
		a == nextSelectionText].
	"No change if model is locked"
	oldSelection == nextSelection ifTrue: [^ self flash].
	
	self searchedElement: nextSelection.! !

!PluggableMorphListMorphOfMany methodsFor: 'geometry' stamp: 'BenjaminVanRyseghem 3/30/2011 10:45'!
extent: newExtent
	"Change listMorph's bounds to the new width. It is either the size
	of the widest list item, or the size of self, whatever is bigger"

	super extent: newExtent.
	self listMorph width: (self innerBounds width max: listMorph hUnadjustedScrollRange). 
! !

!PluggableMorphListMorphOfMany methodsFor: 'model access' stamp: 'BenjaminVanRyseghem 3/30/2011 10:45'!
getList
	"Answer the list to be displayed.  Caches the returned list in the 'list' ivar"

	getListSelector isNil ifTrue: [^#()].
	list := model perform: getListSelector.
	list isNil ifTrue: [^ #()].
	^list! !

!PluggableMorphListMorphOfMany methodsFor: 'model access' stamp: 'BenjaminVanRyseghem 3/30/2011 10:45'!
getListItem: index
	"get the index-th item in the displayed list"

	getListElementSelector ifNotNil: [
		^model perform: getListElementSelector with: index].
	(list notNil and: [list size >= index]) ifTrue: [ ^list at: index ].
	^self getList at: index! !

!PluggableMorphListMorphOfMany methodsFor: 'scrolling' stamp: 'BenjaminVanRyseghem 3/30/2011 10:45'!
hExtraScrollRange
	"Return the amount of extra blank space to include to the right of the scroll content."

	^12! !

!PluggableMorphListMorphOfMany methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/30/2011 10:45'!
listMorphClass
	"Answer the class to use for the list morph."

	^LazyMorphListMorph! !

!TextMorph methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
enableTextChange
	self deprecated: 'The name is misleading, use #canChangeText instead ' on: '29 March 2011' in: 'Pharo1.3'.
	^ self canChangeText! !

!Process methodsFor: '*deprecated13' stamp: 'MarcusDenker 3/21/2011 16:35'!
errorHandler
	self deprecated: 'Apparently this is not used' on:  '21 March 2011' in: 'Pharo1.3'.
    ^ errorHandler! !

!Process methodsFor: '*deprecated13' stamp: 'MarcusDenker 3/21/2011 16:36'!
errorHandler: aBlock
	self deprecated: 'Apparently this is not used' on:  '21 March 2011' in: 'Pharo1.3'.
	errorHandler := aBlock! !

DisplayObject subclass: #DisplayText
	instanceVariableNames: 'text textStyle offset form foreColor backColor'
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'Deprecated13'!

!DisplayText commentStamp: '<historical>' prior: 0!
I represent Text whose emphasis changes are mapped to a set of fonts. My instances have an offset used in determining screen placement for displaying. They get used two different ways in the system. In the user interface, they mainly hold onto some text which is viewed by some form of ParagraphEditor. However, as a DisplayObject, they may need to display efficiently, so my instances have a cache for the bits.!

!DisplayText class methodsFor: 'examples' stamp: 'tk 11/28/2001 16:03'!
example
	"Continually prints two lines of text wherever you point with the cursor.  Terminate by pressing any button on the
	mouse."
	| tx |
	tx := 'this is a line of characters and
this is the second line.' asDisplayText.
	tx foregroundColor: Color black backgroundColor: Color transparent.
	tx := tx alignedTo: #center.
	[Sensor anyButtonPressed]
		whileFalse:
			[tx displayOn: Display at: Sensor cursorPoint]

	"DisplayText example."! !

!DisplayText class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
text: aText 
	"Answer an instance of me such that the text displayed is aText 
	according to the system's default text style."

	^self new
		setText: aText
		textStyle: (TextSharedInformation at: #DefaultTextStyle) copy
		offset: 0 @ 0! !

!DisplayText class methodsFor: 'instance creation' stamp: ''!
text: aText textStyle: aTextStyle 
	"Answer an instance of me such that the text displayed is aText 
	according to the style specified by aTextStyle."

	^self new
		setText: aText
		textStyle: aTextStyle
		offset: 0 @ 0! !

!DisplayText class methodsFor: 'instance creation' stamp: ''!
text: aText textStyle: aTextStyle offset: aPoint 
	"Answer an instance of me such that the text displayed is aText 
	according to the style specified by aTextStyle. The display of the 
	information should be offset by the amount given as the argument, 
	aPoint."

	^self new
		setText: aText
		textStyle: aTextStyle
		offset: aPoint! !

!DisplayText methodsFor: 'accessing' stamp: ''!
alignedTo: alignPointSelector
	"Return a copy with offset according to alignPointSelector which is one of...
	#(topLeft, topCenter, topRight, leftCenter, center, etc)"
	| boundingBox |
	boundingBox := 0@0 corner: self form extent.
	^ self shallowCopy offset: (0@0) - (boundingBox perform: alignPointSelector)! !

!DisplayText methodsFor: '*deprecated13' stamp: 'MarcusDenker 3/26/2011 17:13'!
asParagraph
	"Answer a Paragraph whose text and style are identical to that of the 
	receiver."
	| para |
	self deprecated: 'ST80 lefover' on:  '21 March 2011' in: 'Pharo1.3'.
	para := Paragraph withText: text style: textStyle.
	para foregroundColor: foreColor backgroundColor: backColor.
	backColor isTransparent ifTrue: [para rule: Form paint].
	^ para! !

!DisplayText methodsFor: 'color' stamp: ''!
backgroundColor
	backColor == nil ifTrue: [^ Color transparent].
	^ backColor! !

!DisplayText methodsFor: 'display box access' stamp: ''!
boundingBox 
	"Refer to the comment in DisplayObject|boundingBox."

	^self form boundingBox! !

!DisplayText methodsFor: 'private' stamp: 'SeanDeNigris 8/31/2011 14:20'!
composeForm
	self deprecated: 'Pharo1.3: this class is no longer used' on: '30 March 2011' in: 'Pharo1.3'.	"form := UIManager default composeFormFor: self."
	^ form! !

!DisplayText methodsFor: 'display box access' stamp: ''!
computeBoundingBox 
	"Compute minimum enclosing rectangle around characters."

	| character font width carriageReturn lineWidth lineHeight |
	carriageReturn := Character cr.
	width := lineWidth := 0.
	font := textStyle defaultFont.
	lineHeight := textStyle lineGrid.
	1 to: text size do: 
		[:i | 
		character := text at: i.
		character = carriageReturn
		  ifTrue: 
			[lineWidth := lineWidth max: width.
			lineHeight := lineHeight + textStyle lineGrid.
			width := 0]
		  ifFalse: [width := width + (font widthOf: character)]].
	lineWidth := lineWidth max: width.
	^offset extent: lineWidth @ lineHeight! !

!DisplayText methodsFor: 'displaying' stamp: 'yo 6/23/2003 20:05'!
displayOn: aDisplayMedium at: aDisplayPoint clippingBox: clipRectangle rule: ruleInteger fillColor: aForm
	"For TT font, rule 34 is used if possible."
	"Refer to the comment in 
	DisplayObject|displayOn:at:clippingBox:rule:mask:."

	| form1 rule |
	form1 := self form.
	rule := (ruleInteger = Form over and: [backColor isTransparent])
				ifTrue: [form1 depth = 32 ifTrue: [rule := 34] ifFalse: [Form paint]]
				ifFalse: [ruleInteger].
	form1 depth = 32 ifTrue: [rule := 34].
	form1
		displayOn: aDisplayMedium
		at: aDisplayPoint + offset
		clippingBox: clipRectangle
		rule: rule
		fillColor: aForm! !

!DisplayText methodsFor: 'displaying' stamp: ''!
displayOn: aDisplayMedium transformation: displayTransformation clippingBox: clipRectangle align: alignmentPoint with: relativePoint rule: ruleInteger fillColor: aForm 
	"Refer to the comment in 
	DisplayObject|displayOn:transformation:clippingBox:align:with:rule:mask:."

	| absolutePoint |
	absolutePoint := displayTransformation applyTo: relativePoint.
	absolutePoint := absolutePoint x asInteger @ absolutePoint y asInteger.
	self displayOn: aDisplayMedium
		at: absolutePoint - alignmentPoint
		clippingBox: clipRectangle
		rule: ruleInteger
		fillColor: aForm! !

!DisplayText methodsFor: 'displaying' stamp: ''!
displayOnPort: aPort at: location
	self form displayOnPort: aPort at: location + offset! !

!DisplayText methodsFor: 'accessing' stamp: ''!
fontsUsed
	"Return a list of all fonts used currently in this text.  8/19/96 tk"

	^ text runs values asSet collect: [:each | textStyle fontAt: each]! !

!DisplayText methodsFor: 'color' stamp: ''!
foregroundColor
	foreColor == nil ifTrue: [^ Color black].
	^ foreColor! !

!DisplayText methodsFor: 'color' stamp: ''!
foregroundColor: cf backgroundColor: cb
	foreColor := cf.
	backColor := cb! !

!DisplayText methodsFor: 'accessing' stamp: ''!
form 
	"Answer the form into which the receiver's display bits are cached."

	form == nil ifTrue: [self composeForm].
	^form! !

!DisplayText methodsFor: 'accessing' stamp: 'MarcusDenker 9/30/2009 11:53'!
form: aForm
	form := aForm! !

!DisplayText methodsFor: 'accessing' stamp: ''!
lineGrid
	"Answer the relative space between lines of the receiver's text."

	^textStyle lineGrid! !

!DisplayText methodsFor: 'accessing' stamp: ''!
numberOfLines 
	"Answer the number of lines of text in the receiver."

	^self height // text lineGrid! !

!DisplayText methodsFor: 'accessing' stamp: ''!
offset 
	"Refer to the comment in DisplayObject|offset."

	^offset! !

!DisplayText methodsFor: 'accessing' stamp: ''!
offset: aPoint 
	"Refer to the comment in DisplayObject|offset:."

	offset := aPoint! !

!DisplayText methodsFor: 'private' stamp: ''!
setText: aText textStyle: aTextStyle offset: aPoint

	text := aText.
	textStyle := aTextStyle.
	offset := aPoint.
	form := nil! !

!DisplayText methodsFor: 'accessing' stamp: ''!
string
	"Answer the string of the characters displayed by the receiver."

	^text string! !

!DisplayText methodsFor: 'accessing' stamp: ''!
text 
	"Answer the text displayed by the receiver."

	^text! !

!DisplayText methodsFor: 'accessing' stamp: ''!
text: aText 
	"Set the receiver to display the argument, aText."
	
	text := aText.
	form := nil.
	self changed.
	! !

!DisplayText methodsFor: 'accessing' stamp: ''!
textStyle 
	"Answer the style by which the receiver displays its text."

	^textStyle! !

!DisplayText methodsFor: 'accessing' stamp: ''!
textStyle: aTextStyle 
	"Set the style by which the receiver should display its text."

	textStyle := aTextStyle.
	form := nil.
	self changed.
	! !

DisplayObject subclass: #Paragraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'Deprecated13'!

!Paragraph commentStamp: '<historical>' prior: 0!
I represent displayable text that has been decoraged with margin alignment, line leading, and tab settings.!

!TextConstants class methodsFor: '*deprecated13' stamp: 'BenjaminVanRyseghem 3/18/2011 11:22'!
at: aSymbol put: anObject
	
	^self
	         deprecated: 'TextConstants is not a place to store your stuff. You can use TextConstants TextSharedInformation for that'
	         on: '18 March 2011'
	         in: 'Pharo1.3'! !

!ProtoObject methodsFor: '*deprecated13' stamp: 'MarcusDenker 4/27/2011 19:58'!
executeMethod: compiledMethod
	"Execute compiledMethod against the receiver with no args"

	self deprecated: 'use #withArgs:executeMethod:' on: '2011-04-27' in: 'Pharo1.3'.
	^ self withArgs: #() executeMethod: compiledMethod! !

!ProtoObject methodsFor: '*deprecated13' stamp: 'MarcusDenker 4/27/2011 19:58'!
with: arg1 executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and arg1"

	self deprecated: 'use #withArgs:executeMethod:' on: '2011-04-27' in: 'Pharo1.3'.
	^ self withArgs: {arg1} executeMethod: compiledMethod! !

!ProtoObject methodsFor: '*deprecated13' stamp: 'MarcusDenker 4/27/2011 19:58'!
with: arg1 with: arg2 executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and arg1 & arg2"

	self deprecated: 'use #withArgs:executeMethod:' on: '2011-04-27' in: 'Pharo1.3'.
	^ self withArgs: {arg1. arg2} executeMethod: compiledMethod! !

!ProtoObject methodsFor: '*deprecated13' stamp: 'MarcusDenker 4/27/2011 19:58'!
with: arg1 with: arg2 with: arg3 executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and arg1, arg2, & arg3"

	self deprecated: 'use #withArgs:executeMethod:' on: '2011-04-27' in: 'Pharo1.3'.
	^ self withArgs: {arg1. arg2. arg3} executeMethod: compiledMethod! !

!ProtoObject methodsFor: '*deprecated13' stamp: 'MarcusDenker 4/27/2011 19:58'!
with: arg1 with: arg2 with: arg3 with: arg4 executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and arg1, arg2, arg3, & arg4"

	self deprecated: 'use #withArgs:executeMethod:' on: '2011-04-27' in: 'Pharo1.3'.
	^ self withArgs: {arg1. arg2. arg3. arg4} executeMethod: compiledMethod! !

CharacterScanner subclass: #DisplayScanner
	instanceVariableNames: 'bitBlt lineY runX foregroundColor backgroundColor fillBlt lineHeight paragraphColor morphicOffset ignoreColorChanges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!DisplayScanner commentStamp: '<historical>' prior: 0!
My instances are used to scan text and display it on the screen or in a hidden form.!

!DisplayScanner class methodsFor: 'queries' stamp: 'ar 5/17/2000 17:39'!
defaultFont
	^ TextStyle defaultFont! !

!DisplayScanner methodsFor: 'stop conditions' stamp: 'nice 11/16/2009 15:02'!
cr
	"When a carriage return is encountered, simply increment the pointer 
	into the paragraph."

	pendingKernX := 0.
	(lastIndex < text size and: [(text at: lastIndex) = CR and: [(text at: lastIndex+1) = Character lf]])
		ifTrue: [lastIndex := lastIndex + 2]
		ifFalse: [lastIndex := lastIndex + 1].
	^false! !

!DisplayScanner methodsFor: 'stop conditions' stamp: 'di 9/3/2000 16:24'!
crossedX
	"This condition will sometimes be reached 'legally' during display, when, 
	for instance the space that caused the line to wrap actually extends over 
	the right boundary. This character is allowed to display, even though it 
	is technically outside or straddling the clipping ectangle since it is in 
	the normal case not visible and is in any case appropriately clipped by 
	the scanner."

	^ true ! !

!DisplayScanner methodsFor: 'scanning' stamp: 'nice 3/16/2010 19:34'!
displayLine: textLine offset: offset leftInRun: leftInRun 
	"The call on the primitive (scanCharactersFrom:to:in:rightX:) will be interrupted according to an array of stop conditions passed to the scanner at which time the code to handle the stop condition is run and the call on the primitive continued until a stop condition returns true (which means the line has terminated).  leftInRun is the # of characters left to scan in the current run; when 0, it is time to call setStopConditions."
	| stopCondition nowLeftInRun startIndex string lastPos |
	line := textLine.
	morphicOffset := offset.
	lineY := line top + offset y.
	lineHeight := line lineHeight.
	rightMargin := line rightMargin + offset x.
	lastIndex := line first.
	leftInRun <= 0 ifTrue: [ self setStopConditions ].
	leftMargin := (line leftMarginForAlignment: alignment) + offset x.
	destX := runX := leftMargin.
	fillBlt == nil ifFalse: 
		[ "Not right"
		fillBlt
			destX: line left
				destY: lineY
				width: line width left
				height: lineHeight;
			copyBits ].
	lastIndex := line first.
	leftInRun <= 0 
		ifTrue: [ nowLeftInRun := text runLengthFor: lastIndex ]
		ifFalse: [ nowLeftInRun := leftInRun ].
	destY := lineY + line baseline - font ascent.
	runStopIndex := lastIndex + (nowLeftInRun - 1) min: line last.
	spaceCount := 0.
	string := text string.
	[
		startIndex := lastIndex.
		lastPos := destX @ destY.
		stopCondition := self 
			scanCharactersFrom: lastIndex
			to: runStopIndex
			in: string
			rightX: rightMargin
			stopConditions: stopConditions
			kern: kern.
		lastIndex >= startIndex ifTrue: 
			[ font 
				displayString: string
				on: bitBlt
				from: startIndex
				to: lastIndex
				at: lastPos
				kern: kern ].
		"see setStopConditions for stopping conditions for displaying."
		(self perform: stopCondition)
			or: [lastIndex > runStopIndex]
	] whileFalse.
	^ runStopIndex - lastIndex	"Number of characters remaining in the current run"! !

!DisplayScanner methodsFor: 'stop conditions' stamp: 'lr 7/4/2009 10:42'!
endOfRun
	"The end of a run in the display case either means that there is actually 
	a change in the style (run code) to be associated with the string or the 
	end of this line has been reached."
	| runLength |
	lastIndex = line last ifTrue: [ ^ true ].
	runX := destX.
	runLength := text runLengthFor: (lastIndex := lastIndex + 1).
	runStopIndex := lastIndex + (runLength - 1) min: line last.
	self setStopConditions.
	^ false! !

!DisplayScanner methodsFor: 'stop conditions' stamp: 'tween 4/6/2007 12:51'!
paddedSpace
	"Each space is a stop condition when the alignment is right justified. 
	Padding must be added to the base width of the space according to 
	which space in the line this space is and according to the amount of 
	space that remained at the end of the line when it was composed."

	spaceCount := spaceCount + 1.
	destX := destX + spaceWidth + (line justifiedPadFor: spaceCount font: font).
	lastIndex := lastIndex + 1.
	^ false! !

!DisplayScanner methodsFor: 'scanning' stamp: 'lr 7/4/2009 10:42'!
placeEmbeddedObject: anchoredMorph 
	anchoredMorph relativeTextAnchorPosition ifNotNil: 
		[ anchoredMorph position: anchoredMorph relativeTextAnchorPosition + (anchoredMorph owner textBounds origin x @ 0) - (0 @ morphicOffset y) + (0 @ lineY).
		^ true ].
	(super placeEmbeddedObject: anchoredMorph) ifFalse: [ ^ false ].
	anchoredMorph isMorph 
		ifTrue: 
			[ anchoredMorph position: (destX - anchoredMorph width) @ lineY - morphicOffset ]
		ifFalse: 
			[ destY := lineY.
			runX := destX.
			anchoredMorph 
				displayOn: bitBlt destForm
				at: (destX - anchoredMorph width) @ destY
				clippingBox: bitBlt clipRect ].
	^ true! !

!DisplayScanner methodsFor: 'stop conditions' stamp: 'lr 7/4/2009 10:42'!
plainTab
	| oldX |
	oldX := destX.
	super plainTab.
	fillBlt == nil ifFalse: 
		[ fillBlt
			destX: oldX
				destY: destY
				width: destX - oldX
				height: font height;
			copyBits ]! !

!DisplayScanner methodsFor: 'private' stamp: 'ar 5/17/2000 19:26'!
setDestForm: df
	bitBlt setDestForm: df.! !

!DisplayScanner methodsFor: 'private' stamp: 'lr 7/4/2009 10:42'!
setFont
	foregroundColor := paragraphColor.
	super setFont.	"Sets font and emphasis bits, and maybe foregroundColor"
	font 
		installOn: bitBlt
		foregroundColor: foregroundColor
		backgroundColor: Color transparent.
	text ifNotNil: [ destY := lineY + line baseline - font ascent ]! !

!DisplayScanner methodsFor: 'private' stamp: 'lr 7/4/2009 10:42'!
setPort: aBitBlt 
	"Install the BitBlt to use"
	bitBlt := aBitBlt.
	bitBlt
		sourceX: 0;
		width: 0.	"Init BitBlt so that the first call to a primitive will not fail"
	bitBlt sourceForm: nil	"Make sure font installation won't be confused"! !

!DisplayScanner methodsFor: 'stop conditions' stamp: 'yo 10/4/2002 20:43'!
setStopConditions
	"Set the font and the stop conditions for the current run."
	
	self setFont.
	self setConditionArray: (alignment = Justified ifTrue: [#paddedSpace]).

"
	alignment = Justified ifTrue: [
		stopConditions == DefaultStopConditions 
			ifTrue:[stopConditions := stopConditions copy].
		stopConditions at: Space asciiValue + 1 put: #paddedSpace]
"! !

!DisplayScanner methodsFor: 'stop conditions' stamp: 'lr 7/4/2009 10:42'!
tab
	self plainTab.
	lastIndex := lastIndex + 1.
	^ false! !

!DisplayScanner methodsFor: 'private' stamp: 'lr 7/4/2009 10:42'!
text: t textStyle: ts foreground: foreColor background: backColor fillBlt: blt ignoreColorChanges: shadowMode 
	text := t.
	textStyle := ts.
	foregroundColor := paragraphColor := foreColor.
	(backgroundColor := backColor) isTransparent ifFalse: 
		[ fillBlt := blt.
		fillBlt fillColor: backgroundColor ].
	ignoreColorChanges := shadowMode! !

!DisplayScanner methodsFor: 'private' stamp: 'lr 7/4/2009 10:42'!
textColor: textColor 
	ignoreColorChanges ifTrue: [ ^ self ].
	foregroundColor := textColor! !

!SystemDictionary methodsFor: '*deprecated13' stamp: ''!
hasSpecialSelector: aLiteral ifTrueSetByte: aBlock

	self deprecated: 'Use Smalltalk instead' on: '20 March 2010' in: 'Pharo1.1'.
	^ Smalltalk hasSpecialSelector: aLiteral ifTrueSetByte: aBlock! !

!TextMorphForEditView methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
basicKeyStroke: evt
	"Do the key stroke and check to see if it should be accepted."

	self deprecated: 'Not used anymore in 1.3' on: '27 April 2011' in: 'Pharo1.3'.
	self autoAccept == true
		ifTrue: [ 
			self editView hasUnacceptedEdits
				ifTrue: [ self editor accept ] ]! !

!Text methodsFor: '*deprecated13' stamp: 'MarcusDenker 3/26/2011 17:14'!
asParagraph
	"Answer a Paragraph whose text is the receiver."
	self deprecated: 'ST80 lefover' on:  '21 March 2011' in: 'Pharo1.3'.
	^Paragraph withText: self! !

AbstractFontSelectorDialogWindow subclass: #TextStyleFontSelectorDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!TextStyleFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2008 15:55'!
defaultFontFamilies
	"Answer the set of available fonts families that are supported as Text objects
	in the font that they represent. Only includes FreeTypeFont/TTCFont."
	
	^(((TextStyle actualTextStyles
		select: [:ts | ts defaultFont isTTCFont])
		collect: [:ts | ts defaultFont familyName]) asSet
		collect: [:fam | |famTs|
			famTs := TextStyle named: fam.
			self isFreeTypeInstalled ifTrue: [ 
				(famTs defaultFont isSymbolFont or: [
						(famTs defaultFont hasDistinctGlyphsForAll: fam) not])
					ifTrue: [famTs := TextStyle default]].
			fam asText
				addAttribute: (TextFontReference
					toFont: (famTs fontOfPointSize: self theme listFont pointSize))])
			asSortedCollection: [:a :b | a asString <= b asString]! !

!TextStyleFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2008 15:35'!
matchingFont
	"Answer the font that matches the selections."

	|ts fs emp|
	ts := (TextStyle named: self familyName) ifNil: [^TextStyle defaultFont].
	fs := self fontSize ifNil: [ts defaultFont pointSize].
	emp := self isBold
		ifTrue: [TextEmphasis bold emphasisCode]
		ifFalse: [TextEmphasis normal emphasisCode].
	self isItalic
		ifTrue: [emp := emp + TextEmphasis italic emphasisCode].
	self isUnderlined
		ifTrue: [emp := emp + TextEmphasis underlined emphasisCode].
	self isStruckOut
		ifTrue: [emp := emp + TextEmphasis struckOut emphasisCode].
	(ts fontOfPointSize: fs) pointSize ~= fs
		ifTrue: [ts addNewFontSize: fs].
	^(ts fontOfPointSize: fs)
		emphasis: emp! !

!TextStyleFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:43'!
updateFromSelectedFont
	"Update our state based on the selected font."

	|font|
	font := self selectedFont ifNil: [TextStyle defaultFont].
	fontFamilyIndex := (self fontFamilies indexOf: font familyName).
	fontSizeIndex := (self fontSizes indexOf: font pointSize).
	isBold := (font emphasis allMask: TextEmphasis bold emphasisCode).
	isItalic := (font emphasis allMask: TextEmphasis italic emphasisCode).
	isUnderlined := (font emphasis allMask: TextEmphasis underlined emphasisCode).
	isStruckOut := (font emphasis allMask: TextEmphasis struckOut emphasisCode).
	self
		changed: #fontFamilyIndex;
		changed: #fontSizeIndex;
		changed: #isBold;
		changed: #isItalic;
		changed: #isUnderlined;
		changed: #isStruckOut.
	self textPreviewMorph ifNotNil: [:tp |
		tp
			font: self selectedFont;
			scrollToTop]! !

!TheWorldMenu class methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
registerOpenCommand: anArray
	self deprecated: 'Use <worldMenu> instead.' on: '19 March 2010' in: 'Pharo1.2'! !

!TheWorldMenu class methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
unregisterOpenCommandWithReceiver: anArray
	self deprecated: 'Use <worldMenu> instead.' on: '19 March 2010' in: 'Pharo1.2'! !

Form subclass: #StaticForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!StaticForm commentStamp: '<historical>' prior: 0!
An optimization for Nebraska - a StaticForm does not change once created so it may be cached on the remote end.!

!StaticForm methodsFor: 'as yet unclassified' stamp: 'RAA 8/14/2000 09:59'!
isStatic

	^true! !

ImageReadWriter subclass: #PCXReadWriter
	instanceVariableNames: 'version encoding colorPlanes isGrayScale width height bitsPerPixel colorPalette rowByteSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!PCXReadWriter commentStamp: 'LaurentLaffont 5/4/2011 21:26' prior: 0!
I am an Image ReadWriter supposed to be in charge of PCX file encoding and decoding.

Actually, as my instances does not implement understandsImageFormat, they use the default ^false implementation and I cannot be used.
I don't have uses in the image also :).

But in case I am fixed, the code to open a morph with a pcx image is:

PCXReadWriter formFromFileNamed: 'anImage.pcx'.!

!PCXReadWriter class methodsFor: 'image reading/writing' stamp: 'nk 7/16/2003 17:57'!
typicalFileExtensions
	"Answer a collection of file extensions (lowercase) which files that I can read might commonly have"
	^#('pcx')! !

!PCXReadWriter methodsFor: 'accessing' stamp: 'lr 7/4/2009 10:42'!
nextImage
	"Read in the next PCX image from the stream."
	| bytes form |
	self readHeader.
	bytes := self readBody.
	colorPalette := self readPalette.
	self close.
	form := ColorForm 
		extent: width @ height
		depth: bitsPerPixel.
	(Form new hackBits: bytes) displayOn: (Form new hackBits: form bits).
	form colors: colorPalette.
	^ form! !

!PCXReadWriter methodsFor: 'private-decoding' stamp: 'tao 10/6/97 08:38'!
nextWord
	^self next + (self next bitShift: 8)! !

!PCXReadWriter methodsFor: 'private-decoding' stamp: 'lr 7/4/2009 10:42'!
readBody
	| array scanLine rowBytes position byte count pad |
	pad := #(0 3 2 1 ) at: width \\ 4 + 1.
	array := ByteArray new: (width + pad) * height * bitsPerPixel // 8.
	scanLine := ByteArray new: rowByteSize.
	position := 1.
	1 
		to: height
		do: 
			[ :line | 
			rowBytes := 0.
			[ rowBytes < rowByteSize ] whileTrue: 
				[ byte := self next.
				byte < 192 
					ifTrue: 
						[ rowBytes := rowBytes + 1.
						scanLine 
							at: rowBytes
							put: byte ]
					ifFalse: 
						[ count := byte - 192.
						byte := self next.
						1 
							to: count
							do: 
								[ :i | 
								scanLine 
									at: rowBytes + i
									put: byte ].
						rowBytes := rowBytes + count ] ].
			array 
				replaceFrom: position
				to: position + width - 1
				with: scanLine
				startingAt: 1.
			position := position + width + pad ].
	^ array! !

!PCXReadWriter methodsFor: 'private-decoding' stamp: 'lr 7/4/2009 10:42'!
readHeader
	| xMin xMax yMin yMax |
	self next.	"skip over manufacturer field"
	version := self next.
	encoding := self next.
	bitsPerPixel := self next.
	xMin := self nextWord.
	yMin := self nextWord.
	xMax := self nextWord.
	yMax := self nextWord.
	width := xMax - xMin + 1.
	height := yMax - yMin + 1.
	self next: 4.	"skip over device resolution"
	self next: 49.	"skip over EGA color palette"
	colorPlanes := self next.
	rowByteSize := self nextWord.
	isGrayScale := (self next: 2) = 2.
	self next: 58	"skip over filler"! !

!PCXReadWriter methodsFor: 'private-decoding' stamp: 'lr 7/4/2009 10:42'!
readPalette
	| r g b array |
	self next = 12 ifFalse: [ self error: 'no Color Palette!!' ].
	array := Array new: (1 bitShift: bitsPerPixel).
	1 
		to: array size
		do: 
			[ :i | 
			r := self next.
			g := self next.
			b := self next.
			array 
				at: i
				put: (Color 
						r: r
						g: g
						b: b
						range: 255) ].
	^ array! !

RectangleMorph subclass: #FillInTheBlankMorph
	instanceVariableNames: 'response done textPane responseUponCancel queryMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!FillInTheBlankMorph class methodsFor: 'default constants' stamp: 'AlainPlantec 11/29/2009 22:02'!
defaultAnswerExtent
	^  (200@60 * (StandardFonts menuFont height / 12)) rounded! !

!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'ar 3/18/2001 00:54'!
request: queryString
	"Create an instance of me whose question is queryString. Invoke it centered at the cursor, and answer the string the user accepts. Answer the empty string if the user cancels."
	"FillInTheBlankMorph request: 'What is your favorite color?'"

	^ self
		request: queryString
		initialAnswer: ''
		centerAt: (ActiveHand ifNil:[Sensor]) cursorPoint! !

!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'ar 3/18/2001 00:54'!
request: queryString initialAnswer: defaultAnswer 
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts. Answer the empty string if the user cancels."
	"FillInTheBlankMorph
		request: 'What is your favorite color?'
		initialAnswer: 'red, no blue. Ahhh!!'"

	^ self
		request: queryString
		initialAnswer: defaultAnswer
		centerAt: ActiveHand cursorPoint! !

!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'ar 3/17/2001 23:43'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts. Answer the empty string if the user cancels.
	This variant is only for calling from within a Morphic project."
	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	 ^ self 
		request: queryString 
		initialAnswer: defaultAnswer 
		centerAt: aPoint 
		inWorld: ActiveWorld
! !

!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'sw 1/31/2000 11:03'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.  Answer the empty string if the user cancels."
	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	^ self request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: ''! !

!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'sw 2/2/2000 22:43'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel.  If user hits cr, treat it as a normal accept."

	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	^ self request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: true! !

!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'NS 8/1/2000 11:44'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."

	^ self request: queryString initialAnswer: defaultAnswer centerAt: aPoint 
		inWorld: aWorld onCancelReturn: returnOnCancel 
		acceptOnCR: acceptBoolean answerExtent: self defaultAnswerExtent! !

!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'NS 8/1/2000 11:39'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerExtent: answerExtent
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."
	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	| aFillInTheBlankMorph |
	aFillInTheBlankMorph := self new
		setQuery: queryString
		initialAnswer: defaultAnswer
		answerExtent: answerExtent
		acceptOnCR: acceptBoolean.
	aFillInTheBlankMorph responseUponCancel: returnOnCancel.
	aWorld addMorph: aFillInTheBlankMorph centeredNear: aPoint.
	^ aFillInTheBlankMorph getUserResponse
! !

!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'NS 8/1/2000 11:43'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerHeight: answerHeight
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."
	^ self request: queryString initialAnswer: defaultAnswer centerAt: aPoint 
		inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean 
		answerExtent: self defaultAnswerExtent x @ answerHeight! !

!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'bolot 5/18/2000 13:57'!
requestPassword: queryString
	"Create an instance of me whose question is queryString. Invoke it centered at the cursor, and answer the string the user accepts. Answer the empty string if the user cancels."
	"use password font"
	"FillInTheBlankMorph requestPassword: 'Password?'"

	^ self
		requestPassword: queryString
		initialAnswer: ''
		centerAt: Sensor cursorPoint
		inWorld: World
		onCancelReturn: ''
		acceptOnCR: true
! !

!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'bolot 5/18/2000 13:53'!
requestPassword: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."
	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	| aFillInTheBlankMorph |
	aFillInTheBlankMorph := self new
		setPasswordQuery: queryString
		initialAnswer: defaultAnswer
		answerHeight: 50
		acceptOnCR: acceptBoolean.
	aFillInTheBlankMorph responseUponCancel: returnOnCancel.
	aWorld addMorph: aFillInTheBlankMorph centeredNear: aPoint.
	^ aFillInTheBlankMorph getUserResponse
! !

!FillInTheBlankMorph methodsFor: 'menu' stamp: 'jm 5/4/1998 14:21'!
accept
	"Sent by the accept button."

	textPane accept.
! !

!FillInTheBlankMorph methodsFor: 'menu' stamp: 'sw 1/31/2000 11:11'!
cancel
	"Sent by the cancel button."

	response := responseUponCancel.
	done := true.
! !

!FillInTheBlankMorph methodsFor: 'menu' stamp: 'jm 5/4/1998 15:15'!
codePaneMenu: aMenu shifted: shifted

	^ StringHolder new codePaneMenu: aMenu shifted: shifted.
! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'AlainPlantec 12/19/2009 23:04'!
createAcceptButton
	"create the [accept] button"
	| result frame |
	result := SimpleButtonMorph new target: self;
				 color: self theme settings derivedMenuColor lighter lighter.
	result borderColor: self theme settings menuBorderColor.
	result label: 'Accept(s)' translated;
		 actionSelector: #accept.
	result setNameTo: 'accept'.
	frame := LayoutFrame new.
	frame rightFraction: 0.5;
		 rightOffset: -10;
		 bottomFraction: 1.0;
		 bottomOffset: -2.
	result layoutFrame: frame.
	self addMorph: result.
	self
		updateColor: result
		color: result color
		intensity: 2.
	^ result! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'AlainPlantec 12/19/2009 23:04'!
createCancelButton
	"create the [cancel] button"
	| result frame |
	result := SimpleButtonMorph new target: self;
				 color: self theme settings derivedMenuColor lighter lighter.
	result
		borderColor: self theme settings menuBorderColor.
	result label: 'Cancel(l)' translated;
		 actionSelector: #cancel.
	result setNameTo: 'cancel'.
	frame := LayoutFrame new.
	frame leftFraction: 0.5;
		 leftOffset: 10;
		 bottomFraction: 1.0;
		 bottomOffset: -2.
	result layoutFrame: frame.
	self addMorph: result.
	self
		updateColor: result
		color: result color
		intensity: 2.
	^ result! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'GuillermoPolito 8/9/2010 21:20'!
createQueryTextMorph: queryString 
	"create the queryTextMorph"
	| frame |
	queryMorph := TextMorph new contents: queryString.
	queryMorph setNameTo: 'query' translated.
	queryMorph lock.
	frame := LayoutFrame new.
	frame topFraction: 0.0;
		 topOffset: 2.
	frame leftFraction: 0.5;
		 leftOffset: (queryMorph width // 2) negated.
	queryMorph layoutFrame: frame.
	self addMorph: queryMorph.
	^ queryMorph! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'sd 11/8/2003 15:56'!
createTextPaneExtent: answerExtent acceptBoolean: acceptBoolean topOffset: topOffset buttonAreaHeight: buttonAreaHeight 
	"create the textPane"
	| result frame |
	result := PluggableTextMorph
				on: self
				text: #response
				accept: #response:
				readSelection: #selectionInterval
				menu: #codePaneMenu:shifted:.
	result extent: answerExtent.
	result hResizing: #spaceFill;
		 vResizing: #spaceFill.
	result borderWidth: 1.
	result hasUnacceptedEdits: true.
	result acceptOnCR: acceptBoolean.
	result setNameTo: 'textPane'.
	frame := LayoutFrame new.
	frame leftFraction: 0.0;
		 rightFraction: 1.0;
		 topFraction: 0.0;
		 topOffset: topOffset;
		 bottomFraction: 1.0;
		 bottomOffset: buttonAreaHeight negated.
	result layoutFrame: frame.
	self addMorph: result.
	^ result! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:27'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'ar 10/10/2000 22:35'!
delete

	self breakDependents.
	super delete.! !

!FillInTheBlankMorph methodsFor: 'geometry' stamp: 'jrp 7/6/2005 21:42'!
extent: aPoint 
	"change the receiver's extent"

	super extent: aPoint .
	self setDefaultParameters.
	self updateColor! !

!FillInTheBlankMorph methodsFor: 'invoking' stamp: 'GuillermoPolito 8/9/2010 21:20'!
getUserResponse
	"Wait for the user to accept or cancel, and answer the result string. Answers the empty string if the user cancels."
	"Details: This is invoked synchronously from the caller. In order to keep processing inputs and updating the screen while waiting for the user to respond, this method has its own version of the World's event loop."

	| w |
	w := self world.
	w ifNil: [^ response].
	
	(ProvideAnswerNotification signal:
		queryMorph userString) ifNotNil:
		[:answer |
		self delete.
		w doOneCycle.
		^ response := (answer == #default) ifTrue: [response] ifFalse: [answer]].

	done := false.
	w activeHand newKeyboardFocus: textPane.
	[done] whileFalse: [w doOneCycle].
	self delete.
	w doOneCycle.
	^ response
! !

!FillInTheBlankMorph methodsFor: 'event handling' stamp: 'ar 10/7/2000 15:47'!
handlesMouseDown: evt
	^true! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'FernandoOlivero 4/12/2011 09:45'!
initialize

	super initialize.
	self setDefaultParameters.
	self extent: 400 @ 150.
	responseUponCancel := ''.
	self theme currentSettings preferRoundCorner
		ifTrue: [self useRoundedCorners].
	! !

!FillInTheBlankMorph methodsFor: 'invoking' stamp: 'RAA 7/19/2000 20:40'!
morphicLayerNumber

	^10.6! !

!FillInTheBlankMorph methodsFor: 'event handling' stamp: 'md 10/22/2003 16:20'!
mouseDown: evt
	(self containsPoint: evt position) ifFalse:[^ Beeper beep]. "sent in response to outside modal click"
	evt hand grabMorph: self. "allow repositioning"! !

!FillInTheBlankMorph methodsFor: 'accessing' stamp: 'jm 5/4/1998 14:03'!
response

	^ response
! !

!FillInTheBlankMorph methodsFor: 'accessing' stamp: 'jm 5/4/1998 14:22'!
response: aText
	"Sent when text pane accepts."

	response := aText asString.
	done := true.
	^ true
! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'sw 1/31/2000 11:01'!
responseUponCancel: anObject
	responseUponCancel := anObject
! !

!FillInTheBlankMorph methodsFor: 'accessing' stamp: 'di 5/22/1998 00:58'!
selectionInterval
	^ 1 to: response size
! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'FernandoOlivero 4/12/2011 09:45'!
setDefaultParameters
	"change the receiver's appareance parameters"
	self
		color: self theme currentSettings derivedMenuColor;
		borderWidth: self theme settings menuBorderWidth;
		borderColor: self theme settings menuBorderColor.
	self layoutInset: 3.
! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'ar 11/4/2000 23:21'!
setPasswordQuery: queryString initialAnswer: initialAnswer answerHeight: answerHeight acceptOnCR: acceptBoolean
	| pane |
	self setQuery: queryString 
		initialAnswer: initialAnswer 
		answerHeight: answerHeight 
		acceptOnCR: acceptBoolean.
	pane := self submorphNamed: 'textPane'.
	pane font: (StrikeFont passwordFontSize: 12).! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'sd 11/8/2003 15:58'!
setQuery: queryString initialAnswer: initialAnswer answerExtent: answerExtent acceptOnCR: acceptBoolean 
	| query topOffset accept cancel buttonAreaHeight |
	response := initialAnswer.
	done := false.
	self removeAllMorphs.
	self layoutPolicy: ProportionalLayout new.
	query := self createQueryTextMorph: queryString.
	topOffset := query height + 4.
	accept := self createAcceptButton.
	cancel := self createCancelButton.
	buttonAreaHeight := (accept height max: cancel height)
				+ 4.
	textPane := self
				createTextPaneExtent: answerExtent
				acceptBoolean: acceptBoolean
				topOffset: topOffset
				buttonAreaHeight: buttonAreaHeight.
	self extent: (query extent x max: answerExtent x)
			+ 4 @ (topOffset + answerExtent y + 4 + buttonAreaHeight).
	! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'NS 8/1/2000 11:44'!
setQuery: queryString initialAnswer: initialAnswer answerHeight: answerHeight acceptOnCR: acceptBoolean
	self setQuery: queryString initialAnswer: initialAnswer 
		answerExtent: (self class defaultAnswerExtent x @ answerHeight) 
		acceptOnCR: acceptBoolean
! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'sd 11/8/2003 15:58'!
updateColor
	"update the recevier's fillStyle"
	| textPaneBorderColor |
	self
		updateColor: self
		color: self color
		intensity: 1.
	textPane isNil
		ifTrue: [^ self].
	textPaneBorderColor := self borderColor == #raised
				ifTrue: [#inset]
				ifFalse: [self borderColor].
	textPane borderColor: textPaneBorderColor! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'FernandoOlivero 4/12/2011 09:45'!
updateColor: aMorph color: aColor intensity: anInteger 
	"update the apareance of aMorph"
	| fill |
	self theme preferGradientFill ifFalse: [^ self].
	fill := GradientFillStyle ramp: {0.0 -> Color white. 1 -> aColor}.
	fill radial: false;
		origin: aMorph topLeft;
		direction: 0 @ aMorph height.
	aMorph fillStyle: fill! !

Array variableSubclass: #ActionSequence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!ActionSequence commentStamp: 'tlk 5/7/2006 20:02' prior: 0!
An ActionSequence is an array that lists the object's dependant objects.!

!ActionSequence methodsFor: 'converting' stamp: 'reThink 2/18/2001 15:12'!
asActionSequence

	^self! !

!ActionSequence methodsFor: 'converting' stamp: 'rw 7/20/2003 16:03'!
asActionSequenceTrappingErrors

	^WeakActionSequenceTrappingErrors withAll: self! !

!ActionSequence methodsFor: 'converting' stamp: 'reThink 2/18/2001 15:28'!
asMinimalRepresentation

	self size = 0
		ifTrue: [^nil].
	self size = 1
		ifTrue: [^self first].
	^self! !

!ActionSequence methodsFor: 'printing' stamp: 'SqR 07/28/2001 18:25'!
printOn: aStream

	self size < 2 ifTrue: [^super printOn: aStream].
	aStream nextPutAll: '#('.
	self
		do: [:each | each printOn: aStream]
		separatedBy: [aStream cr].
	aStream nextPut: $)! !

!ActionSequence methodsFor: 'evaluating' stamp: 'reThink 2/18/2001 17:51'!
value
    "Answer the result of evaluating the elements of the receiver."

    | answer |
    self do:
        [:each |
        answer := each value].
    ^answer! !

!ActionSequence methodsFor: 'evaluating' stamp: 'reThink 2/18/2001 17:52'!
valueWithArguments: anArray

    | answer |
    self do:
        [:each |
        answer := each valueWithArguments: anArray].
    ^answer! !

!SmalltalkImage methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
forgetClass: aClass logged: aBool
	self deprecated: 'Use Smalltalk globals' on: '1 May 2011' in: 'Pharo1.3'.
	^ globals forgetClass: aClass logged: aBool! !

!SmalltalkImage methodsFor: '*deprecated13' stamp: 'IgorStasenko 1/21/2011 19:03'!
logError: errMsg inContext: aContext to: aFilename
	"Log the error message and a stack trace to the given file."

	self 
		deprecated: 'use #logError:inContext: instead' 
		on: '21 January 2011'
		in: 'Pharo1.3' .
		
	^ self logError: errMsg inContext: aContext! !

!SmalltalkImage methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
poolUsers
	self deprecated: 'Use Smalltalk globals' on: '1 May 2011' in: 'Pharo1.3'.
	^ globals poolUsers! !

!InputEventSensor methodsFor: '*deprecated13' stamp: 'StephaneDucasse 3/3/2011 17:46'!
currentCursor
	"The current cursor is maintained in class Cursor."
	
	self deprecated: 'Use Cursor currentCursor instead' on:  '3 March 2011'  in: 'Pharo1.3'.
	^ Cursor currentCursor! !

!InputEventSensor methodsFor: '*deprecated13' stamp: 'StephaneDucasse 3/3/2011 17:47'!
currentCursor: newCursor 
	"The current cursor is maintained in class Cursor."

	self deprecated: 'Use Cursor currentCursor: instead' on:  '3 March 2011'  in: 'Pharo1.3'.
	
	Cursor currentCursor: newCursor.! !

!InputEventSensor methodsFor: '*deprecated13' stamp: 'StephaneDucasse 3/3/2011 17:30'!
peekPosition
	self deprecated.
	
	^self cursorPoint! !

!SimpleHierarchicalListMorph class methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
expandedForm
	self deprecated: 'Use UITheme>>treeExpandedForm instead' on: '11 February 2011' in: 'Pharo1.3'.
	expandedForm
		ifNotNil: [ 
			expandedForm depth ~= Display depth
				ifTrue: [ expandedForm := nil ] ].
	^ expandedForm
		ifNil: [ 
			expandedForm := (Form
				extent: 10 @ 9
				depth: 8
				fromArray:
					#(4294967295 4294967295 4294901760 4294967295 4294967295 4294901760 4278255873 16843009 16842752 4294902089 1229539657 33488896 4294967041 1229539585 4294901760 4294967295 21561855 4294901760 4294967295 4278321151 4294901760 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760)
				offset: 0 @ 0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself ]! !

!SimpleHierarchicalListMorph class methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
notExpandedForm
	self deprecated: 'Use UITheme>>treeUnexpandedForm instead' on: '11 February 2011' in: 'Pharo1.3'.
	notExpandedForm
		ifNotNil: [ 
			notExpandedForm depth ~= Display depth
				ifTrue: [ notExpandedForm := nil ] ].
	^ notExpandedForm
		ifNil: [ 
			notExpandedForm := (Form
				extent: 10 @ 9
				depth: 8
				fromArray:
					#(4294967041 4294967295 4294901760 4294967041 33554431 4294901760 4294967041 1224867839 4294901760 4294967041 1229521407 4294901760 4294967041 1229539585 4294901760 4294967041 1229521407 4294901760 4294967041 1224867839 4294901760 4294967041 33554431 4294901760 4294967041 4294967295 4294901760)
				offset: 0 @ 0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself ]! !

!SequenceableCollection methodsFor: '*deprecated13' stamp: 'MarcusDenker 10/26/2010 15:36'!
sortBy: aBlock
	"Create a copy that is sorted.  Sort criteria is the block that accepts two arguments.
	When the block is true, the first arg goes first ([:a :b | a > b] sorts in descending
	order)."

	self deprecated: 'use #sort: or #sorted: instead' on: '04 September 2010' in: 'Pharo1.2'.
	
	^ self asOrderedCollection
			sort: aBlock;
	 		yourself! !

!LazyListMorph methodsFor: '*deprecated13' stamp: 'SeanDeNigris 8/31/2011 14:20'!
drawBackgroundForMulti: row on: aCanvas
	| selectionDrawBounds |
	self deprecated: 'use #drawBackgroundForSelectedRow:  on: instead' on: '11 February 2011' in: 'Pharo1.3'.	"shade the background darker, if this row is selected"
	selectionDrawBounds := self drawBoundsForRow: row.
	selectionDrawBounds := selectionDrawBounds intersect: self bounds.
	aCanvas fillRectangle: selectionDrawBounds color: self color muchLighter! !

Object subclass: #FakeClassPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!FakeClassPool commentStamp: '<historical>' prior: 0!
The sole purpose of this class is to allow the Browser code pane to evaluate the class variables of the class whose method it is showing.  It does this by stuffing a pointer to the classpool dictionary of the class being shown into its own classpool.  It does this just around a doIt in the code pane.  An instance of FakeClasspool is then used as the receiver of the doIt.!

!FakeClassPool class methodsFor: 'initialize' stamp: 'dvf 9/27/2005 19:05'!
adopt: classOrNil
	"Temporarily use the classPool and sharedPools of another class"
	classOrNil isBehavior
		ifFalse: [classPool := nil.
				sharedPools := nil]
		ifTrue: [classPool := classOrNil classPool.
				sharedPools := classOrNil sharedPools]
! !

Object subclass: #MenuIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!MenuIcons commentStamp: 'AlainPlantec 10/19/2010 22:19' prior: 0!
DEPRECATED class.
All is in ThemeIcons now.
So, I'm just a placeholder so that old code can still load. !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
backIcon
	"DEPRECATED!!!!!!  use 'UITheme current backIcon' instead"
	^ UITheme current backIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
backspaceArrowIcon
	"DEPRECATED!!!!!!  use 'UITheme current backspaceArrowIcon' instead"
	^ UITheme current backspaceArrowIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
blankIcon
	"DEPRECATED!!!!!!  use 'UITheme current blankIcon' instead"
	^ UITheme current blankIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
checkBoxOffIcon
	"DEPRECATED!!!!!!  use 'UITheme current checkBoxOffIcon' instead"
	^ UITheme current checkBoxOffIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
checkBoxOnIcon
	"DEPRECATED!!!!!!  use 'UITheme current checkBoxOnIcon' instead"
	^ UITheme current checkBoxOnIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
checkBoxPressedIcon
	"DEPRECATED!!!!!!  use 'UITheme current checkBoxPressedIcon' instead"
	^ UITheme current checkBoxPressedIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
configurationIcon
	"DEPRECATED!!!!!!  use 'UITheme current configurationIcon' instead"
	^ UITheme current configurationIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
confirmIcon
	"DEPRECATED!!!!!!  use 'UITheme current confirmIcon' instead"
	^ UITheme current confirmIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
crudeRedoDisabledIcon
	"DEPRECATED!!!!!!  use 'UITheme current crudeRedoDisabledIcon' instead"
	^ UITheme current crudeRedoDisabledIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
crudeRedoIcon
	"DEPRECATED!!!!!!  use 'UITheme current crudeRedoIcon' instead"
	^ UITheme current crudeRedoIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
crudeUndoDisabledIcon
	"DEPRECATED!!!!!!  use 'UITheme current crudeUndoDisabledIcon' instead"
	^ UITheme current crudeUndoDisabledIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
crudeUndoIcon
	"DEPRECATED!!!!!!  use 'UITheme current crudeUndoIcon' instead"
	^ UITheme current crudeUndoIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
downArrowIcon
	"DEPRECATED!!!!!!  use 'UITheme current downArrowIcon' instead"
	^ UITheme current downArrowIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
errorIcon
	"DEPRECATED!!!!!!  use 'UITheme current errorIcon' instead"
	^ UITheme current errorIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
expandBoxIcon
	"DEPRECATED!!!!!!  use 'UITheme current expandBoxIcon' instead"
	^ UITheme current expandBoxIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
eyedropperIcon
	"DEPRECATED!!!!!!  use 'UITheme current eyedropperIcon' instead"
	^ UITheme current eyedropperIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
forwardIcon
	"DEPRECATED!!!!!!  use 'UITheme current forwardIcon' instead"
	^ UITheme current forwardIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
fullScreenIcon
	"DEPRECATED!!!!!!  use 'UITheme current fullScreenIcon' instead"
	^ UITheme current fullScreenIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
getsIcon
	"DEPRECATED!!!!!!  use 'UITheme current getsIcon' instead"
	^ UITheme current getsIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloCollapseIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloCollapseIcon' instead"
	^ UITheme current haloCollapseIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloDebugIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloDebugIcon' instead"
	^ UITheme current haloDebugIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloDismissIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloDismissIcon' instead"
	^ UITheme current haloDismissIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloDragIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloDragIcon' instead"
	^ UITheme current haloDragIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloDupIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloDupIcon' instead"
	^ UITheme current haloDupIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloFontEmphIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloFontEmphIcon' instead"
	^ UITheme current haloFontEmphIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloFontSizeIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloFontSizeIcon' instead"
	^ UITheme current haloFontSizeIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloFontStyleIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloFontStyleIcon' instead"
	^ UITheme current haloFontStyleIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloGrabIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloGrabIcon' instead"
	^ UITheme current haloGrabIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloHelpIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloHelpIcon' instead"
	^ UITheme current haloHelpIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloMenuIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloMenuIcon' instead"
	^ UITheme current haloMenuIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloPaintIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloPaintIcon' instead"
	^ UITheme current haloPaintIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloRecolorIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloRecolorIcon' instead"
	^ UITheme current haloRecolorIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloRotIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloRotIcon' instead"
	^ UITheme current haloRotIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloScaleIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloScaleIcon' instead"
	^ UITheme current haloScaleIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
haloViewIcon
	"DEPRECATED!!!!!!  use 'UITheme current haloViewIcon' instead"
	^ UITheme current haloViewIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
helpIcon
	"DEPRECATED!!!!!!  use 'UITheme current helpIcon' instead"
	^ UITheme current helpIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
homeIcon
	"DEPRECATED!!!!!!  use 'UITheme current homeIcon' instead"
	^ UITheme current homeIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
imageIcon
	"DEPRECATED!!!!!!  use 'UITheme current imageIcon' instead"
	^ UITheme current imageIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
infoIcon
	"DEPRECATED!!!!!!  use 'UITheme current infoIcon' instead"
	^ UITheme current infoIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
jumpIcon
	"DEPRECATED!!!!!!  use 'UITheme current jumpIcon' instead"
	^ UITheme current jumpIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
lockIcon
	"DEPRECATED!!!!!!  use 'UITheme current lockIcon' instead"
	^ UITheme current lockIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
objectsIcon
	"DEPRECATED!!!!!!  use 'UITheme current objectsIcon' instead"
	^ UITheme current objectsIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
openIcon
	"DEPRECATED!!!!!!  use 'UITheme current openIcon' instead"
	^ UITheme current openIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
paintIcon
	"DEPRECATED!!!!!!  use 'UITheme current paintIcon' instead"
	^ UITheme current paintIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
paintTabIcon
	"DEPRECATED!!!!!!  use 'UITheme current paintTabIcon' instead"
	^ UITheme current paintTabIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
paintingIcon
	"DEPRECATED!!!!!!  use 'UITheme current paintingIcon' instead"
	^ UITheme current paintingIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
pharoIcon
	"DEPRECATED!!!!!!  use 'UITheme current pharoIcon' instead"
	^ UITheme current pharoIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
projectIcon
	"DEPRECATED!!!!!!  use 'UITheme current projectIcon' instead"
	^ UITheme current projectIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
publishIcon
	"DEPRECATED!!!!!!  use 'UITheme current publishIcon' instead"
	^ UITheme current publishIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
questionIcon
	"DEPRECATED!!!!!!  use 'UITheme current questionIcon' instead"
	^ UITheme current questionIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
radioButtonOffIcon
	"DEPRECATED!!!!!!  use 'UITheme current radioButtonOffIcon' instead"
	^ UITheme current radioButtonOffIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
radioButtonOnIcon
	"DEPRECATED!!!!!!  use 'UITheme current radioButtonOnIcon' instead"
	^ UITheme current radioButtonOnIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
radioButtonPressedIcon
	"DEPRECATED!!!!!!  use 'UITheme current radioButtonPressedIcon' instead"
	^ UITheme current radioButtonPressedIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
rotateIcon
	"DEPRECATED!!!!!!  use 'UITheme current rotateIcon' instead"
	^ UITheme current rotateIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
scaleIcon
	"DEPRECATED!!!!!!  use 'UITheme current scaleIcon' instead"
	^ UITheme current scaleIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallAuthoringToolsIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallAuthoringToolsIcon' instead"
	^ UITheme current smallAuthoringToolsIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallBackIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallBackIcon' instead"
	^ UITheme current smallBackIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallBarcodeIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallBarcodeIcon' instead"
	^ UITheme current smallBarcodeIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallBoldIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallBoldIcon' instead"
	^ UITheme current smallBoldIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallCancelIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallCancelIcon' instead"
	^ UITheme current smallCancelIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallCenteredIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallCenteredIcon' instead"
	^ UITheme current smallCenteredIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallConfigurationIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallConfigurationIcon' instead"
	^ UITheme current smallConfigurationIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallCopyIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallCopyIcon' instead"
	^ UITheme current smallCopyIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallCutIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallCutIcon' instead"
	^ UITheme current smallCutIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallDebugIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallDebugIcon' instead"
	^ UITheme current smallDebugIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallDeleteIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallDeleteIcon' instead"
	^ UITheme current smallDeleteIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallDoItIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallDoItIcon' instead"
	^ UITheme current smallDoItIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallErrorIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallErrorIcon' instead"
	^ UITheme current smallErrorIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallExpertIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallExpertIcon' instead"
	^ UITheme current smallExpertIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallExportIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallExportIcon' instead"
	^ UITheme current smallExportIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallFindIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallFindIcon' instead"
	^ UITheme current smallFindIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallFontsIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallFontsIcon' instead"
	^ UITheme current smallFontsIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallForwardIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallForwardIcon' instead"
	^ UITheme current smallForwardIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallFullScreenIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallFullScreenIcon' instead"
	^ UITheme current smallFullScreenIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallHelpIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallHelpIcon' instead"
	^ UITheme current smallHelpIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallHierarchyBrowserIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallHierarchyBrowserIcon' instead"
	^ UITheme current smallHierarchyBrowserIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallHomeIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallHomeIcon' instead"
	^ UITheme current smallHomeIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallInfoIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallInfoIcon' instead"
	^ UITheme current smallInfoIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallInspectItIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallInspectItIcon' instead"
	^ UITheme current smallInspectItIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallItalicIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallItalicIcon' instead"
	^ UITheme current smallItalicIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallJumpIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallJumpIcon' instead"
	^ UITheme current smallJumpIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallJustifiedIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallJustifiedIcon' instead"
	^ UITheme current smallJustifiedIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallLanguageIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallLanguageIcon' instead"
	^ UITheme current smallLanguageIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallLeftFlushIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallLeftFlushIcon' instead"
	^ UITheme current smallLeftFlushIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallLoadProjectIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallLoadProjectIcon' instead"
	^ UITheme current smallLoadProjectIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallLockIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallLockIcon' instead"
	^ UITheme current smallLockIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallNewIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallNewIcon' instead"
	^ UITheme current smallNewIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallObjectCatalogIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallObjectCatalogIcon' instead"
	^ UITheme current smallObjectCatalogIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallObjectsIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallObjectsIcon' instead"
	^ UITheme current smallObjectsIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallOkIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallOkIcon' instead"
	^ UITheme current smallOkIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallOpenIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallOpenIcon' instead"
	^ UITheme current smallOpenIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallPaintIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallPaintIcon' instead"
	^ UITheme current smallPaintIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallPasteIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallPasteIcon' instead"
	^ UITheme current smallPasteIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallPrintIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallPrintIcon' instead"
	^ UITheme current smallPrintIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallProjectIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallProjectIcon' instead"
	^ UITheme current smallProjectIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallPublishIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallPublishIcon' instead"
	^ UITheme current smallPublishIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallPushpinIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallPushpinIcon' instead"
	^ UITheme current smallPushpinIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallQuestionIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallQuestionIcon' instead"
	^ UITheme current smallQuestionIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallQuitIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallQuitIcon' instead"
	^ UITheme current smallQuitIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallRedoIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallRedoIcon' instead"
	^ UITheme current smallRedoIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallRemoteOpenIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallRemoteOpenIcon' instead"
	^ UITheme current smallRemoteOpenIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallRightFlushIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallRightFlushIcon' instead"
	^ UITheme current smallRightFlushIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallSaveAsIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallSaveAsIcon' instead"
	^ UITheme current smallSaveAsIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallSaveIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallSaveIcon' instead"
	^ UITheme current smallSaveIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallSelectIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallSelectIcon' instead"
	^ UITheme current smallSelectIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallStrikeOutIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallStrikeOutIcon' instead"
	^ UITheme current smallStrikeOutIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallSystemBrowserIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallSystemBrowserIcon' instead"
	^ UITheme current smallSystemBrowserIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallUnderlineIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallUnderlineIcon' instead"
	^ UITheme current smallUnderlineIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallUndoIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallUndoIcon' instead"
	^ UITheme current smallUndoIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallUpdateIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallUpdateIcon' instead"
	^ UITheme current smallUpdateIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallVolumeIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallVolumeIcon' instead"
	^ UITheme current smallVolumeIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallWarningIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallWarningIcon' instead"
	^ UITheme current smallWarningIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
smallWindowIcon
	"DEPRECATED!!!!!!  use 'UITheme current smallWindowIcon' instead"
	^ UITheme current smallWindowIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
solidMenuIcon
	"DEPRECATED!!!!!!  use 'UITheme current solidMenuIcon' instead"
	^ UITheme current solidMenuIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
squeakyMouseIcon
	"DEPRECATED!!!!!!  use 'UITheme current squeakyMouseIcon' instead"
	^ UITheme current squeakyMouseIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
tinyMenuIcon
	"DEPRECATED!!!!!!  use 'UITheme current tinyMenuIcon' instead"
	^ UITheme current tinyMenuIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
upArrowIcon
	"DEPRECATED!!!!!!  use 'UITheme current upArrowIcon' instead"
	^ UITheme current upArrowIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
volumeIcon
	"DEPRECATED!!!!!!  use 'UITheme current volumeIcon' instead"
	^ UITheme current volumeIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
warningIcon
	"DEPRECATED!!!!!!  use 'UITheme current warningIcon' instead"
	^ UITheme current warningIcon! !

!MenuIcons class methodsFor: 'backward compatibility' stamp: 'AlainPlantec 10/19/2010 22:18'!
windowIcon
	"DEPRECATED!!!!!!  use 'UITheme current windowIcon' instead"
	^ UITheme current windowIcon! !

!Object methodsFor: '*deprecated13' stamp: 'IgorStasenko 4/15/2011 17:29'!
exploreWithLabel: label

	^ Smalltalk tools objectExplorer new openExplorerFor: self withLabel:
label! !

!Object methodsFor: '*deprecated13' stamp: 'StephaneDucasse 1/29/2011 11:58'!
notifyWithLabel: aString 
	"Create and schedule a Notifier with aString as the window label as well as the contents of the window, in  order to request confirmation before a process can proceed."

	self deprecated: 'Do not use this method, instead use Warning or UIManager API' on: '28 January 2011' in: 'Pharo1.3'.
	^ Warning signal: aString! !

Object subclass: #ParagraphEditor
	instanceVariableNames: 'model paragraph startBlock stopBlock beginTypeInBlock emphasisHere initialText selectionShowing otherInterval lastParentLocation'
	classVariableNames: 'AutoIndent CaseSensitiveFinds ChangeText CmdActions CmdKeysInText FindText ShiftCmdActions UndoInterval UndoMessage UndoParagraph UndoSelection Undone WalkAlongDisplayedLine'
	poolDictionaries: 'TextConstants'
	category: 'Deprecated13'!

!ParagraphEditor commentStamp: 'AlainPlantec 12/2/2010 20:51' prior: 0!
DEPRECATED IN 1.2
Use TextEditor or SmalltalkEditor instead

I am a Controller for editing a Paragraph. I am a kind of ScrollController, so that more text can be created for the Paragraph than can be viewed on the screen. Editing messages are sent by issuing commands from a yellow button menu or from keys on the keyboard. My instances keep control as long as the cursor is within the view when the red or yellow mouse button is pressed; they give up control if the blue button is pressed.!

!ParagraphEditor class methodsFor: 'class initialization' stamp: 'sw 5/27/2000 00:03'!
abandonChangeText
	"Call this to get out of the maddening situation in which the system keeps aggressively trying to do a replacement that you no longer wish to make, every time you make choose a new method in a list."
	ChangeText := FindText

	"ParagraphEditor abandonChangeText"
! !

!ParagraphEditor class methodsFor: 'settings' stamp: 'AlainPlantec 12/19/2009 23:50'!
autoIndent
	^ AutoIndent ifNil: [AutoIndent := true]! !

!ParagraphEditor class methodsFor: 'settings' stamp: 'AlainPlantec 12/19/2009 23:50'!
autoIndent: aBoolean
	AutoIndent := aBoolean! !

!ParagraphEditor class methodsFor: 'settings' stamp: 'AlainPlantec 12/10/2009 22:56'!
caseSensitiveFinds
	^ CaseSensitiveFinds ifNil: [CaseSensitiveFinds := false]! !

!ParagraphEditor class methodsFor: 'settings' stamp: 'AlainPlantec 12/10/2009 22:57'!
caseSensitiveFinds: aBoolean
	CaseSensitiveFinds := aBoolean! !

!ParagraphEditor class methodsFor: 'settings' stamp: 'AlainPlantec 12/19/2009 23:52'!
cmdKeysInText
	^ CmdKeysInText ifNil: [CmdKeysInText := true]! !

!ParagraphEditor class methodsFor: 'settings' stamp: 'AlainPlantec 12/19/2009 23:52'!
cmdKeysInText: aBoolean
	CmdKeysInText := aBoolean! !

!ParagraphEditor class methodsFor: 'class initialization' stamp: 'michael.rueger 3/23/2009 17:51'!
initialize
	"Initialize the keyboard shortcut maps and the shared buffers 
	for copying text across views and managing again and undo. 
	Marked this method changed to trigger reinit"

	"ParagraphEditor initialize"

	UndoSelection := FindText := ChangeText := Text new.
	UndoMessage := Message selector: #halt.
	self initializeCmdKeyShortcuts.
	self initializeShiftCmdKeyShortcuts.! !

!ParagraphEditor class methodsFor: 'keyboard shortcut tables' stamp: 'michael.rueger 2/23/2009 18:15'!
initializeCmdKeyShortcuts
	"Initialize the (unshifted) command-key (or alt-key) shortcut table."

	"NOTE: if you don't know what your keyboard generates, use Sensor kbdTest"

	"ParagraphEditor initialize"

	| cmdMap |

	cmdMap := Array new: 256 withAll: #noop:.	"use temp in case of a crash"

	cmdMap at: 1 + 1 put: #cursorHome:.			"home key"
	cmdMap at: 4 + 1 put: #cursorEnd:.				"end key"
	cmdMap at: 8 + 1 put: #backspace:.				"ctrl-H or delete key"
	cmdMap at: 11 + 1 put: #cursorPageUp:.		"page up key"
	cmdMap at: 12 + 1 put: #cursorPageDown:.	"page down key"
	cmdMap at: 13 + 1 put: #crWithIndent:.			"cmd-Return"
	cmdMap at: 27 + 1 put: #offerMenuFromEsc:.	"escape key"
	cmdMap at: 28 + 1 put: #cursorLeft:.			"left arrow key"
	cmdMap at: 29 + 1 put: #cursorRight:.			"right arrow key"
	cmdMap at: 30 + 1 put: #cursorUp:.				"up arrow key"
	cmdMap at: 31 + 1 put: #cursorDown:.			"down arrow key"
	cmdMap at: 32 + 1 put: #selectWord:.			"space bar key"
	cmdMap at: 127 + 1 put: #forwardDelete:keyEvent:.		"del key"

	'0123456789-=' 
		do: [:char | cmdMap at: char asciiValue + 1 put: #changeEmphasis:keyEvent:].

	'([{''"<' do: [:char | cmdMap at: char asciiValue + 1 put: #enclose:keyEvent:].

	cmdMap at: $, asciiValue + 1 put: #shiftEnclose:keyEvent:.

	"triplet = {character. comment selector. novice appropiated}"
	#(
		($a		#selectAll:				true)
		($b		#browseIt:				false)
		($c		#copySelection:			true)
		($d		#doIt:						false)
		($e		#exchange:				true)
		($f		#find:						true)
		($g		#findAgain:				true)
		($h		#setSearchString:		true)
		($i		#inspectIt:				false)
		($j		#doAgainOnce:			true)
		($l		#cancel:					true)
		($m		#implementorsOfIt:		false)
		($n		#sendersOfIt:			false)
		($p		#printIt:					false)
		($q		#querySymbol:			false)
		($s		#save:					true)
		($v		#paste:					true)
		($w		#backWord:				true)
		($x		#cut:						true)
		($y		#swapChars:				true)
		($z		#undo:					true)
	)
		do: [:triplet | cmdMap at: triplet first asciiValue + 1 put: triplet second].

	CmdActions := cmdMap.
! !

!ParagraphEditor class methodsFor: 'keyboard shortcut tables' stamp: 'CB 7/27/2009 14:50'!
initializeShiftCmdKeyShortcuts 
	"Initialize the shift-command-key (or control-key) shortcut table."
	"NOTE: if you don't know what your keyboard generates, use Sensor kbdTest"
	"wod 11/3/1998: Fix setting of cmdMap for shifted keys to actually use the 
	capitalized versions of the letters.
	TPR 2/18/99: add the plain ascii values back in for those VMs that don't return the shifted values."

	| cmdMap |

	"shift-command and control shortcuts"
	cmdMap := Array new: 256 withAll: #noop:.  "use temp in case of a crash"

	cmdMap at: ( 1 + 1) put: #cursorHome:.				"home key"
	cmdMap at: ( 4 + 1) put: #cursorEnd:.				"end key"
	cmdMap at: ( 8 + 1) put: #forwardDelete:keyEvent:.			"ctrl-H or delete key"
	cmdMap at: (11 + 1) put: #cursorPageUp:.			"page up key"
	cmdMap at: (12 + 1) put: #cursorPageDown:.		"page down key"
	cmdMap at: (13 + 1) put: #crWithIndent:.			"ctrl-Return"
	cmdMap at: (27 + 1) put: #offerMenuFromEsc:.	"escape key"
	cmdMap at: (28 + 1) put: #cursorLeft:.				"left arrow key"
	cmdMap at: (29 + 1) put: #cursorRight:.				"right arrow key"
	cmdMap at: (30 + 1) put: #cursorUp:.				"up arrow key"
	cmdMap at: (31 + 1) put: #cursorDown:.			"down arrow key"
	cmdMap at: (32 + 1) put: #selectWord:.				"space bar key"
	cmdMap at: (45 + 1) put: #changeEmphasis:keyEvent:.		"cmd-sh-minus"
	cmdMap at: (61 + 1) put: #changeEmphasis:keyEvent:.		"cmd-sh-plus"
	cmdMap at: (127 + 1) put: #forwardDelete:keyEvent:.		"del key"

	"Note: Command key overrides shift key, so, for example, cmd-shift-9 produces $9 not $("
	'9[,''' do: [ :char | cmdMap at: (char asciiValue + 1) put: #shiftEnclose:keyEvent: ].	"({< and double-quote"
	"Note: Must use cmd-9 or ctrl-9 to get '()' since cmd-shift-9 is a Mac FKey command."

	"NB: sw 12/9/2001 commented out the idiosyncratic line just below, which was grabbing shift-esc in the text editor and hence which argued with the wish to have shift-esc be a universal gesture for escaping the local context and calling up the desktop menu."  
	"cmdMap at: (27 + 1) put: #shiftEnclose:." 	"ctrl-["

	"'""''(' do: [ :char | cmdMap at: (char asciiValue + 1) put: #enclose:]."

	"triplet = {character. comment selector. novice appropiated}"
	#(
		($a		argAdvance:						false)
		($b		browseItHere:					false)
		($c		compareToClipboard:			false)
		($d		debugIt:						false)
		($e		methodStringsContainingIt:	false)
		($f		displayIfFalse:					false)
		($g		fileItIn:							false)
		($h		cursorTopHome:					true)
		($i		exploreIt:							false)
		($j		doAgainMany:					true)
		($k		changeStyle:						true)
		($l		outdent:							true)
		($m	selectCurrentTypeIn:			true)
		($n		referencesToIt:					false)
		($r		indent:							true)
		($s		search:							true)
		($t		displayIfTrue:					false)
		($u		changeLfToCr:					false)
		($v		pasteInitials:						false)
		($w	methodNamesContainingIt:	false)
		($x		makeLowercase:					true)
		($y		makeUppercase:					true)
		($z		makeCapitalized:				true)
	)
		do: [:triplet |
			cmdMap at: (triplet first asciiValue         + 1) put: triplet second.		"plain keys"
			cmdMap at: (triplet first asciiValue - 32 + 1) put: triplet second.		"shifted keys"
			cmdMap at: (triplet first asciiValue - 96 + 1) put: triplet second.		"ctrl keys"
		].

	ShiftCmdActions := cmdMap! !

!ParagraphEditor class methodsFor: 'instance creation' stamp: 'nk 9/3/2004 14:10'!
new
	"Answer a new instance of me with a null Paragraph to be edited."

	| aParagraphEditor |
	aParagraphEditor := super new.
	aParagraphEditor changeParagraph: '' asParagraph.
	^aParagraphEditor! !

!ParagraphEditor class methodsFor: 'instance creation' stamp: ''!
newParagraph: aParagraph 
	"Answer an instance of me with aParagraph as the text to be edited."

	| aParagraphEditor |
	aParagraphEditor := super new.
	aParagraphEditor initialize.
	aParagraphEditor changeParagraph: aParagraph.
	^aParagraphEditor! !

!ParagraphEditor class methodsFor: 'class initialization' stamp: 'GuillermoPolito 5/29/2011 15:15'!
shiftedYellowButtonMenu
	"Answer the menu to be presented when the yellow button is pressed while the shift key is down"

	| menu |
	menu := UIManager default newMenuIn: self for: self.
	menu addList: {
		
		{'Browse it (b)' translated.					#browseIt}.
		{'Senders of it (n)' translated.				#sendersOfIt}.
		{'Implementors of it (m)' translated.		#implementorsOfIt}.
		{'References to it (N)' translated.			#referencesToIt}.
		#-.
		{'Selectors containing it (W)' translated.	#methodNamesContainingIt}.
		{'Method strings with it (E)' translated.	#methodStringsContainingit}.
		{'Method source with it' translated.		#methodSourceContainingIt}.
		{'Class names containing it' translated.	#classNamesContainingIt}.
		{'Class comments with it' translated.		#classCommentsContainingIt}.
		{'Change sets with it' translated.			#browseChangeSetsWithSelector}.
	"	#-.
		{'Pretty print' translated.					#prettyPrint}.
		{'Pretty print with color' translated.		#prettyPrintWithColor}.
		{'File it in (G)' translated.					#fileItIn}.
		#-.
		{'Back...' translated.						#yellowButtonActivity}.
	"
	}.
	^menu! !

!ParagraphEditor class methodsFor: 'keyboard shortcut tables' stamp: 'sbw 10/8/1999 21:42'!
specialShiftCmdKeys

"Private - return array of key codes that represent single keys acting
as if shift-command were also being pressed"

^#(
	1	"home"
	3	"enter"
	4	"end"
	8	"backspace"
	11	"page up"
	12	"page down"
	27	"escape"
	28	"left arrow"
	29	"right arrow"
	30	"up arrow"
	31	"down arrow"
	127	"delete"
	)! !

!ParagraphEditor class methodsFor: 'settings' stamp: 'AlainPlantec 12/11/2009 13:37'!
walkAlongDisplayedLine
	^ WalkAlongDisplayedLine ifNil: [WalkAlongDisplayedLine := true]! !

!ParagraphEditor class methodsFor: 'settings' stamp: 'AlainPlantec 12/11/2009 13:37'!
walkAlongDisplayedLine: aBoolean
	WalkAlongDisplayedLine := aBoolean! !

!ParagraphEditor class methodsFor: 'class initialization' stamp: 'GuillermoPolito 5/29/2011 15:14'!
yellowButtonExpertMenu
	| menu |
	menu := UIManager default newMenuIn: self for: self.
	menu addList: {
			{'Do it (d)' translated.					#doIt. nil. #smallDoItIcon}.
			{'Print it (p)' translated.					#printIt. nil. #smallPrintIcon}.
			{'Inspect it (i)' translated.				#inspectIt. nil. #smallInspectItIcon}.
			{'Explore it (I)' translated.				#exploreIt. nil. #smallInspectItIcon}.
			{'Debug it (D)' translated.				#debugIt. nil. #smallDebugItIcon}.
			{'Profile it' translated.					#tallyIt}.
		     {'Watch it' translated.					#watchIt}.	 
		    	 
			#-.
			{'Find...(f)' translated.					#find. nil. #smallFindIcon}.
			{'Find again (g)' translated.				#findAgain.nil. #smallFindIcon}.
			{'Extended search...' translated.			#shiftedTextPaneMenuRequest}.
			#-.
			{'Do again (j)' translated.				#again. nil. #smallDoItIcon}.
			{'Undo (z)' translated.					#undo. nil. #smallUndocon}.
			#-.
			{'Copy (c)' translated.					#copySelection. nil. #smallCopyIcon}.
			{'Cut (x)' translated.						#cut. nil. #smallCutIcon}.
			{'Paste (v)' translated.					#paste. nil. #smallPasteIcon}.
			{'Paste...' translated.					#pasteRecent. nil. #smallCopyIcon}.
			#-.
			{'Accept (s)' translated.					#accept. nil. #smallOkIcon}.
			{'Cancel (l)' translated.					#cancel. nil. #smallCancelIcon}.
		}.
	^menu! !

!ParagraphEditor class methodsFor: 'class initialization' stamp: 'marcus.denker 11/19/2008 13:49'!
yellowButtonMenu

	^self yellowButtonExpertMenu
! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'jm 5/3/1998 19:19'!
accept
	"Save the current text of the text being edited as the current acceptable version for purposes of canceling."

	initialText := paragraph text copy.
! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'th 9/18/2002 14:37'!
adjustSelection: directionBlock
	"Helper function for Cursor movement. Always moves point thus allowing selections to shrink. "
	"See also expandSelection:"
	"Accepts a one argument Block that computes the new postion given an old one."
	| newPosition |
	newPosition := directionBlock value: self pointIndex.
	self selectMark: self markIndex point: newPosition.
	^true.! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'th 10/28/2003 12:11'!
afterSelectionInsertAndSelect: aString

	self insertAndSelect: aString at: self stopIndex ! !

!ParagraphEditor methodsFor: 'menu messages' stamp: ''!
again
	"Text substitution. If the left shift key is down, the substitution is made 
	throughout the entire Paragraph. Otherwise, only the next possible 
	substitution is made.
	Undoer & Redoer: #undoAgain:andReselect:typedKey:."

	"If last command was also 'again', use same keys as before"
	self againOrSame: (UndoMessage sends: #undoAgain:andReselect:typedKey:)! !

!ParagraphEditor methodsFor: 'private' stamp: 'AlainPlantec 12/10/2009 23:04'!
againOnce: indices
	"Find the next occurrence of FindText.  If none, answer false.
	Append the start index of the occurrence to the stream indices, and, if
	ChangeText is not the same object as FindText, replace the occurrence by it.
	Note that the search is case-sensitive for replacements, otherwise not."

	| where |
	where := paragraph text findString: FindText startingAt: self stopIndex
				caseSensitive: ((ChangeText ~~ FindText) or: [self caseSensitiveFinds]).
	where = 0 ifTrue: [^ false].
	self deselect; selectInvisiblyFrom: where to: where + FindText size - 1.
	ChangeText ~~ FindText ifTrue: [self zapSelectionWith: ChangeText].
	indices nextPut: where.
	self selectAndScroll.
	^ true! !

!ParagraphEditor methodsFor: 'private' stamp: 'StephaneDucasse 7/22/2011 16:31'!
againOrSame: useOldKeys
	"Subroutine of search: and again.  If useOldKeys, use same FindText and ChangeText as before.
	 1/26/96 sw: real worked moved to againOrSame:many:"

	^ self againOrSame: useOldKeys many: Sensor shiftPressed! !

!ParagraphEditor methodsFor: 'private' stamp: 'PeterHugossonMiller 9/3/2009 10:13'!
againOrSame: useOldKeys many: many
	"Subroutine of search: and again.  If useOldKeys, use same FindText and ChangeText as before.  If many is true, do it repeatedly.  Created 1/26/96 sw by adding the many argument to #againOrSame."

	|  home indices wasTypedKey |

	home := self selectionInterval.  "what was selected when 'again' was invoked"

	"If new keys are to be picked..."
	useOldKeys ifFalse: "Choose as FindText..."
		[FindText := UndoSelection.  "... the last thing replaced."
		"If the last command was in another paragraph, ChangeText is set..."
		paragraph == UndoParagraph ifTrue: "... else set it now as follows."
			[UndoInterval ~= home ifTrue: [self selectInterval: UndoInterval]. "blink"
			ChangeText := ((UndoMessage sends: #undoCutCopy:) and: [self hasSelection])
				ifTrue: [FindText] "== objects signal no model-locking by 'undo copy'"
				ifFalse: [self selection]]]. "otherwise, change text is last-replaced text"

	(wasTypedKey := FindText size = 0)
		ifTrue: "just inserted at a caret"
			[home := self selectionInterval.
			self replaceSelectionWith: self nullText.  "delete search key..."
			FindText := ChangeText] "... and search for it, without replacing"
		ifFalse: "Show where the search will start"
			[home last = self selectionInterval last ifFalse:
				[self selectInterval: home]].

	"Find and Change, recording start indices in the array"
	indices := (Array new: 20) writeStream. "an array to store change locs"
	[(self againOnce: indices) & many] whileTrue. "<-- this does the work"
	indices isEmpty ifTrue:  "none found"
		[self flash.
		wasTypedKey ifFalse: [^self]].

	(many | wasTypedKey) ifFalse: "after undo, select this replacement"
		[home := self startIndex to:
			self startIndex + UndoSelection size - 1].

	self undoer: #undoAgain:andReselect:typedKey: with: indices contents with: home with: wasTypedKey! !

!ParagraphEditor methodsFor: 'menu messages' stamp: ''!
align
	"Align text according to the next greater alignment value--cycling among 
	left flush, right flush, center, justified.  No effect on the undoability of the pre
	preceding command."

	paragraph toggleAlignment.
	paragraph displayOn: Display.
	self recomputeInterval! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:20'!
align: characterStream 
	"Triggered by Cmd-u;  cycle through alignment alternatives.  8/11/96 sw"

	self align.
	^ true! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:21'!
argAdvance: characterStream
	"Invoked by Ctrl-a.  Useful after Ctrl-q.
	 Search forward from the end of the selection for a colon followed by
		a space.  Place the caret after the space.  If none are found, place the
		caret at the end of the text.  Does not affect the undoability of the 
	 	previous command."

	| start |
	self closeTypeIn: characterStream.
	start := paragraph text findString: ': ' startingAt: self stopIndex.
	start = 0 ifTrue: [start := paragraph text size + 1].
	self selectAt: start + 2.
	^true! !

!ParagraphEditor methodsFor: 'settings' stamp: 'AlainPlantec 12/19/2009 23:50'!
autoIndent
	^ self class autoIndent! !

!ParagraphEditor methodsFor: 'typing support' stamp: 'yo 3/16/2004 13:05'!
backTo: startIndex
	"During typing, backspace to startIndex.  Deleted characters fall into three
	 clusters, from left to right in the text: (1) preexisting characters that were
	 backed over; (2) newly typed characters that were backed over (excluding
	 typeahead, which never even appears); (3) preexisting characters that
	 were highlighted before typing began.  If typing has not yet been opened,
	 open it and watch for the first and third cluster.  If typing has been opened,
	 watch for the first and second cluster.  Save characters from the first and third
	 cluster in UndoSelection.  Tally characters from the first cluster in UndoMessage's parameter.
	 Delete all the clusters.  Do not alter Undoer or UndoInterval (except via
	 openTypeIn).  The code is shorter than the comment."

	| saveLimit newBackovers |
	saveLimit := beginTypeInBlock == nil
		ifTrue: [self openTypeIn. UndoSelection := self nullText. self stopIndex]
		ifFalse: [self startOfTyping].
	self setMark: startIndex.
	startIndex < saveLimit ifTrue:
		[newBackovers := self startOfTyping - startIndex.
		beginTypeInBlock := self startIndex.
		UndoSelection replaceFrom: 1 to: 0 with:
			(paragraph text copyFrom: startIndex to: saveLimit - 1).
		UndoMessage argument: (UndoMessage argument ifNil: [1]) + newBackovers].
	self zapSelectionWith: self nullText.
	self unselect! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:21'!
backWord: characterStream 
	"If the selection is not a caret, delete it and leave it in the backspace buffer.
	 Else if there is typeahead, delete it.
	 Else, delete the word before the caret."

	| startIndex |
	characterStream isEmpty
		ifTrue:
			[self hasCaret
				ifTrue: "a caret, delete at least one character"
					[startIndex := 1 max: self markIndex - 1.
					[startIndex > 1 and:
						[(paragraph text at: startIndex - 1) asCharacter tokenish]]
						whileTrue:
							[startIndex := startIndex - 1]]
				ifFalse: "a non-caret, just delete it"
					[startIndex := self markIndex].
			self backTo: startIndex]
		ifFalse:
			[characterStream reset].
	^false! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'StephaneDucasse 7/22/2011 16:31'!
backspace: characterStream 
	"Backspace over the last character."

	| startIndex |
	Sensor shiftPressed ifTrue: [^ self backWord: characterStream].
	characterStream isEmpty
		ifTrue:
			[startIndex := self markIndex + (self hasCaret ifTrue: [0] ifFalse: [1]).
			startIndex := 1 max: startIndex - 1.
			self backTo: startIndex]
		ifFalse:
			[characterStream skip: -1].
	^false! !

!ParagraphEditor methodsFor: 'parenblinking' stamp: 'mir 8/3/2004 13:31'!
blinkParenAt: parenLocation 
	self text
		addAttribute: TextEmphasis bold
		from: parenLocation
		to: parenLocation.
	lastParentLocation := parenLocation.! !

!ParagraphEditor methodsFor: 'parenblinking' stamp: 'michael.rueger 2/23/2009 13:31'!
blinkPrevParen: openDelimiter
	| closeDelimiter level string here hereChar |
	string := paragraph text string.
	here := startBlock stringIndex.
	closeDelimiter := '([{' at: (')]}' indexOf: openDelimiter).
	level := 1.
	[level > 0 and: [here > 2]]
		whileTrue:
			[hereChar := string at: (here := here - 1).
			hereChar = closeDelimiter
				ifTrue:
					[level := level - 1.
					level = 0
						ifTrue: [^ self blinkParenAt: here]]
				ifFalse:
					[hereChar = openDelimiter
						ifTrue: [level := level + 1]]].! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sd 6/3/2010 12:57'!
browseIt
	"Launch a browser for the class indicated by the current selection. 
	If multiple classes matching the selection exist, let the user choose among them."
	| aClass |
	self lineSelectAndEmptyCheck: [^ self].
	aClass := SystemNavigation default
				classFromPattern: (self selection string copyWithoutAll: CharacterSet crlf)
				withCaption: 'choose a class to browse...'.
	aClass ifNil: [^ self internalCallToImplementorsOfIt].
	self terminateAndInitializeAround: [ | aBrow |
			aBrow := SystemBrowser default new.
			aBrow setClass: aClass selector: nil.
			aBrow class
				openBrowserView: (aBrow openEditString: nil)
				label: 'System Browser']! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'sd 5/24/2010 22:32'!
browseIt: characterStream 
	"Triggered by Cmd-B; browse the thing represented by the current selection, if plausible."

	self browseIt.
	^ true! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:31'!
browseItHere: characterStream 
	"Triggered by Cmd-shift-B; browse the thing represented by the current selection, if plausible, in the receiver's own window.  3/1/96 sw"

	self browseItHere.
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'alain.plantec 6/11/2008 15:00'!
cancel 
	"Restore the text of the paragraph to be the text saved since initialization 
	or the last accept.  Undoer & Redoer: undoAndReselect:redoAndReselect:.
	This used to call controlTerminate and controlInitialize but this seemed illogical.
	Sure enough, nobody overrode them who had cancel in the menu, and if
	anybody really cared they could override cancel."

	UndoSelection := paragraph text.
	self undoer: #undoAndReselect:redoAndReselect: with: self selectionInterval with: (1 to: 0).
	self changeParagraph: (paragraph text: initialText).
	UndoParagraph := paragraph.
	otherInterval := UndoInterval := 1 to: initialText size. "so undo will replace all"
	paragraph displayOn: Display.
	self selectAt: 1.
	self scrollToTop
! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:31'!
cancel: characterStream 
	"Cancel unsubmitted changes.  Flushes typeahead.  1/12/96 sw
	 1/22/96 sw: put in control terminate/init"

	self terminateAndInitializeAround: [self cancel].
	^ true! !

!ParagraphEditor methodsFor: 'settings' stamp: 'AlainPlantec 12/10/2009 23:04'!
caseSensitiveFinds
	^ self class caseSensitiveFinds! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'alain.plantec 2/6/2009 17:12'!
changeAlignment
	| aList reply  |
	aList := #(leftFlush centered justified rightFlush).
	reply := UIManager default chooseFrom: (aList collect: [:t | t translated]) values: aList.
	reply ifNil:[^self].
	self setAlignment: reply.
	paragraph composeAll.
	self recomputeSelection.
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'alain.plantec 2/6/2009 17:14'!
changeEmphasis
	| aList reply  |
	aList := #(normal bold italic narrow underlined struckOut).
	reply := UIManager default chooseFrom: (aList collect: [:t | t translated]) values: aList.
	reply ifNotNil: [
		self setEmphasis: reply.
		paragraph composeAll.
		self recomputeSelection].
	^ true! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'StephaneDucasse 7/22/2011 16:32'!
changeEmphasis: characterStream keyEvent: keyEvent
	"Change the emphasis of the current selection or prepare to
	accept characters with the change in emphasis. Emphasis
	change amounts to a font change. Keeps typeahead."
	
	| keyCode attribute oldAttributes index thisSel colors extras |

	"control 0..9 -> 0..9"
	keyCode := ('0123456789-=' indexOf: keyEvent keyCharacter ifAbsent: [1]) - 1.

	oldAttributes := paragraph text attributesAt: self pointIndex forStyle: paragraph textStyle.
	thisSel := self selection.

	"Decipher keyCodes for Command 0-9..."
	(keyCode between: 1 and: 5) ifTrue: [
		attribute := TextFontChange fontNumber: keyCode
	].

	keyCode = 6 ifTrue: [
		| labels lines | 
		colors := #(#black #magenta #red #yellow #green #blue #cyan #white ).
		extras := (self class name = #TextMorphEditor and: [(self morph isKindOf: TextMorphForEditView) not])
						ifTrue: ["not a system window" #()]
						ifFalse: [#('Link to comment of class' 'Link to definition of class' 'Link to hierarchy of class' 'Link to method' )].

		
		labels := colors , #('choose color...' 'Do it' 'Print it' ) , extras , #('be a web URL link' 'Edit hidden info' 'Copy hidden info' ).
		lines := Array with: colors size + 1.
		index := UIManager default chooseFrom: labels lines: lines.
		index = 0 ifTrue: [ ^ true].
			
		index <= colors size ifTrue: [
			attribute := TextColor color: (Color perform: (colors at: index))
		]
		ifFalse: [
			index := index - colors size - 1. "Re-number!!!!!!"

			index = 0 ifTrue: [
				attribute := self chooseColor
			].

			index = 1 ifTrue: [
				attribute := TextDoIt new.
				thisSel := attribute analyze: self selection asString
			].

			index = 2 ifTrue: [
				attribute := TextPrintIt new.
				thisSel := attribute analyze: self selection asString
			].

			extras size = 0 & (index > 2) ifTrue: [
				index := index + 4 "skip those"
			].

			index = 3 ifTrue: [
				attribute := TextLink new.
				thisSel := attribute analyze: self selection asString with: 'Comment'
			].

			index = 4 ifTrue: [
				attribute := TextLink new.
				thisSel := attribute analyze: self selection asString with: 'Definition'
			].

			index = 5 ifTrue: [
				attribute := TextLink new.
				thisSel := attribute analyze: self selection asString with: 'Hierarchy'
			].

			index = 6 ifTrue: [
				attribute := TextLink new.
				thisSel := attribute analyze: self selection asString
			].
		
			index = 7 ifTrue: [
				attribute := TextURL new.
				thisSel := attribute analyze: self selection asString
			].
		
			index = 8 ifTrue: [
				"Edit hidden info"
				thisSel := self hiddenInfo. "includes selection"
				attribute := TextEmphasis normal
			].

			index = 9 ifTrue: [
				"Copy hidden info"
				self copyHiddenInfo.
				^ true
			].
		
			"no other action"
			thisSel
				ifNil: [ ^ true ]
		]
	].

	(keyCode between: 7 and: 11) ifTrue: [
		keyEvent shiftPressed ifTrue: [
			keyCode = 10 ifTrue: [
				attribute := TextKern kern: -1
			].
			keyCode = 11 ifTrue: [
				attribute := TextKern kern: 1
			]
		]
		ifFalse: [
			attribute := TextEmphasis perform: (#(#bold #italic #narrow #underlined #struckOut ) at: keyCode - 6).
			oldAttributes
						do: [:att | (att dominates: attribute) ifTrue: [attribute turnOff]]
		]
	].

	keyCode = 0
		ifTrue: [attribute := TextEmphasis normal].

	beginTypeInBlock ~~ nil ifTrue: [
		"only change emphasisHere while typing"
		self insertTypeAhead: characterStream.
		emphasisHere := Text addAttribute: attribute toArray: oldAttributes.
		^ true
	].

	self
		replaceSelectionWith: (thisSel asText addAttribute: attribute).
		
	^ true
! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'alain.plantec 2/6/2009 17:15'!
changeEmphasisOrAlignment
	| aList reply  |
	aList := #(normal bold italic narrow underlined struckOut leftFlush centered rightFlush justified).
	reply := UIManager default chooseFrom: (aList collect: [:t | t translated]) values: aList lines: #(6).
	reply ~~ nil ifTrue:
		[(#(leftFlush centered rightFlush justified) includes: reply)
			ifTrue:
				[paragraph perform: reply.
				self recomputeInterval]
			ifFalse:
				[self setEmphasis: reply.
				paragraph composeAll.
				self recomputeSelection.
				]].
	^ true! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'nice 11/30/2009 22:31'!
changeLfToCr: characterStream 
	"Replace all LFs by CRs, and CR-LF pairs by single CRs.
	Triggered by Cmd-U -- useful when getting code from FTP sites"

	self replaceSelectionWith: (Text fromString:
		self selection string withSqueakLineEndings).
	^ true! !

!ParagraphEditor methodsFor: 'initialize-release' stamp: ''!
changeParagraph: aParagraph 
	"Install aParagraph as the one to be edited by the receiver."

	UndoParagraph == paragraph ifTrue: [UndoParagraph := nil].
	paragraph := aParagraph.
	self resetState! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'alain.plantec 2/6/2009 17:16'!
changeStyle
	"Let user change styles for the current text pane  
	 Moved from experimentalCommand to its own method  "

	| aList reply style |
	aList := StrikeFont actualFamilyNames.
	aList addFirst: 'DefaultTextStyle'.
	reply := UIManager default chooseFrom: aList values: aList lines: #(1).
	reply ifNotNil:
		[(style := TextStyle named: reply) ifNil: [Beeper beep. ^ true].
		paragraph textStyle: style copy.
		paragraph composeAll.
		self recomputeSelection.
		].
	^ true! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:32'!
changeStyle: characterStream 
	"Put up the style-change menu"

	self closeTypeIn: characterStream.
	self changeStyle.
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'RAA 3/15/2001 12:10'!
changeStyleTo: aNewStyle

	paragraph textStyle: aNewStyle.
	paragraph composeAll.
	self recomputeSelection.
! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sw 9/27/1999 11:54'!
chooseAlignment
	self changeAlignment! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'tk 5/7/2001 09:11'!
chooseColor
	"Make a new Text Color Attribute, let the user pick a color, and return the attribute.  This is the non-Morphic version."

	^ TextColor color: (Color fromUser)! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sd 4/15/2003 22:40'!
classCommentsContainingIt
	"Open a browser class comments which contain the current selection somewhere in them."

	self lineSelectAndEmptyCheck: [^ self].
	self terminateAndInitializeAround: [
		self systemNavigation browseClassCommentsWithString: self selection string]! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'StephaneDucasse 7/22/2011 16:32'!
classNamesContainingIt
	"Open a browser on classes whose names contain the selected string"

	self lineSelectAndEmptyCheck: [^self].
	self systemNavigation 
		browseClassesWithNamesContaining: self selection string
		caseSensitive: Sensor shiftPressed! !

!ParagraphEditor methodsFor: 'parenblinking' stamp: 'mir 8/3/2004 13:31'!
clearParens
	lastParentLocation ifNotNil:
		[self text string size >= lastParentLocation ifTrue: [
			self text
				removeAttribute: TextEmphasis bold
				from: lastParentLocation
				to: lastParentLocation]]
! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'ar 1/15/2001 18:37'!
clipboardText

	^ Clipboard clipboardText! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'ar 1/15/2001 18:38'!
clipboardText: text

	^ Clipboard clipboardText: text! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'ar 1/15/2001 18:38'!
clipboardTextPut: text

	^ Clipboard clipboardText: text! !

!ParagraphEditor methodsFor: 'typing support' stamp: 'th 9/19/2002 17:40'!
closeTypeIn
	"See comment in openTypeIn.  It is important to call closeTypeIn before executing
	 any non-typing key, making a new selection, etc.  It is called automatically for
	 menu commands.
	 Typing commands can call 'closeTypeIn: aCharacterStream' instead of this to
	 save typeahead.  Undoer & Redoer: undoAndReselect:redoAndReselect:."

	| begin stop |
	beginTypeInBlock == nil ifFalse:
		[(UndoMessage sends: #noUndoer) ifTrue: "should always be true, but just in case..."
			[begin := self startOfTyping.
			stop := self stopIndex.
			self undoer: #undoAndReselect:redoAndReselect:
				with: (begin + UndoMessage argument to: begin + UndoSelection size - 1)
				with: (stop to: stop - 1).
			UndoInterval := begin to: stop - 1].
		beginTypeInBlock := nil]! !

!ParagraphEditor methodsFor: 'typing support' stamp: ''!
closeTypeIn: characterStream
	"Call instead of closeTypeIn when you want typeahead to be inserted before the
	 control character is executed, e.g., from Ctrl-V."

	self insertTypeAhead: characterStream.
	self closeTypeIn! !

!ParagraphEditor methodsFor: 'settings' stamp: 'AlainPlantec 12/19/2009 23:52'!
cmdKeysInText
	^ self class cmdKeysInText! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'th 1/21/2000 18:51'!
comment
	"All key actions that are neither editing nor typing actions have to
	send closeTypeIn at first. See comment in openTypeIn closeTypeIn"! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'di 11/23/1998 15:21'!
compareToClipboard
	"Check to see if whether the receiver's text is the same as the text currently on the clipboard, and inform the user."
	| s1 s2 |
	s1 := self clipboardText string.
	s2 := paragraph text string.
	s1 = s2 ifTrue: [^ self inform: 'Exact match'].

	(StringHolder new textContents:
		(TextDiffBuilder buildDisplayPatchFrom: s1 to: s2))
		openLabel: 'Comparison to Clipboard Text'! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:32'!
compareToClipboard: characterStream 
	"Compare the receiver to the text on the clipboard.  Flushes typeahead.  5/1/96 sw"

	self terminateAndInitializeAround: [self compareToClipboard].
	^ true! !

!ParagraphEditor methodsFor: 'watchIt' stamp: 'StephaneDucasse 3/1/2011 19:40'!
compileSelectionAsBlock
	"Treat the current selection as an expression; evaluate it and return the result"
	
	| stream result rcvr ctxt |
	self lineSelectAndEmptyCheck: [^ ''].

	stream := ReadWriteStream on: (String new: (startBlock stringIndex) - (stopBlock stringIndex) + 2).
	stream nextPutAll: '[[ '.
	stream next: ((startBlock stringIndex) - (stopBlock stringIndex))
		putAll: paragraph string
		startingAt: stopBlock stringIndex.
	stream nextPutAll: ' ] on: Error do: [ :ex | ex ]]'.
	stream reset.

	(model respondsTo: #doItReceiver) 
		ifTrue: [
				rcvr := model doItReceiver.
				ctxt := model doItContext]
		ifFalse: [rcvr := ctxt := nil].
	result := [
		rcvr class evaluatorClass new 
			evaluate: stream
			in: ctxt
			to: rcvr
			notifying: self
			ifFail: [ ^ #failedDoit]
	] 
		on: OutOfScopeNotification 
		do: [ :ex | ex resume: true].
	^ result! !

!ParagraphEditor methodsFor: 'do-its' stamp: 'jb 7/1/2011 10:53'!
compileSelectionFor: anObject in: evalContext

	| methodNode |
	methodNode := [self class evaluatorClass new
		compileNoPattern: self selectionAsStream
		in: anObject class
		context: evalContext
		notifying: self
		ifFail: [^nil]]
			on: OutOfScopeNotification
			do: [:ex | ex resume: true].

	^ methodNode generateWithTempNames.
! !

!ParagraphEditor methodsFor: 'private' stamp: 'PeterHugossonMiller 9/3/2009 10:14'!
completeSymbol: hintText lastOffering: selectorOrNil
	"Invoked by Ctrl-q when there is only a caret.
		Do selector-completion, i.e., try to replace the preceding identifier by a
		selector that begins with those characters & has as many keywords as possible.
	 	Leave two spaces after each colon (only one after the last) as space for
		arguments.  Put the caret after the space after the first keyword.  If the
		user types Ctrl-q again immediately, choose a different selector.
	 Undoer: #undoQuery:lastOffering:; Redoer: itself.
	If redoing, just redisplay the last offering, selector[OrNil]."

	| firstTime input prior caret newStart sym kwds outStream |
	firstTime := self isRedoing
		ifTrue: [prior := sym := selectorOrNil. true]
		ifFalse: [hintText isNil].
	firstTime
		ifTrue: "Initial Ctrl-q (or redo)"					
			[caret := self startIndex.
			self selectPrecedingIdentifier.
			input := self selection]
		ifFalse: "Repeated Ctrl-q"
			[caret := UndoInterval first + hintText size.
			self selectInvisiblyFrom: UndoInterval first to: UndoInterval last.
			input := hintText.
			prior := selectorOrNil].
	(input size ~= 0 and: [sym ~~ nil or:
			[(sym := Symbol thatStarts: input string skipping: prior) ~~ nil]])
		ifTrue: "found something to offer"
			[newStart := self startIndex.
			outStream := (String new: 2 * sym size) writeStream.
			1 to: (kwds := sym keywords) size do:
				[:i |
				outStream nextPutAll: (kwds at: i).
				i = 1 ifTrue: [caret := newStart + outStream contents size + 1].
				outStream nextPutAll:
					(i < kwds size ifTrue: ['  '] ifFalse: [' '])].
			UndoSelection := input.
			self deselect; zapSelectionWith: outStream contents asText.
			self undoer: #undoQuery:lastOffering: with: input with: sym]
		ifFalse: "no more matches"
			[firstTime ifFalse: "restore original text & set up for a redo"
				[UndoSelection := self selection.
				self deselect; zapSelectionWith: input.
				self undoer: #completeSymbol:lastOffering: with: input with: prior.
				Undone := true].
			self flash].
	self selectAt: caret! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'th 9/17/2002 16:11'!
computeIntervalFrom: start to: stop
	"Select the designated characters, inclusive.  Make no visual changes."

	self setMark: start.
	self setPoint: stop + 1.! !

!ParagraphEditor methodsFor: 'controlling' stamp: ''!
controlInitialize

	super controlInitialize.
	self recomputeInterval.
	self initializeSelection.
	beginTypeInBlock := nil! !

!ParagraphEditor methodsFor: 'controlling' stamp: ''!
controlTerminate

	self closeTypeIn.  "Must call to establish UndoInterval"
	super controlTerminate.
	self deselect! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'tk 5/7/2001 08:47'!
copyHiddenInfo
	"In TextLinks, TextDoits, TextColor, and TextURLs, there is hidden
info.  Copy that to the clipboard.  You can paste it and see what it is.
Usually enclosed in <>."

	^ self clipboardTextPut: self hiddenInfo asText! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sw 8/1/97 15:09'!
copySelection
	"Copy the current selection and store it in the paste buffer, unless a caret.  Undoer & Redoer: undoCutCopy"

	self lineSelectAndEmptyCheck: [^ self].

	"Simulate 'substitute: self selection' without locking the controller"
	UndoSelection := self selection.
	self undoer: #undoCutCopy: with: self clipboardText.
	UndoInterval := self selectionInterval.
	self clipboardTextPut: UndoSelection! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:32'!
copySelection: characterStream 
	"Copy the current text selection.  Flushes typeahead."

	self copySelection.
	^true! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'di 5/6/1998 15:21'!
correctFrom: start to: stop with: aString
	"Make a correction in the model that the user has authorised from somewhere else in the system (such as from the compilier).  The user's selection is not changed, only corrected."
	| wasShowing userSelection delta loc |
	aString = '#insert period' ifTrue:
		[loc := start.
		[(loc := loc-1)>0 and: [(paragraph text string at: loc) isSeparator]]
			whileTrue: [loc := loc-1].
		^ self correctFrom: loc+1 to: loc with: '.'].
	(wasShowing := selectionShowing) ifTrue: [ self reverseSelection ].
	userSelection := self selectionInterval.

	self selectInvisiblyFrom: start to: stop.
	self replaceSelectionWith: aString asText.

	delta := aString size - (stop - start + 1).
	self selectInvisiblyFrom:
		userSelection first + (userSelection first > start ifFalse: [ 0 ] ifTrue: [ delta ])
		to: userSelection last + (userSelection last > start ifFalse: [ 0 ] ifTrue: [ delta ]).
	wasShowing ifTrue: [ self reverseSelection ].
! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:32'!
crWithIndent: characterStream 
	"Replace the current text selection with CR followed by as many tabs
	as on the current line (+/- bracket count) -- initiated by Shift-Return."
	| char s i tabCount |
	s := paragraph string.
	i := self stopIndex.
	tabCount := 0.
	[(i := i-1) > 0 and: [(char := s at: i) ~= Character cr]]
		whileTrue:  "Count tabs and brackets (but not a leading bracket)"
		[(char = Character tab and: [i < s size and: [(s at: i+1) ~= $[ ]]) ifTrue: [tabCount := tabCount + 1].
		char = $[ ifTrue: [tabCount := tabCount + 1].
		char = $] ifTrue: [tabCount := tabCount - 1]].
	characterStream crtab: tabCount.  "Now inject CR with tabCount tabs"
	^ false! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'th 11/18/2002 17:08'!
cursorDown: characterStream 

	"Private - Move cursor from position in current line to same position in
	next line. If next line too short, put at end. If shift key down,
	select."
	self closeTypeIn: characterStream.
	self 
		moveCursor:[:position | self
				sameColumn: position
				newLine:[:line | line + 1]
				forward: true]
		forward: true
		specialBlock:[:dummy | dummy].
	^true! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'AlainPlantec 12/11/2009 13:38'!
cursorEnd: characterStream 

	"Private - Move cursor end of current line."
	| string |
	self closeTypeIn: characterStream.
	string := paragraph text string.
	self
		moveCursor:
			[:position | self walkAlongDisplayedLine
				ifTrue:[| targetLine |
					targetLine := paragraph lines at:(paragraph lineIndexOfCharacterIndex: position).
					targetLine = paragraph lines last
						ifTrue:[targetLine last + 1]
						ifFalse:[targetLine last]]
				ifFalse:[
					string
						indexOfAnyOf: CharacterSet crlf
						startingAt: position
						ifAbsent:[string size + 1]]]
		forward: true
		specialBlock:[:dummy | string size + 1].
	^true! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'AlainPlantec 12/11/2009 13:38'!
cursorHome: characterStream 

	"Private - Move cursor from position in current line to beginning of
	current line. If control key is pressed put cursor at beginning of text"

	| string |

	string := paragraph text string.
	self
		moveCursor: [ :position | self walkAlongDisplayedLine
				ifTrue:[
					(paragraph lines at:(paragraph lineIndexOfCharacterIndex: position)) first]
				ifFalse:[
					(string
						lastIndexOfAnyOf: CharacterSet crlf
						startingAt: position - 1
						ifAbsent:[0]) + 1]]
		forward: false
		specialBlock: [:dummy | 1].
	^true! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'th 9/19/2002 20:07'!
cursorLeft: characterStream 
	"Private - Move cursor left one character if nothing selected, otherwise 
	move cursor to beginning of selection. If the shift key is down, start 
	selecting or extending current selection. Don't allow cursor past 
	beginning of text"

	self closeTypeIn: characterStream.
	self
		moveCursor:[:position | position - 1 max: 1]
		forward: false
		specialBlock:[:position | self previousWord: position].
	^ true! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'th 11/18/2002 17:09'!
cursorPageDown: characterStream 

	self closeTypeIn: characterStream.
	self 
		moveCursor: [:position |
			self
				sameColumn: position
				newLine:[:lineNo | lineNo + self pageHeight]
				forward: true]
		forward: true
		specialBlock:[:dummy | dummy].
	^true! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'th 11/18/2002 17:09'!
cursorPageUp: characterStream 

	self closeTypeIn: characterStream.
	self 
		moveCursor: [:position |
			self
				sameColumn: position
				newLine:[:lineNo | lineNo - self pageHeight]
				forward: false]
		forward: false
		specialBlock:[:dummy | dummy].
	^true! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'th 9/19/2002 20:01'!
cursorRight: characterStream 
	"Private - Move cursor right one character if nothing selected, 
	otherwise move cursor to end of selection. If the shift key is down, 
	start selecting characters or extending already selected characters. 
	Don't allow cursor past end of text"

	self closeTypeIn: characterStream.
	self
		moveCursor: [:position | position + 1]
		forward: true
		specialBlock:[:position | self nextWord: position].
	^ true! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:32'!
cursorTopHome: characterStream 
	"Put cursor at beginning of text -- invoked from cmd-H shortcut, useful for keyboards that have no home key."
	
	self selectAt: 1.
	^ true! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'th 11/18/2002 17:15'!
cursorUp: characterStream 

"Private - Move cursor from position in current line to same position in
prior line. If prior line too short, put at end"

	self closeTypeIn: characterStream.
	self
		moveCursor: [:position | self
				sameColumn: position
				newLine:[:line | line - 1]
				forward: false]
		forward: false
		specialBlock:[:dummy | dummy].
	^true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sw 8/1/97 16:33'!
cut
	"Cut out the current selection and redisplay the paragraph if necessary.  Undoer & Redoer: undoCutCopy:"

	self lineSelectAndEmptyCheck: [^ self].

	self replaceSelectionWith: self nullText. 
	self undoer: #undoCutCopy: with: self clipboardText.
	self clipboardTextPut: UndoSelection! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:33'!
cut: characterStream 
	"Cut out the current text selection.  Flushes typeahead."

	self cut.
	^true! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 3/23/2009 17:48'!
debugIt: characterStream 
	"Triggered by Cmd-D; browse the thing represented by the current selection, if plausible"

	self debugIt.
	^ true! !

!ParagraphEditor methodsFor: 'current selection' stamp: ''!
deselect
	"If the text selection is visible on the screen, reverse its highlight."

	selectionShowing ifTrue: [self reverseSelection]! !

!ParagraphEditor methodsFor: 'typing support' stamp: 'michael.rueger 2/23/2009 13:24'!
dispatchOnEnterWith: typeAheadStream
	"Enter key hit.  Treat is as an 'accept', viz a synonym for cmd-s.  If cmd key is down, treat is as a synonym for print-it. "

	self terminateAndInitializeAround: [
	Sensor commandKeyPressed
		ifTrue:
			[self printIt.]
		ifFalse: 
			[self closeTypeIn: typeAheadStream.
			self accept].
	].
	^ true! !

!ParagraphEditor methodsFor: 'typing support' stamp: 'StephaneDucasse 7/22/2011 16:32'!
dispatchOnKeyEvent: keyEvent with: typeAheadStream
	"Carry out the action associated with this character, if any.
	Type-ahead is passed so some routines can flush or use it."

	| honorCommandKeys keyValue keyChar char action charCode |
	self clearParens.
	keyValue := OSPlatform current virtualKey: keyEvent scanCode.
  	keyValue := keyValue ifNil: [keyEvent keyValue].
	"Work around bug in some VMs delivering negative key values"
	keyChar := (keyValue max: 0) asCharacter.
	char := keyEvent keyCharacter.
	charCode := char asUnicode.
	
	"mikki 1/3/2005 21:31 Preference for auto-indent on return added."
	keyChar = Character cr ifTrue: [
		^(self autoIndent
			xor: keyEvent controlKeyPressed)
			ifTrue: [self crWithIndent: typeAheadStream]
			ifFalse: [self normalCharacter: typeAheadStream character: char]].

	((honorCommandKeys := self cmdKeysInText)
		and: [keyChar = Character enter])
		ifTrue: [^ self dispatchOnEnterWith: typeAheadStream].
		
	(0 <= charCode and: [charCode < 256]) ifTrue: [	"none of the following is safe if the character's asciiValue is out of the 0..255 range"
		
	"Special keys overwrite crtl+key combinations - at least on Windows. To resolve this
	conflict, assume that keys other than cursor keys aren't used together with Crtl." 
	((self class specialShiftCmdKeys includes: keyValue) and: [keyValue < 27])
		ifTrue: [
			action := keyEvent controlKeyPressed
				ifTrue: [ShiftCmdActions at: keyValue + 1]
				ifFalse: [CmdActions at: keyValue + 1].
			^action numArgs = 1
				ifTrue: [self perform: action with: typeAheadStream]
				ifFalse: [self perform: action with: keyEvent with: typeAheadStream]].

	"backspace, and escape keys (ascii 8 and 27) are command keys"
	((honorCommandKeys and: [keyEvent commandKeyPressed]) or: [self class specialShiftCmdKeys includes: keyValue])
		ifTrue: [
			action := keyEvent shiftPressed
					ifTrue: [ShiftCmdActions at: keyValue + 1]
					ifFalse: [CmdActions at: keyValue + 1].
			^action numArgs = 1
				ifTrue: [self perform: action with: typeAheadStream]
				ifFalse: [self perform: action with: typeAheadStream with: keyEvent]].

	"the control key can be used to invoke shift-cmd shortcuts"
	(honorCommandKeys and: [keyEvent controlKeyPressed])
		ifTrue: [
			action := ShiftCmdActions at: keyValue + 1.
			^action numArgs = 1
				ifTrue: [self perform: action with: typeAheadStream]
				ifFalse: [self perform: action with: typeAheadStream with: keyEvent]].
	
	"allow cut/copy/paste/selectAll regardless of cmdKeysInText preference.
	Useful when running a deployed/locked-down image (after disableProgrammerFacilities)."
	((#(cut: copySelection: paste: selectAll:) includes: (CmdActions at: keyValue + 1)) 
		and: [keyEvent commandKeyPressed])
		ifTrue: [
			action := CmdActions at: keyValue + 1.
			^action numArgs = 1
				ifTrue: [self perform: action with: typeAheadStream]
				ifFalse: [self perform: action with: typeAheadStream with: keyEvent]].
	]. "end of range protection"

	(')]}' includes: char)
		ifTrue: [self blinkPrevParen: char].

	^self normalCharacter: typeAheadStream character: char! !

!ParagraphEditor methodsFor: 'displaying' stamp: 'GuillermoPolito 5/24/2010 14:31'!
display
	"Redisplay the paragraph."

	| selectionState view |
	selectionState := selectionShowing.
	self deselect.
	paragraph foregroundColor: view foregroundColor
			backgroundColor: view backgroundColor;
			displayOn: Display.
	selectionState ifTrue: [self select]! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:33'!
displayIfFalse: characterStream 
	"Replace the current text selection with the text 'ifFalse:'--initiated by 
	ctrl-f."

	characterStream nextPutAll: 'ifFalse:'.
	^false! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:33'!
displayIfTrue: characterStream 
	"Replace the current text selection with the text 'ifTrue:'--initiated by 
	ctrl-t."

	characterStream nextPutAll: 'ifTrue:'.
	^false! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:33'!
doAgainMany: characterStream 
	"Do the previous thing again repeatedly. 1/26/96 sw"

	self closeTypeIn: characterStream.
	self againOrSame: (UndoMessage sends: #undoAgain:andReselect:typedKey:) many: true.
	^ true! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:33'!
doAgainOnce: characterStream 
	"Do the previous thing again once. 1/26/96 sw"

	self closeTypeIn: characterStream.
	self again.
	^ true! !

!ParagraphEditor methodsFor: 'do-its' stamp: 'di 5/10/1998 21:38'!
doIt
	"Set the context to include pool vars of the model.  Then evaluate."
	^ self evaluateSelection.
! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:33'!
doIt: characterStream 
	"Called when user hits cmd-d.  Select the current line, if relevant, then evaluate and execute.  2/1/96 sw.
	2/29/96 sw: don't call selectLine; it's done by doIt now"

	self terminateAndInitializeAround: [self doIt].
	^ true! !

!ParagraphEditor methodsFor: 'typing support' stamp: 'di 6/14/1998 13:08'!
doneTyping
	beginTypeInBlock := nil! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:33'!
duplicate: characterStream
	"Paste the current selection over the prior selection, if it is non-overlapping and
	 legal.  Flushes typeahead.  Undoer & Redoer: undoAndReselect."

	self closeTypeIn.
	(self hasSelection and: [self isDisjointFrom: otherInterval])
		ifTrue: "Something to duplicate"
			[self replace: otherInterval with: self selection and:
				[self selectAt: self pointIndex]]
		ifFalse:
			[self flash].
	^true! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 13:25'!
enclose: characterStream keyEvent: keyEvent
	"Insert or remove bracket characters around the current selection.
	 Flushes typeahead."

	| char left right startIndex stopIndex oldSelection which text |
	char := keyEvent keyCharacter.
	self closeTypeIn.
	startIndex := self startIndex.
	stopIndex := self stopIndex.
	oldSelection := self selection.
	which := '([<{"''' indexOf: char ifAbsent: [ ^true ].
	left := '([<{"''' at: which.
	right := ')]>}"''' at: which.
	text := paragraph text.
	((startIndex > 1 and: [stopIndex <= text size])
		and:
		[(text at: startIndex-1) = left and: [(text at: stopIndex) = right]])
		ifTrue:
			["already enclosed; strip off brackets"
			self selectFrom: startIndex-1 to: stopIndex.
			self replaceSelectionWith: oldSelection]
		ifFalse:
			["not enclosed; enclose by matching brackets"
			self replaceSelectionWith:
				(Text string: (String with: left), oldSelection string ,(String with: right)
					emphasis: emphasisHere).
			self selectFrom: startIndex+1 to: stopIndex].
	^true! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'nice 11/16/2009 14:41'!
encompassLine: anInterval
	"Return an interval that encompasses the entire line"
	| string left right |
	string := paragraph text string.
	left := (string lastIndexOfAnyOf: CharacterSet crlf startingAt: anInterval first - 1 ifAbsent:[0]) + 1.
	right := (string indexOfAnyOf: CharacterSet crlf startingAt: anInterval last + 1 ifAbsent: [string size + 1]) - 1.
	^left to: right! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'AlainPlantec 2/17/2010 01:53'!
escapeToDesktop: characterStream 
	"Pop up a morph to field keyboard input in the context of the desktop"

	ActiveWorld invokeWorldMenuFromEscapeKey.
	^ true! !

!ParagraphEditor methodsFor: 'do-its' stamp: 'nice 3/31/2011 21:51'!
evaluateSelection
	"Treat the current selection as an expression; evaluate it and return the result"
	
	^self evaluateSelectionAndDo: [:result | result]! !

!ParagraphEditor methodsFor: 'do-its' stamp: 'nice 3/31/2011 21:56'!
evaluateSelectionAndDo: aBlock
	"Treat the current selection as an expression; evaluate it and invoke aBlock with the result."
	| result rcvr ctxt |
	self lineSelectAndEmptyCheck: [^ nil].

	(model respondsTo: #doItReceiver) 
		ifTrue: [ rcvr := model doItReceiver.
				ctxt := model doItContext]
		ifFalse: [rcvr := ctxt := nil].
	result := [
		rcvr class evaluatorClass new 
			evaluate: self selectionAsStream
			in: ctxt
			to: rcvr
			notifying: self
			ifFail: [self flash. ^nil]
			logged: true.
	] 
		on: OutOfScopeNotification 
		do: [ :ex | ex resume: true].
	^aBlock value: result! !

!ParagraphEditor methodsFor: 'menu messages' stamp: ''!
exchange
	"See comment in exchangeWith:"

	self exchangeWith: otherInterval! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:34'!
exchange: characterStream
	"Exchange the current and prior selections.  Keeps typeahead."

	self closeTypeIn: characterStream.
	self exchange.
	^true! !

!ParagraphEditor methodsFor: 'private' stamp: 'alain.plantec 6/11/2008 15:06'!
exchangeWith: prior
	"If the prior selection is non-overlapping and legal, exchange the text of
	 it with the current selection and leave the currently selected text selected
	 in the location of the prior selection (or leave a caret after a non-caret if it was
	 exchanged with a caret).  If both selections are carets, flash & do nothing.
	 Don't affect the paste buffer.  Undoer: itself; Redoer: Undoer."

	| start stop before selection priorSelection delta altInterval |
	start := self startIndex.
	stop := self stopIndex - 1.
	((prior first <= prior last) | (start <= stop) "Something to exchange" and:
			[self isDisjointFrom: prior])
		ifTrue:
			[before := prior last < start.
			selection := self selection.
			priorSelection := paragraph text copyFrom: prior first to: prior last.

			delta := before ifTrue: [0] ifFalse: [priorSelection size - selection size].
			self zapSelectionWith: priorSelection.
			self selectFrom: prior first + delta to: prior last + delta.

			delta := before ifTrue: [stop - prior last] ifFalse: [start - prior first].
			self zapSelectionWith: selection.
			altInterval := prior first + delta to: prior last + delta.
			self undoer: #exchangeWith: with: altInterval.
			"If one was a caret, make it otherInterval & leave the caret after the other"
			prior first > prior last ifTrue: [self selectAt: UndoInterval last + 1].
			otherInterval := start > stop
				ifTrue: [self selectAt: altInterval last + 1. UndoInterval]
				ifFalse: [altInterval]]
		ifFalse:
			[self flash]! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sma 5/28/2000 09:34'!
experimentalCommand
	"Use for experimental command-key implementation.  Using this, 
	you can try things out without forever needing to reinitialize the 
	ParagraphEditor."

	self prettyPrint.
	^ true! !

!ParagraphEditor methodsFor: 'do-its' stamp: 'nice 3/31/2011 22:39'!
exploreIt
	self evaluateSelectionAndDo: [:result | result explore].
! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:34'!
exploreIt: characterStream 
	"Explore the selection -- invoked via cmd-shift-I.  If there is no current selection, use the current line."

	self terminateAndInitializeAround: [self exploreIt].
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'di 9/7/1999 08:41'!
fileItIn
	"Make a Stream on the text selection and fileIn it.
	 1/24/96 sw: moved here from FileController; this function can be useful from any text window that shows stuff in chunk format"

	| selection |
	selection := self selection.
	self terminateAndInitializeAround:
		[(ReadWriteStream on: selection string from: 1 to: selection size) fileIn].
! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:34'!
fileItIn: characterStream 
	"File in the selection; invoked via a keyboard shortcut, -- for now, cmd-shift-G."

	self terminateAndInitializeAround: [self fileItIn].
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'DamienCassou 9/29/2009 13:05'!
find
	"Prompt the user for a string to search for, and search the receiver from the current selection onward for it.  1/26/96 sw"

	| reply |
	reply := UIManager default request: 'Find what? ' translated initialAnswer: ''.
	reply isEmptyOrNil ifTrue: [^ self].
	self setSearch: reply.
	ChangeText := FindText.  "Implies no replacement to againOnce: method"
	self againOrSame: true
	
! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:34'!
find: characterStream
	"Prompt the user for what to find, then find it, searching from the current selection onward.  1/24/96 sw"

	self closeTypeIn: characterStream.
	self find.
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: ''!
findAgain
	"Find the text-to-find again.  1/24/96 sw"

	self againOrSame: true! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:34'!
findAgain: characterStream 
	"Find the desired text again.  1/24/96 sw"

	self closeTypeIn: characterStream.
	self findAgain.
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: ''!
fit
	"Make the bounding rectangle of the paragraph contain all the text while 
	 not changing the width of the view of the paragraph.  No effect on undoability
	 of the preceding command."

	paragraph clearVisibleRectangle.
	paragraph fit.
	paragraph displayOn: Display; outline.
	self recomputeInterval! !

!ParagraphEditor methodsFor: 'displaying' stamp: ''!
flash
	"Causes the view of the paragraph to complement twice in succession."

	paragraph flash! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'StephaneDucasse 7/22/2011 16:32'!
forwardDelete: characterStream keyEvent: keyEvent
	"Delete forward over the next character.
	  Make Undo work on the whole type-in, not just the one char.
	wod 11/3/1998: If there was a selection use #zapSelectionWith: rather than #backspace: which was 'one off' in deleting the selection. Handling of things like undo or typeIn area were not fully considered."
	| startIndex usel upara uinterval ind stopIndex |
	startIndex := self mark.
	startIndex > paragraph text size
		ifTrue: [^ false].
	self hasSelection ifTrue:
		["there was a selection"
		self zapSelectionWith: self nullText.
		^ false].
	"Null selection - do the delete forward"
	beginTypeInBlock == nil	"no previous typing.  openTypeIn"
		ifTrue: [self openTypeIn. UndoSelection := self nullText].
	uinterval := UndoInterval deepCopy.
	upara := UndoParagraph deepCopy.
	stopIndex := startIndex.
	(keyEvent keyValue = 127 and: [keyEvent shiftPressed])
		ifTrue: [stopIndex := (self nextWord: stopIndex) - 1].
	self selectFrom: startIndex to: stopIndex.
	self replaceSelectionWith: self nullText.
	self selectFrom: startIndex to: startIndex-1.
	UndoParagraph := upara.  UndoInterval := uinterval.
	UndoMessage selector == #noUndoer ifTrue: [
		(UndoSelection isText) ifTrue: [
			usel := UndoSelection.
			ind := startIndex. "UndoInterval startIndex"
			usel replaceFrom: usel size + 1 to: usel size with:
				(UndoParagraph text copyFrom: ind to: ind).
			UndoParagraph text replaceFrom: ind to: ind with:
self nullText]].
	^false! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/19/2002 18:22'!
hasCaret
	^self markBlock = self pointBlock! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/19/2002 18:22'!
hasSelection
	^self hasCaret not! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'th 9/18/2002 16:31'!
hiddenInfo
	"In TextLinks, TextDoits, TextColor, and TextURLs, there is hidden info.  Return the entire string that was used by Cmd-6 to create this text attribute.  Usually enclosed in < >."

	| attrList |
	attrList := paragraph text attributesAt: (self pointIndex +
self markIndex)//2 forStyle: paragraph textStyle.
	attrList do: [:attr |
		(attr isKindOf: TextAction) ifTrue:
			[^ self selection asString, '<', attr info, '>']].
	"If none of the above"
	attrList do: [:attr |
		attr class == TextColor ifTrue:
			[^ self selection asString, '<', attr color printString, '>']].
	^ self selection asString, '[No hidden info]'! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sd 6/3/2010 12:58'!
implementorsOfIt
	"Open an implementors browser on the selected selector"

	| aSelector |
	self lineSelectAndEmptyCheck: [^ self].
	(aSelector := self selectedSelector) == nil ifTrue: [^ self flash].
	self terminateAndInitializeAround: 
		[ (self systemNavigation allImplementorsOf: aSelector) isEmpty
				ifTrue: [self internalCallToBrowseIt]
				ifFalse: [ self systemNavigation browseAllImplementorsOf: aSelector]]! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'sd 5/24/2010 22:40'!
implementorsOfIt: characterStream 
	"Triggered by Cmd-m; browse implementors of the selector represented by the current selection, if plausible."

	self implementorsOfIt.
	^ true! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'nice 11/30/2009 22:33'!
inOutdent: characterStream delta: delta
	"Add/remove a tab at the front of every line occupied by the selection. Flushes typeahead.  Derived from work by Larry Tesler back in December 1985.  Now triggered by Cmd-L and Cmd-R.  2/29/96 sw"

	| realStart realStop lines startLine stopLine start stop adjustStart indentation size numLines inStream newString outStream |

	"Operate on entire lines, but remember the real selection for re-highlighting later"
	realStart := self startIndex.
	realStop := self stopIndex - 1.

	"Special case a caret on a line of its own, including weird case at end of paragraph"
	(realStart > realStop and:
				[realStart < 2 or: [(paragraph string at: realStart - 1) == Character cr or: [(paragraph string at: realStart - 1) == Character lf]]])
		ifTrue:
			[delta < 0
				ifTrue:
					[self flash]
				ifFalse:
					[self replaceSelectionWith: Character tab asSymbol asText.
					self selectAt: realStart + 1].
			^ true].

	lines := paragraph lines.
	startLine := paragraph lineIndexOfCharacterIndex: realStart.
	stopLine := paragraph lineIndexOfCharacterIndex: (realStart max: realStop).
	start := (lines at: startLine) first.
	stop := (lines at: stopLine) last.
	
	"Pin the start of highlighting unless the selection starts a line"
	adjustStart := realStart > start.

	"Find the indentation of the least-indented non-blank line; never outdent more"
	indentation := (startLine to: stopLine) inject: 1000 into:
		[:m :l |
		 m min: (paragraph indentationOfLineIndex: l ifBlank: [:tabs | 1000])].			

	size :=  stop + 1 - start.
	numLines := stopLine + 1 - startLine.
	inStream := ReadStream on: paragraph string from: start to: stop.

	newString := WideString new: size + ((numLines * delta) max: 0).
	outStream := ReadWriteStream on: newString.

	"This subroutine does the actual work"
	self indent: delta fromStream: inStream toStream: outStream.

	"Adjust the range that will be highlighted later"
	adjustStart ifTrue: [realStart := (realStart + delta) max: start].
	realStop := realStop + outStream position - size.

	"Prepare for another iteration"
	indentation := indentation + delta.
	size := outStream position.
	inStream := outStream setFrom: 1 to: size.

	outStream == nil
		ifTrue: 	"tried to outdent but some line(s) were already left flush"
			[self flash]
		ifFalse:
			[self selectInvisiblyFrom: start to: stop.
			size = newString size ifFalse: [newString := outStream contents].
			self replaceSelectionWith: newString asText].
	self selectFrom: realStart to: realStop. 	"highlight only the original range"
	^ true! !

!ParagraphEditor methodsFor: 'editing keys' stamp: ''!
indent: characterStream
	"Add a tab at the front of every line occupied by the selection. Flushes typeahead.  Invoked from keyboard via cmd-shift-R.  2/29/96 sw"

	^ self inOutdent: characterStream delta: 1! !

!ParagraphEditor methodsFor: 'private' stamp: ''!
indent: delta fromStream: inStream toStream: outStream
	"Append the contents of inStream to outStream, adding or deleting delta or -delta
	 tabs at the beginning, and after every CR except a final CR.  Do not add tabs
	 to totally empty lines, and be sure nothing but tabs are removed from lines."

	| ch skip cr tab prev atEnd |
	cr := Character cr.
	tab := Character tab.
	delta > 0
		ifTrue: "shift right"
			[prev := cr.
			 [ch := (atEnd := inStream atEnd) ifTrue: [cr] ifFalse: [inStream next].
			  (prev == cr and: [ch ~~ cr]) ifTrue:
				[delta timesRepeat: [outStream nextPut: tab]].
			  atEnd]
				whileFalse:
					[outStream nextPut: ch.
					prev := ch]]
		ifFalse: "shift left"
			[skip := delta. "a negative number"
			 [inStream atEnd] whileFalse:
				[((ch := inStream next) == tab and: [skip < 0]) ifFalse:
					[outStream nextPut: ch].
				skip := ch == cr ifTrue: [delta] ifFalse: [skip + 1]]]! !

!ParagraphEditor methodsFor: 'accessing' stamp: 'tk 4/21/1998 09:55'!
initialText
	^ initialText! !

!ParagraphEditor methodsFor: 'current selection' stamp: ''!
initializeSelection
	"Do the initial activity when starting up the receiver. For example, in the 
	ParagraphEditor highlight the current selection."

	self select! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'di 12/17/1998 09:41'!
insertAndSelect: aString at: anInteger

	self replace: (anInteger to: anInteger - 1)
		with: (Text string: (' ' , aString)
					attributes: emphasisHere)
		and: [self selectAndScroll]! !

!ParagraphEditor methodsFor: 'typing support' stamp: 'th 9/17/2002 16:23'!
insertTypeAhead: typeAhead
	typeAhead position = 0 ifFalse:
		[self zapSelectionWith: (Text string: typeAhead contents emphasis: emphasisHere).
		typeAhead reset.
		self unselect]! !

!ParagraphEditor methodsFor: 'do-its' stamp: 'nice 3/31/2011 22:39'!
inspectIt
	self evaluateSelectionAndDo: [:result | result inspect].
! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:37'!
inspectIt: characterStream 
	"Inspect the selection -- invoked via cmd-i.  If there is no current selection, use the current line.  1/17/96 sw
	 2/29/96 sw: don't call selectLine; it's done by inspectIt now"

self terminateAndInitializeAround: [self inspectIt].
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sd 6/3/2010 12:58'!
internalCallToBrowseIt
	"Launch a browser for the class indicated by the current selection. 
	If multiple classes matching the selection exist, let the user choose among them."
	| aClass |
	self lineSelectAndEmptyCheck: [^ self].
	aClass := SystemNavigation default
				classFromPattern: (self selection string copyWithoutAll: CharacterSet crlf)
				withCaption: 'choose a class to browse...'.
	aClass ifNil: [^ self].
	self terminateAndInitializeAround: [ | aBrow |
			aBrow := SystemBrowser default new.
			aBrow setClass: aClass selector: nil.
			aBrow class
				openBrowserView: (aBrow openEditString: nil)
				label: 'System Browser']! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sd 6/3/2010 12:57'!
internalCallToImplementorsOfIt
	"Open an implementors browser on the selected selector"

	| aSelector |
	self lineSelectAndEmptyCheck: [^ self].
	(aSelector := self selectedSelector) == nil ifTrue: [^ self flash].
	self terminateAndInitializeAround: 
		[ (self systemNavigation allImplementorsOf: aSelector) isEmpty
				ifFalse: [ self systemNavigation browseAllImplementorsOf: aSelector]]! !

!ParagraphEditor methodsFor: 'private' stamp: 'cmm 4/9/2004 14:00'!
isDisjointFrom: anInterval
	"Answer true if anInterval is a caret not touching or within the current
	 interval, or if anInterval is a non-caret that does not overlap the current
	 selection."

	| fudge |
	fudge := anInterval size = 0 ifTrue: [1] ifFalse: [0].
	^(anInterval last + fudge < self startIndex or:
			[anInterval first - fudge >= self stopIndex])
! !

!ParagraphEditor methodsFor: 'undo support' stamp: ''!
isDoing
	"Call from a doer/undoer/redoer any time to see which it is."

	^(self isUndoing | self isRedoing) not! !

!ParagraphEditor methodsFor: 'undo support' stamp: ''!
isRedoing
	"Call from a doer/undoer/redoer any time to see which it is."

	^UndoParagraph == #redoing! !

!ParagraphEditor methodsFor: 'undo support' stamp: ''!
isUndoing
	"Call from a doer/undoer/redoer any time to see which it is."

	^UndoParagraph == #undoing! !

!ParagraphEditor methodsFor: 'typing support' stamp: 'PeterHugossonMiller 9/3/2009 10:14'!
keystroke: keyEvent
	"Key struck on the keyboard. Find out which one and, if special, carry 
	out the associated special action. Otherwise, add the character to the 
	stream of characters.  Undoer & Redoer: see closeTypeIn."

	| typeAhead |
	typeAhead := (String new: 128) writeStream.
	self deselect.
	(self dispatchOnKeyEvent: keyEvent with: typeAhead)
		ifTrue: [
			self doneTyping.
			self setEmphasisHere.
			^self selectAndScroll; updateMarker].
	self openTypeIn.

	self hasSelection ifTrue: "save highlighted characters"
		[UndoSelection := self selection]. 
	self zapSelectionWith: 
			(Text string: typeAhead contents emphasis: emphasisHere).
	typeAhead reset.
	self unselect.
	self selectAndScroll.
	self updateMarker! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'th 9/19/2002 18:12'!
lineSelectAndEmptyCheck: returnBlock
	"If the current selection is an insertion point, expand it to be the entire current line; if after that's done the selection is still empty, then evaluate the returnBlock, which will typically consist of '[^ self]' in the caller -- check senders of this method to understand this."

	self selectLine.  "if current selection is an insertion point, then first select the entire line in which occurs before proceeding"
	self hasSelection ifFalse: [self flash.  ^ returnBlock value]! !

!ParagraphEditor methodsFor: 'private' stamp: 'nice 11/16/2009 10:11'!
lines
	"Other than my member paragraph i compute lines based on logical
	line breaks, not optical (which may change due to line wrapping of the editor)"
	| lines string index lineIndex stringSize |
	string := paragraph text string.
	"Empty strings have no lines at all. Think of something."
	string isEmpty ifTrue:[^{#(1 0 0)}].
	stringSize := string size.
	lines := OrderedCollection new: (string size // 15).
	index := 0.
	lineIndex := 0.
	string linesDo:[:line |
		lines addLast: (Array
			with: (index := index + 1)
			with: (lineIndex := lineIndex + 1)
			with: (index := index + line size min: stringSize))].
	"Special workaround for last line empty."
	(string last == Character cr or: [string last == Character lf])
	"lines last last < stringSize" ifTrue:[lines addLast:{stringSize +1. lineIndex+1. stringSize}].
	^lines! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:37'!
makeCapitalized: characterStream 
	"Force the current selection to be capitalized. Triggered by Cmd-Z."
	| prev |
prev := $-.  "not a letter"
	self replaceSelectionWith: (Text fromString:
			(self selection string collect:
				[:c | prev := prev isLetter ifTrue: [c asLowercase] ifFalse: [c asUppercase]])).
	^ true! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:37'!
makeLowercase: characterStream 
	"Force the current selection to lowercase.  Triggered by Cmd-X."

	self replaceSelectionWith: (Text fromString: (self selection string asLowercase)).
	^ true! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:37'!
makeUppercase: characterStream 
	"Force the current selection to uppercase.  Triggered by Cmd-Y."

	self replaceSelectionWith: (Text fromString: (self selection string asUppercase)).
	^ true! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/17/2002 16:13'!
mark
	^ self markBlock stringIndex! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 10/21/2003 15:49'!
markBlock
	^ stopBlock! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 10/21/2003 15:49'!
markBlock: aCharacterBlock
	stopBlock := aCharacterBlock.
! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/18/2002 12:31'!
markIndex
	^ self markBlock stringIndex! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sd 4/16/2003 19:31'!
methodNamesContainingIt
	"Open a browser on methods names containing the selected string"

	self lineSelectAndEmptyCheck: [^ self].
	Cursor wait showWhile:
		[self terminateAndInitializeAround: [self systemNavigation browseMethodsWhoseNamesContain: self selection string withBlanksTrimmed]].
	Cursor normal show! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:37'!
methodNamesContainingIt: characterStream 
	"Browse methods whose selectors containing the selection in their names"

	self methodNamesContainingIt.
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'md 9/6/2005 18:45'!
methodSourceContainingIt
	"Open a browser on methods which contain the current selection in their source (case-sensitive full-text search of source). Slow!!"

	self lineSelectAndEmptyCheck: [^ self].
	self systemNavigation browseMethodsWithSourceString: self selection string! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:37'!
methodStringsContainingIt: characterStream 
	"Invoked from cmd-E -- open a browser on all methods holding string constants containing it.  Flushes typeahead. "

	self methodStringsContainingit.
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sd 4/16/2003 19:28'!
methodStringsContainingit
	"Open a browser on methods which contain the current selection as part of a string constant."

	self lineSelectAndEmptyCheck: [^ self].
	self terminateAndInitializeAround: [self systemNavigation browseMethodsWithString: self selection string]! !

!ParagraphEditor methodsFor: 'model access' stamp: 'michael.rueger 2/23/2009 18:31'!
model
	"Answer the receiver's model which is the same as the model of the 
	receiver's view."

	^model! !

!ParagraphEditor methodsFor: 'model access' stamp: 'michael.rueger 2/23/2009 18:31'!
model: aModel 
	"Controller|model: and Controller|view: are sent by View|controller: in 
	order to coordinate the links between the model, view, and controller. In 
	ordinary usage, the receiver is created and passed as the parameter to 
	View|controller: so that the receiver's model and view links can be set 
	up by the view."

	model := aModel! !

!ParagraphEditor methodsFor: 'private' stamp: 'StephaneDucasse 7/22/2011 16:32'!
moveCursor: directionBlock forward: forward specialBlock: specialBlock
	"Private - Move cursor.
	directionBlock is a one argument Block that computes the new Position from a given one.
	specialBlock is a one argumentBlock that computes the new position from a given one under the alternate semantics.
	Note that directionBlock always is evaluated first."
	| shift indices newPosition |
	shift := Sensor shiftPressed.
	indices := self setIndices: shift forward: forward.
	newPosition := directionBlock value: (indices at: #moving).
	(Sensor commandKeyPressed or:[Sensor controlKeyPressed])
		ifTrue: [newPosition := specialBlock value: newPosition].
	shift
		ifTrue: [self selectMark: (indices at: #fixed) point: newPosition - 1]
		ifFalse: [self selectAt: newPosition]! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'di 5/6/1998 15:25'!
nextTokenFrom: start direction: dir
	"simple token-finder for compiler automated corrections"
	| loc str |
	loc := start + dir.
	str := paragraph text string.
	[(loc between: 1 and: str size) and: [(str at: loc) isSeparator]]
		whileTrue: [loc := loc + dir].
	^ loc! !

!ParagraphEditor methodsFor: 'private' stamp: 'sma 12/15/1999 11:32'!
nextWord: position
	| string index |
	string := paragraph text string.
	index := position.
	[(index between: 1 and: string size) and: [(string at: index) isAlphaNumeric]]
		whileTrue: [index := index + 1].
	[(index between: 1 and: string size) and: [(string at: index) isAlphaNumeric not]]
		whileTrue: [index := index + 1].
	^ index! !

!ParagraphEditor methodsFor: 'undo support' stamp: ''!
noUndoer
	"The Undoer to use when the command can not be undone.  Checked for
	 specially by readKeyboard."

	UndoMessage := Message selector: #noUndoer! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:40'!
noop: characterStream 
	"Unimplemented keyboard command; just ignore it."

	^ true
! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 13:20'!
normalCharacter: characterStream character: character
	"A nonspecial character is to be added to the stream of characters."

	characterStream nextPut: character.
	^false! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'di 5/20/1998 08:31'!
notify: aString at: anInteger in: aStream 
	"The compilation of text failed. The syntax error is noted as the argument, 
	aString. Insert it in the text at starting character position anInteger."

	self insertAndSelect: aString at: (anInteger max: 1)! !

!ParagraphEditor methodsFor: 'private' stamp: ''!
nullText

	^Text string: '' emphasis: emphasisHere! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'alain.plantec 2/6/2009 17:17'!
offerFontMenu
	"Present a menu of available fonts, and if one is chosen, apply it to the current selection.  
	Use only names of Fonts of this paragraph  "

	| aList reply |
	aList := paragraph textStyle fontNamesWithPointSizes.
	reply := UIManager default chooseFrom: aList values: aList.
	reply ~~ nil ifTrue:
		[self replaceSelectionWith:
			(Text string: self selection asString 
				attribute: (TextFontChange fontNumber: (aList indexOf: reply)))] ! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:40'!
offerFontMenu: characterStream 
	"The user typed the command key that requests a font change; Offer the font menu.  5/27/96 sw
	 Keeps typeahead.  (?? should flush?)"

	self closeTypeIn: characterStream.
	self offerFontMenu.
	^ true! !

!ParagraphEditor methodsFor: 'as yet unclassified' stamp: 'michael.rueger 2/23/2009 12:41'!
offerMenuFromEsc: aStream
	self yellowButtonActivity.
	^true "tell the caller that the character was processed "! !

!ParagraphEditor methodsFor: 'typing support' stamp: 'th 9/18/2002 16:48'!
openTypeIn
	"Set up UndoSelection to null text (to be added to by readKeyboard and backTo:),
	 beginTypeInBlock to keep track of the leftmost backspace, and UndoParameter to tally
	 how many deleted characters were backspaced over rather than 'cut'.
	 You can't undo typing until after closeTypeIn."

	beginTypeInBlock == nil ifTrue:
		[UndoSelection := self nullText.
		self undoer: #noUndoer with: 0.
		beginTypeInBlock := self startIndex]! !

!ParagraphEditor methodsFor: 'editing keys' stamp: ''!
outdent: characterStream
	"Remove a tab from the front of every line occupied by the selection. Flushes typeahead.  Invoked from keyboard via cmd-shift-L.  2/29/96 sw"

	^ self inOutdent: characterStream delta: -1! !

!ParagraphEditor methodsFor: 'private' stamp: 'th 9/20/2002 11:09'!
pageHeight
	| howManyLines visibleHeight totalHeight ratio |
	howManyLines := paragraph numberOfLines.
	visibleHeight := self visibleHeight.
	totalHeight := self totalTextHeight.
	ratio := visibleHeight / totalHeight.
	^(ratio * howManyLines) rounded - 2! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'th 9/20/2002 11:21'!
paste
	"Paste the text from the shared buffer over the current selection and 
	redisplay if necessary.  Undoer & Redoer: undoAndReselect."

	self replace: self selectionInterval with: self clipboardText and:
		[self selectAt: self pointIndex]! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:41'!
paste: characterStream 
	"Replace the current text selection by the text in the shared buffer.
	 Keeps typeahead."

	self closeTypeIn: characterStream.
	self paste.
	^true! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'JB 2/12/2010 15:22'!
pasteInitials: characterStream 
	"Replace the current text selection by an authorship name/date stamp; invoked by cmd-shift-v, easy way to put an authorship stamp in the comments of an editor.
	 Keeps typeahead."

	self closeTypeIn: characterStream.
	self replace: self selectionInterval with: (Text fromString: Author changeStamp) and: [self selectAt: self stopIndex].
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'ar 1/15/2001 18:36'!
pasteRecent
	"Paste an item chose from RecentClippings."

	| clipping |
	(clipping := Clipboard chooseRecentClipping) ifNil: [^ self].
	Clipboard clipboardText: clipping.
	^ self paste! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 10/21/2003 15:49'!
pointBlock
	^ startBlock! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 10/21/2003 15:49'!
pointBlock: aCharacterBlock
	startBlock := aCharacterBlock.
! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/18/2002 12:31'!
pointIndex
	^ self pointBlock stringIndex! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'alain.plantec 5/18/2009 15:58'!
prettyPrint
	"Reformat the contents of the receiver's view (a Browser)."

	| selectedClass newText |
	model selectedMessageCategoryName ifNil: [^ self flash].
	selectedClass := model selectedClassOrMetaClass.
	newText := selectedClass prettyPrinterClass
		format: self text
		in: selectedClass
		notifying: self.
	newText ifNotNil:
		[self deselect; selectInvisiblyFrom: 1 to: paragraph text size.
		self replaceSelectionWith: (newText asText makeSelectorBoldIn: selectedClass).
		self selectAt: 1]! !

!ParagraphEditor methodsFor: 'private' stamp: 'sma 12/15/1999 11:33'!
previousWord: position
	| string index |
	string := paragraph text string.
	index := position.
	[(index between: 1 and: string size) and: [(string at: index) isAlphaNumeric not]]
		whileTrue: [index := index - 1].
	[(index between: 1 and: string size) and: [(string at: index) isAlphaNumeric]]
		whileTrue: [index := index - 1].
	^ index + 1! !

!ParagraphEditor methodsFor: 'do-its' stamp: 'nice 3/31/2011 22:40'!
printIt
	"Treat the current text selection as an expression; evaluate it. Insert the 
	description of the result of evaluation after the selection and then make 
	this description the new text selection."
	self evaluateSelectionAndDo: [:result | self afterSelectionInsertAndSelect: result printString]! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:41'!
printIt: characterStream 
	"Print the results of evaluting the selection -- invoked via cmd-p.  If there is no current selection, use the current line.  1/17/96 sw
	 2/29/96 sw: don't call selectLine now, since it's called by doIt"

	self terminateAndInitializeAround: [self printIt].
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'dew 3/7/2000 21:06'!
printerSetup
	
	TextPrinter defaultTextPrinter inspect
! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:41'!
querySymbol: characterStream
	"Invoked by Ctrl-q to query the Symbol table and display alternate symbols.
	 See comment in completeSymbol:lastOffering: for details."

	self closeTypeIn: characterStream.	"keep typeahead"
	self hasCaret
		ifTrue: "Ctrl-q typed when a caret"
			[self perform: #completeSymbol:lastOffering: withArguments:
				((UndoParagraph == paragraph and: [UndoMessage sends: #undoQuery:lastOffering:])
					ifTrue: [UndoMessage arguments] "repeated Ctrl-q"
					ifFalse: [Array with: nil with: nil])] "initial Ctrl-q"
		ifFalse: "Ctrl-q typed when statements were highlighted"
			[self flash].
	^true! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'dvf 12/8/2001 00:46'!
raiseContextMenu: characterStream 
	"AFAIK, this is never called in morphic, because a subclass overrides it. Which is good, because a ParagraphEditor doesn't know about Morphic and thus duplicates the text-editing actions that really belong in the specific application, not the controller. So the context menu this would raise is likely to be out of date."
	self yellowButtonActivity.
	^true! !

!ParagraphEditor methodsFor: 'current selection' stamp: 'th 9/20/2002 11:41'!
recomputeInterval
	"The same characters are selected but their coordinates may have changed."

	self computeIntervalFrom: self mark to: self pointIndex - 1! !

!ParagraphEditor methodsFor: 'current selection' stamp: ''!
recomputeSelection
	"Redetermine the selection according to the start and stop block indices; 
	do not highlight."

	self deselect; recomputeInterval! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'lr 3/14/2010 21:13'!
referencesToIt
	"Open a references browser on the selected symbol"

	| aSymbol |
	self selectLine.
	((aSymbol := self selectedSymbol) == nil or: [ (Smalltalk globals includesKey: aSymbol) not ])
		ifTrue: [ ^ self flash ].
	self
		terminateAndInitializeAround: [ self systemNavigation browseAllCallsOn: (Smalltalk globals associationAt: self selectedSymbol) ]! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:41'!
referencesToIt: characterStream 
	"Triggered by Cmd-N; browse references to the current selection"

	self referencesToIt.
	^ true! !

!ParagraphEditor methodsFor: 'accessing' stamp: ''!
replace: oldInterval with: newText and: selectingBlock 
	"Replace the text in oldInterval with newText and execute selectingBlock to establish the new selection.  Create an undoAndReselect:redoAndReselect: undoer to allow perfect undoing."

	| undoInterval |
	undoInterval := self selectionInterval.
	undoInterval = oldInterval ifFalse: [self selectInterval: oldInterval].
	UndoSelection := self selection.
	self zapSelectionWith: newText.
	selectingBlock value.
	otherInterval := self selectionInterval.
	self undoer: #undoAndReselect:redoAndReselect: with: undoInterval with: otherInterval! !

!ParagraphEditor methodsFor: 'accessing' stamp: ''!
replaceSelectionWith: aText
	"Remember the selection text in UndoSelection.
	 Deselect, and replace the selection text by aText.
	 Remember the resulting selectionInterval in UndoInterval and PriorInterval.
	 Set up undo to use UndoReplace."

	beginTypeInBlock ~~ nil ifTrue: [^self zapSelectionWith: aText]. "called from old code"
	UndoSelection := self selection.
	self zapSelectionWith: aText.
	self undoer: #undoReplace! !

!ParagraphEditor methodsFor: 'initialize-release' stamp: 'th 10/21/2003 15:49'!
resetState 
	"Establish the initial conditions for editing the paragraph: place caret 
	before first character, set the emphasis to that of the first character,
	and save the paragraph for purposes of canceling."

	stopBlock := paragraph defaultCharacterBlock.
	self pointBlock: stopBlock copy.
	beginTypeInBlock := nil.
	UndoInterval := otherInterval := 1 to: 0.
	self setEmphasisHere.
	selectionShowing := false.
	initialText := paragraph text copy! !

!ParagraphEditor methodsFor: 'current selection' stamp: 'BG 12/12/2003 12:50'!
reverseSelection
	"Reverse the valence of the current selection highlighting."
	selectionShowing := selectionShowing not.
	paragraph reverseFrom: self pointBlock to: self markBlock! !

!ParagraphEditor methodsFor: 'private' stamp: 'AlainPlantec 12/11/2009 13:39'!
sameColumn: start newLine: lineBlock forward: isForward
	"Private - Compute the index in my text
	with the line number derived from lineBlock,"
	" a one argument block accepting the old line number.
	The position inside the line will be preserved as good as possible"
	"The boolean isForward is used in the border case to determine if
	we should move to the beginning or the end of the line."
	| column currentLine offsetAtTargetLine targetEOL lines numberOfLines currentLineNumber targetLineNumber |
	self walkAlongDisplayedLine
		ifTrue: [
			lines := paragraph lines.
			numberOfLines := paragraph numberOfLines.
			currentLineNumber  := paragraph lineIndexOfCharacterIndex: start.
			currentLine := lines at: currentLineNumber]
		ifFalse: [
			lines := self lines.
			numberOfLines := lines size.
			currentLine := lines
				detect:[:lineInterval | lineInterval last >= start]
				ifNone:[lines last].
			currentLineNumber := currentLine second].
	column := start - currentLine first.
	targetLineNumber := ((lineBlock value: currentLineNumber) max: 1) min: numberOfLines.
	offsetAtTargetLine := (lines at: targetLineNumber) first.
	targetEOL := (lines at: targetLineNumber) last + (targetLineNumber == numberOfLines ifTrue:[1]ifFalse:[0]).
	targetLineNumber == currentLineNumber
	"No movement or movement failed. Move to beginning or end of line."
		ifTrue:[^isForward
			ifTrue:[targetEOL]
			ifFalse:[offsetAtTargetLine]].
	^offsetAtTargetLine + column min: targetEOL.! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:41'!
save: characterStream
	"Submit the current text.  Equivalent to 'accept' 1/18/96 sw
	 Keeps typeahead."

	self closeTypeIn: characterStream.
	self terminateAndInitializeAround: [self accept].
	^ true! !

!ParagraphEditor methodsFor: 'scrolling' stamp: 'BG 12/12/2003 15:31'!
scrollBy: heightToMove
	"Move the paragraph by heightToMove, and reset the text selection."
	^ paragraph scrollBy: heightToMove withSelectionFrom: self pointBlock to: self markBlock! !

!ParagraphEditor methodsFor: 'scrolling' stamp: ''!
scrollToBottom
	"Scroll so that the tail end of the text is visible in the view.  5/6/96 sw"

	self scrollView: (paragraph clippingRectangle bottom 
		- paragraph compositionRectangle bottom)! !

!ParagraphEditor methodsFor: 'scrolling' stamp: ''!
scrollToTop
	"Scroll so that the paragraph is at the top of the view."

	self scrollView: (paragraph clippingRectangle top 
		- paragraph compositionRectangle top)! !

!ParagraphEditor methodsFor: 'scrolling' stamp: ''!
scrollView: anInteger 
	"Paragraph scrolling uses opposite polarity"
	^ self scrollBy: anInteger negated! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:41'!
search: characterStream
	"Invoked by Ctrl-S.  Same as 'again', but always uses the existing FindText
	 and ChangeText regardless of the last edit."

	self closeTypeIn: characterStream.
	self againOrSame: true. "true means use same keys"
	^true! !

!ParagraphEditor methodsFor: 'current selection' stamp: ''!
select
	"If the text selection is visible on the screen, highlight it."

	selectionShowing ifFalse: [self reverseSelection]! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'sw 8/29/2000 14:58'!
selectAll
	"Make the selection be all the characters of the receiver"

	self selectFrom: 1 to: paragraph text string size! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'michael.rueger 2/23/2009 12:41'!
selectAll: characterStream 
	"select everything, invoked by cmd-a.  1/17/96 sw"

	self closeTypeIn: characterStream.
	self selectFrom: 1 to: paragraph text string size.
	^ true! !

!ParagraphEditor methodsFor: 'current selection' stamp: 'StephaneDucasse 5/27/2010 22:15'!
selectAndScroll
	"Scroll until the selection is in the view and then highlight it."
	| lineHeight deltaY clippingRectangle endBlock |
	self select.
	endBlock := self stopBlock.
	lineHeight := paragraph textStyle lineGrid.
	clippingRectangle := paragraph clippingRectangle.
	deltaY := endBlock top - clippingRectangle top.
	deltaY >= 0 
		ifTrue: [deltaY := endBlock bottom - clippingRectangle bottom max: 0].
		"check if stopIndex below bottom of clippingRectangle"
	deltaY ~= 0 
		ifTrue: [self scrollBy: (deltaY abs + lineHeight - 1 truncateTo: lineHeight) * deltaY sign]! !

!ParagraphEditor methodsFor: 'current selection' stamp: 'StephaneDucasse 5/27/2010 22:15'!
selectAndScrollToTop
	"Scroll until the selection is in the view and then highlight it."
	| lineHeight deltaY clippingRectangle |
	self select.
	lineHeight := paragraph textStyle lineGrid.
	clippingRectangle := paragraph clippingRectangle.
	deltaY := self stopBlock top - clippingRectangle top.
	deltaY ~= 0 
		ifTrue: [self scrollBy: (deltaY abs + lineHeight - 1 truncateTo: lineHeight) * deltaY sign]! !

!ParagraphEditor methodsFor: 'new selection' stamp: ''!
selectAt: characterIndex 
	"Deselect, then place the caret before the character at characterIndex.
	 Be sure it is in view."

	self selectFrom: characterIndex to: characterIndex - 1! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'michael.rueger 2/23/2009 12:42'!
selectCurrentTypeIn: characterStream 
	"Select what would be replaced by an undo (e.g., the last typeIn)."

	| prior |

	self closeTypeIn: characterStream.
	prior := otherInterval.
	self closeTypeIn: characterStream.
	self selectInterval: UndoInterval.
	otherInterval := prior.
	^ true! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'th 9/18/2002 16:50'!
selectFrom: start to: stop
	"Deselect, then select the specified characters inclusive.
	 Be sure the selection is in view."

	(start = self startIndex and: [stop + 1 = self stopIndex]) ifFalse:
		[self deselect.
		self selectInvisiblyFrom: start to: stop].
	self selectAndScroll! !

!ParagraphEditor methodsFor: 'new selection' stamp: ''!
selectInterval: anInterval
	"Deselect, then select the specified characters inclusive.
	 Be sure the selection is in view."

	self selectFrom: anInterval first to: anInterval last! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'di 5/9/1998 20:59'!
selectInvisiblyFrom: start to: stop
	"Select the designated characters, inclusive.  Make no visual changes."

	^ self computeIntervalFrom: start to: stop! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'th 9/18/2002 14:17'!
selectInvisiblyMark: mark point: point
	"Select the designated characters, inclusive.  Make no visual changes."

	^ self computeIntervalFrom: mark to: point! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'th 9/19/2002 17:17'!
selectLine
	"Make the receiver's selection, if it currently consists of an insertion point only, encompass the current line."
	self hasSelection ifTrue:[^self].
	self selectInterval: (self encompassLine: self selectionInterval)! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'th 9/18/2002 14:18'!
selectMark: mark point: point
	"Deselect, then select the specified characters inclusive.
	 Be sure the selection is in view."

	(mark =  self markIndex and: [point + 1 = self pointIndex]) ifFalse:
		[self deselect.
		self selectInvisiblyMark: mark point: point].
	self selectAndScroll! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'th 9/19/2002 18:49'!
selectPrecedingIdentifier
	"Invisibly select the identifier that ends at the end of the selection, if any."

	| string sep stop tok |
	tok := false.
	string := paragraph text string.
	stop := self stopIndex - 1.
	[stop > 0 and: [(string at: stop) isSeparator]] whileTrue: [stop := stop - 1].
	sep := stop.
	[sep > 0 and: [(string at: sep) tokenish]] whileTrue: [tok := true. sep := sep - 1].
	tok ifTrue: [self selectInvisiblyFrom: sep + 1 to: stop]! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'th 9/18/2002 16:51'!
selectWord
	"Select delimited text or word--the result of double-clicking."

	| openDelimiter closeDelimiter direction match level leftDelimiters rightDelimiters
	string here hereChar start stop |
	string := paragraph text string.
	here := self pointIndex.
	(here between: 2 and: string size)
		ifFalse: ["if at beginning or end, select entire string"
			^self selectFrom: 1 to: string size].
	leftDelimiters := '([{<''"
'.
	rightDelimiters := ')]}>''"
'.
	openDelimiter := string at: here - 1.
	match := leftDelimiters indexOf: openDelimiter.
	match > 0
		ifTrue: 
			["delimiter is on left -- match to the right"
			start := here.
			direction := 1.
			here := here - 1.
			closeDelimiter := rightDelimiters at: match]
		ifFalse: 
			[openDelimiter := string at: here.
			match := rightDelimiters indexOf: openDelimiter.
			match > 0
				ifTrue: 
					["delimiter is on right -- match to the left"
					stop := here - 1.
					direction := -1.
					closeDelimiter := leftDelimiters at: match]
				ifFalse: ["no delimiters -- select a token"
					direction := -1]].
	level := 1.
	[level > 0 and: [direction > 0
			ifTrue: [here < string size]
			ifFalse: [here > 1]]]
		whileTrue: 
			[hereChar := string at: (here := here + direction).
			match = 0
				ifTrue: ["token scan goes left, then right"
					hereChar tokenish
						ifTrue: [here = 1
								ifTrue: 
									[start := 1.
									"go right if hit string start"
									direction := 1]]
						ifFalse: [direction < 0
								ifTrue: 
									[start := here + 1.
									"go right if hit non-token"
									direction := 1]
								ifFalse: [level := 0]]]
				ifFalse: ["bracket match just counts nesting level"
					hereChar = closeDelimiter
						ifTrue: [level := level - 1"leaving nest"]
						ifFalse: [hereChar = openDelimiter 
									ifTrue: [level := level + 1"entering deeper nest"]]]].

	level > 0 ifTrue: ["in case ran off string end"	here := here + direction].
	direction > 0
		ifTrue: [self selectFrom: start to: here - 1]
		ifFalse: [self selectFrom: here + 1 to: stop]! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'michael.rueger 2/23/2009 12:42'!
selectWord: characterStream
	self closeTypeIn: characterStream.
	self selectWord.
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sd 5/24/2010 22:41'!
selectedSelector
	"Try to make a selector out of the current text selection"
	
	^self selection string findSelector! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'StephaneDucasse 5/28/2011 13:34'!
selectedSymbol
	"Return the currently selected symbol, or nil if none.  Spaces, tabs and returns are ignored"

	| aString |
	self hasCaret ifTrue: [^ nil].
	aString := self selection string.
	aString isOctetString ifTrue: [aString := aString asOctetString].
	aString := aString copyWithoutAll:
		{Character space.  Character cr.  Character lf. Character tab}.
	aString size = 0 ifTrue: [^ nil].
	Symbol hasInterned: aString  ifTrue: [:sym | ^ sym].

	^ nil! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'yo 7/31/2004 16:27'!
selection
	"Answer the text in the paragraph that is currently selected."

	| t |
	t := paragraph text copyFrom: self startIndex to: self stopIndex - 1.
	t string isOctetString ifTrue: [t asOctetStringText].
	^ t.
! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/19/2002 18:10'!
selectionAsStream
	"Answer a ReadStream on the text in the paragraph that is currently 
	selected."

	^ReadWriteStream
		on: paragraph string
		from: self startIndex
		to: self stopIndex - 1! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/18/2002 16:18'!
selectionInterval
	"Answer the interval that is currently selected."

	^self startIndex to: self stopIndex - 1 ! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'alain.plantec 6/11/2008 15:13'!
sendersOfIt
	"Open a senders browser on the selected selector"

	| aSelector |
	self lineSelectAndEmptyCheck: [^ self].
	(aSelector := self selectedSelector) == nil ifTrue: [^ self flash].
	self terminateAndInitializeAround: [self systemNavigation browseAllCallsOn: aSelector]! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:42'!
sendersOfIt: characterStream 
	"Triggered by Cmd-n; browse implementors of the selector represented by the current selection, if plausible. 2/1/96 sw"

	self sendersOfIt.
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'th 9/18/2002 17:28'!
setAlignment: aSymbol
	| attr interval |
	attr := TextAlignment perform: aSymbol.
	interval := self encompassLine: self selectionInterval.
	paragraph replaceFrom: interval first to: interval last with:
		((paragraph text copyFrom: interval first to: interval last) addAttribute: attr) displaying: true.
! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'yo 5/27/2004 13:56'!
setEmphasis: emphasisSymbol
	"Change the emphasis of the current selection."

	| oldAttributes attribute |
	oldAttributes := paragraph text attributesAt: self selectionInterval first forStyle: paragraph textStyle.

	attribute := TextEmphasis perform: emphasisSymbol.
	(emphasisSymbol == #normal) 
		ifFalse:	[oldAttributes do:	
			[:att | (att dominates: attribute) ifTrue: [attribute turnOff]]].
	self replaceSelectionWith: (self selection addAttribute: attribute)! !

!ParagraphEditor methodsFor: 'typing support' stamp: 'th 9/18/2002 16:49'!
setEmphasisHere

	emphasisHere := (paragraph text attributesAt: (self pointIndex - 1 max: 1) forStyle: paragraph textStyle)
					select: [:att | att mayBeExtended]! !

!ParagraphEditor methodsFor: 'private' stamp: 'md 2/22/2006 21:17'!
setIndices: shiftPressed forward: forward
	"Little helper method that sets the moving and fixed indices according to some flags."
	| indices |
	indices := Dictionary new.
	shiftPressed ifTrue: [
			indices at: #moving put: self pointIndex.
			indices at: #fixed put: self markIndex
		] ifFalse: [
			forward
				ifTrue:[
					indices at: #moving put: self stopIndex.
					indices at: #fixed put: self startIndex.
				] ifFalse: [
					indices at: #moving put: self startIndex.
					indices at: #fixed put: self stopIndex.
				]
		].
	^indices! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/17/2002 13:02'!
setMark: anIndex
	self markBlock: (paragraph characterBlockForIndex: anIndex)
! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/17/2002 13:02'!
setPoint: anIndex
	self pointBlock: (paragraph characterBlockForIndex: anIndex)
! !

!ParagraphEditor methodsFor: 'accessing' stamp: ''!
setSearch: aString
	"Set the FindText and ChangeText to seek aString; except if already seeking aString, leave ChangeText alone so again will repeat last replacement."

	FindText string = aString
		ifFalse: [FindText := ChangeText := aString asText]! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'alain.plantec 6/11/2008 15:13'!
setSearchString
	"Make the current selection, if any, be the current search string."
	self hasCaret ifTrue: [self flash. ^ self].
	self setSearch:  self selection string! !

!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'StephaneDucasse 5/28/2011 13:34'!
setSearchString: characterStream
	"Establish the current selection as the current search string."

	| aString |
	self closeTypeIn: characterStream.
	self lineSelectAndEmptyCheck: [^ true].
	aString :=  self selection string.
	aString size = 0
		ifTrue:
			[self flash]
		ifFalse:
			[self setSearch: aString].
	^ true! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 13:22'!
shiftEnclose: characterStream keyEvent: keyEvent
	"Insert or remove bracket characters around the current selection.
	 Flushes typeahead."

	| char left right startIndex stopIndex oldSelection which text |
	char := keyEvent keyCharacter.
	char = $9 ifTrue: [ char := $( ].
	char = $, ifTrue: [ char := $< ].
	char = $[ ifTrue: [ char := ${ ].
	char = $' ifTrue: [ char := $" ].
	char asciiValue = 27 ifTrue: [ char := ${ ].	"ctrl-["

	self closeTypeIn.
	startIndex := self startIndex.
	stopIndex := self stopIndex.
	oldSelection := self selection.
	which := '([<{"''' indexOf: char ifAbsent: [1].
	left := '([<{"''' at: which.
	right := ')]>}"''' at: which.
	text := paragraph text.
	((startIndex > 1 and: [stopIndex <= text size])
		and:
		[(text at: startIndex-1) = left and: [(text at: stopIndex) = right]])
		ifTrue:
			["already enclosed; strip off brackets"
			self selectFrom: startIndex-1 to: stopIndex.
			self replaceSelectionWith: oldSelection]
		ifFalse:
			["not enclosed; enclose by matching brackets"
			self replaceSelectionWith:
				(Text string: (String with: left), oldSelection string ,(String with: right)
					emphasis: emphasisHere).
			self selectFrom: startIndex+1 to: stopIndex].
	^true! !

!ParagraphEditor methodsFor: 'typing/selecting keys' stamp: 'th 9/19/2002 17:34'!
simulatedBackspace
	"Backspace over the last character, derived from hand-char recognition.  2/5/96 sw"

	| startIndex |
	startIndex := self markIndex + (self hasSelection ifTrue: [1] ifFalse: [0]).

	startIndex := 1 max: startIndex - 1.
	self backTo: startIndex.
	^ false! !

!ParagraphEditor methodsFor: 'typing support' stamp: 'alain.plantec 6/11/2008 15:11'!
simulatedKeystroke: char
	"Accept char as if it were struck on the keyboard.  This version does not yet deal with command keys, and achieves update in the receiver's typically inactive window via the sledge-hammer of uncache-bits."

	self deselect.
	self openTypeIn.
	self markBlock = self pointBlock ifFalse: [UndoSelection := self selection].
	self zapSelectionWith:
		(Text string: char asString emphasis: emphasisHere).
	self userHasEdited.
	self unselect.
	self selectAndScroll.
	self updateMarker.
! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/17/2002 16:10'!
startBlock
	^ self pointBlock min: self markBlock! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/17/2002 13:10'!
startBlock: aCharacterBlock
	self markBlock: aCharacterBlock! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/18/2002 14:27'!
startIndex
	^ self startBlock stringIndex! !

!ParagraphEditor methodsFor: 'typing support' stamp: 'di 10/6/1998 08:45'!
startOfTyping
	"Compatibility during change from characterBlock to integer"
	beginTypeInBlock == nil ifTrue: [^ nil].
	beginTypeInBlock isNumber ifTrue: [^ beginTypeInBlock].
	"Last line for compatibility during change from CharacterBlock to Integer."
	^ beginTypeInBlock stringIndex
	! !

!ParagraphEditor methodsFor: 'initialize-release' stamp: 'di 5/15/2000 13:51'!
stateArray
	^ {ChangeText.
		FindText.
		UndoInterval.
		UndoMessage.
		UndoParagraph.
		UndoSelection.
		Undone.
		self selectionInterval.
		self startOfTyping.
		emphasisHere}! !

!ParagraphEditor methodsFor: 'initialize-release' stamp: 'di 10/5/1998 17:03'!
stateArrayPut: stateArray
	| sel |
	ChangeText := stateArray at: 1.
	FindText := stateArray at: 2.
	UndoInterval := stateArray at: 3.
	UndoMessage := stateArray at: 4.
	UndoParagraph := stateArray at: 5.
	UndoSelection := stateArray at: 6.
	Undone := stateArray at: 7.
	sel := stateArray at: 8.
	self selectFrom: sel first to: sel last.
	beginTypeInBlock := stateArray at: 9.
	emphasisHere := stateArray at: 10.! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/17/2002 16:14'!
stopBlock
	^ self pointBlock max: self markBlock! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/17/2002 13:10'!
stopBlock: aCharacterBlock
	self pointBlock: aCharacterBlock! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/18/2002 14:27'!
stopIndex
	^ self stopBlock stringIndex! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'StephaneDucasse 5/28/2011 13:34'!
swapChars: characterStream 
	"Triggered byCmd-Y;.  Swap two characters, either those straddling the insertion point, or the two that comprise the selection.  Suggested by Ted Kaehler.  "

	| currentSelection aString chars |
	(chars := self selection) size = 0
		ifTrue:
			[currentSelection := self pointIndex.
			self selectMark: currentSelection - 1 point: currentSelection]
		ifFalse:
			[chars size = 2
				ifFalse:
					[self flash.  ^ true]
				ifTrue:
					[currentSelection := self pointIndex - 1]].
	aString := self selection string.
	self replaceSelectionWith: (Text string: aString reversed emphasis: emphasisHere).
	self selectAt: currentSelection + 1.
	^ true! !

!ParagraphEditor methodsFor: 'do-its' stamp: 'ab 3/23/2005 16:49'!
tallyIt

	^ self tallySelection! !

!ParagraphEditor methodsFor: 'do-its' stamp: 'StephaneDucasse 3/1/2011 19:40'!
tallySelection
	"Treat the current selection as an expression; evaluate and tally it."
	| receiver context v |

	(model respondsTo: #doItReceiver) 
		ifTrue: 
			[
			receiver := model doItReceiver.
			context := model doItContext]
		ifFalse:
			[receiver := context := nil].
	self lineSelectAndEmptyCheck: [ ^ self ].

	[ | compiledMethod |
		compiledMethod := self compileSelectionFor: receiver in: context.
		compiledMethod ifNil: [^ self].
		TimeProfileBrowser spyOn: [
			v := compiledMethod valueWithReceiver: receiver arguments: #()].
	] 
		on: OutOfScopeNotification 
		do: [ :ex | ex resume: true].
	self inform: ('Result: ', (v printStringLimitedTo: 20)).
! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:43'!
tempCommand: characterStream 
	"Experimental.  Triggered by Cmd-t; put trial cmd-key commands here to see how they work, before hanging them on their own cmd accelerators."

	self experimentalCommand.
	^ true! !

!ParagraphEditor methodsFor: 'as yet unclassified' stamp: 'michael.rueger 2/23/2009 18:37'!
terminateAndInitializeAround: aBlock
	"1/12/96 sw"
	self controlTerminate.
	aBlock value.
	self controlInitialize! !

!ParagraphEditor methodsFor: 'accessing' stamp: ''!
text
	"Answer the text of the paragraph being edited."

	^paragraph text! !

!ParagraphEditor methodsFor: 'as yet unclassified' stamp: 'sbw 10/13/1999 22:40'!
totalTextHeight

	^paragraph boundingBox height! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'michael.rueger 2/23/2009 13:23'!
undo
	"Reset the state of the paragraph prior to the previous edit.
	 If another ParagraphEditor instance did that edit, UndoInterval is invalid;
	 just recover the contents of the undo-buffer at the start of the paragraph."

	Sensor flushKeyboard. "a way to flush stuck keys"
	self closeTypeIn.

	UndoParagraph == paragraph ifFalse: "Can't undo another paragraph's edit"
		[UndoMessage := Message selector: #undoReplace.
		UndoInterval := 1 to: 0.
		Undone := true].
	UndoInterval ~= self selectionInterval ifTrue: "blink the actual target"
		[self selectInterval: UndoInterval; deselect].

	"Leave a signal of which phase is in progress"
	UndoParagraph := Undone ifTrue: [#redoing] ifFalse: [#undoing].
	UndoMessage sentTo: self.
	UndoParagraph := paragraph! !

!ParagraphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 12:43'!
undo: characterStream 
	"Undo the last edit.  Keeps typeahead, so undo twice is a full redo."

	self closeTypeIn: characterStream.
	self undo.
	^true! !

!ParagraphEditor methodsFor: 'undoers' stamp: 'nice 1/5/2010 15:59'!
undoAgain: indices andReselect: home typedKey: wasTypedKey
	"The last command was again.  Undo it. Redoer: itself."

	| findSize substText |
	(self isRedoing & wasTypedKey) ifTrue: "redelete search key"
		[self selectInterval: home.
		self zapSelectionWith: self nullText].

	findSize := (self isRedoing ifTrue: [FindText] ifFalse: [ChangeText]) size.
	substText := self isUndoing ifTrue: [FindText] ifFalse: [ChangeText].
	(self isUndoing ifTrue: [indices size to: 1 by: -1] ifFalse: [1 to: indices size]) do:
		[:i | | index subject |
		index := indices at: i.
		(subject := index to: index + findSize - 1) = self selectionInterval ifFalse:
			[self selectInterval: subject].
		FindText == ChangeText ifFalse: [self zapSelectionWith: substText]].

	self isUndoing
		ifTrue:  "restore selection to where it was when 'again' was invoked"
			[wasTypedKey
				ifTrue: "search started by typing key at a caret; restore it"
					[self selectAt: home first.
					self zapSelectionWith: FindText.
					self selectAt: home last + 1]
				ifFalse: [self selectInterval: home]].

	self undoMessage: UndoMessage forRedo: self isUndoing! !

!ParagraphEditor methodsFor: 'undoers' stamp: ''!
undoAndReselect: undoHighlight redoAndReselect: redoHighlight
	"Undo typing, cancel, paste, and other operations that are like replaces
	 but the selection is not the whole restored text after undo, redo, or both.
	 undoHighlight is selected after this phase and redoHighlight after the next phase.
	Redoer: itself."

	self replace: self selectionInterval with: UndoSelection and:
		[self selectInterval: undoHighlight].
	self undoMessage: (UndoMessage argument: redoHighlight) forRedo: self isUndoing
! !

!ParagraphEditor methodsFor: 'undoers' stamp: ''!
undoCutCopy: oldPasteBuffer
	"Undo of a cut, copy, or any edit that changed CurrentSelection.  Be sure
	 undo-copy does not lock the model.  Redoer: itself, so never isRedoing."

	| recentCut |
	recentCut := self clipboardText.	
	UndoSelection size = UndoInterval size
		ifFalse: [self replaceSelectionWith: UndoSelection].
	self clipboardTextPut: oldPasteBuffer.
	self undoer: #undoCutCopy: with: recentCut! !

!ParagraphEditor methodsFor: 'undo support' stamp: ''!
undoMessage: aMessage forRedo: aBoolean
	"Call this from an undoer/redoer to set up UndoMessage as the
	 corresponding redoer/undoer.  Also set up UndoParagraph, as well
	 as the state variable Undone.  It is assumed that UndoInterval has been
	 established (generally by zapSelectionWith:) and that UndoSelection has been
	 saved (generally by replaceSelectionWith: or replace:With:and:)."

	self isDoing ifTrue: [UndoParagraph := paragraph].
	UndoMessage := aMessage.
	Undone := aBoolean! !

!ParagraphEditor methodsFor: 'undoers' stamp: 'th 9/19/2002 18:46'!
undoQuery: hintText lastOffering: selectorOrNil
	"Undo ctrl-q.  selectorOrNil (if not nil) is the previously offered selector.
	 hintText is the original hint.  Redoer: completeSymbol."

	self zapSelectionWith: UndoSelection.
	self undoMessage: (Message selector: #completeSymbol:lastOffering: arguments: UndoMessage arguments) forRedo: true.
	self selectAt: self stopIndex! !

!ParagraphEditor methodsFor: 'undoers' stamp: ''!
undoReplace
	"Undo of any command that replaced a selection by other text that it left
	 highlighted, and that is undone and redone by simple reversal of the
	 operation.  This is the most common Undoer; call replaceSelectionWith:
	 to get this setup.  Redoer: itself, so never isRedoing."

	self replaceSelectionWith: UndoSelection! !

!ParagraphEditor methodsFor: 'undo support' stamp: ''!
undoer: aSelector
	"See comment in undoMessage:.  Use this version when aSelector has no arguments, and you are doing or redoing and want to prepare for undoing."

	self undoMessage: (Message selector: aSelector) forRedo: false! !

!ParagraphEditor methodsFor: 'undo support' stamp: ''!
undoer: aSelector with: arg1
	"See comment in undoMessage:.  Use this version when aSelector has one argument, and you are doing or redoing and want to prepare for undoing."

	self undoMessage: (Message selector: aSelector argument: arg1) forRedo: false! !

!ParagraphEditor methodsFor: 'undo support' stamp: ''!
undoer: aSelector with: arg1 with: arg2
	"See comment in undoMessage:.  Use this version when aSelector has two arguments, and you are doing or redoing and want to prepare for undoing."

	self undoMessage: (Message selector: aSelector arguments: (Array with: arg1 with: arg2)) forRedo: false! !

!ParagraphEditor methodsFor: 'undo support' stamp: ''!
undoer: aSelector with: arg1 with: arg2 with: arg3
	"See comment in undoMessage:.  Use this version when aSelector has three arguments, and you are doing or redoing and want to prepare for undoing."

	self undoMessage: (Message selector: aSelector arguments: (Array with: arg1 with: arg2 with: arg3)) forRedo: false! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/17/2002 16:23'!
unselect
	self markBlock: self pointBlock copy.! !

!ParagraphEditor methodsFor: 'scrolling' stamp: 'alain.plantec 6/11/2008 15:45'!
updateMarker
	"A variation of computeMarkerRegion--only redisplay the marker in the scrollbar if an actual change has occurred in the positioning of the paragraph."
! !

!ParagraphEditor methodsFor: 'accessing' stamp: 'jm 3/18/98 20:38'!
userHasEdited
	"Note that the user has edited my text. Here it is just a noop so that the Character Recognizer won't fail when used with a vanilla ParagrahEditor."
! !

!ParagraphEditor methodsFor: 'as yet unclassified' stamp: 'sbw 10/13/1999 22:33'!
visibleHeight

	^paragraph clippingRectangle height! !

!ParagraphEditor methodsFor: 'settings' stamp: 'AlainPlantec 12/11/2009 13:38'!
walkAlongDisplayedLine
	^ self class walkAlongDisplayedLine! !

!ParagraphEditor methodsFor: 'watchIt' stamp: 'hfm 1/11/2009 10:35'!
watchIt

	self inspectIt! !

!ParagraphEditor methodsFor: 'accessing-selection' stamp: 'th 9/19/2002 18:12'!
zapSelectionWith: aText
	"Deselect, and replace the selection text by aText.
	 Remember the resulting selectionInterval in UndoInterval and otherInterval.
	 Do not set up for undo."

	| start stop |
	self deselect.
	start := self startIndex.
	stop := self stopIndex.
	(aText isEmpty and: [stop > start]) ifTrue:
		["If deleting, then set emphasisHere from 1st character of the deletion"
		emphasisHere := (paragraph text attributesAt: start forStyle: paragraph textStyle)
					select: [:att | att mayBeExtended]].
	(start = stop and: [aText size = 0]) ifFalse:
		[paragraph
			replaceFrom: start
			to: stop - 1
			with: aText
			displaying: true.
		self computeIntervalFrom: start to: start + aText size - 1.
		UndoInterval := otherInterval := self selectionInterval]! !

ParagraphEditor subclass: #TextMorphEditor
	instanceVariableNames: 'morph oldInterval pivotBlock'
	classVariableNames: 'UseMultipleUndo'
	poolDictionaries: 'TextConstants'
	category: 'Deprecated13'!

!TextMorphEditor commentStamp: 'AlainPlantec 12/2/2010 20:51' prior: 0!
DEPRECATED IN 1.2
Use TextEditor or SmalltalkEditor instead

This is the ParagraphEditor for TextMorphs.
!

!TextMorphEditor class methodsFor: 'settings' stamp: 'AlainPlantec 12/1/2010 10:06'!
useMultipleUndo 
	^ UseMultipleUndo ifNil: [UseMultipleUndo := false]! !

!TextMorphEditor class methodsFor: 'settings' stamp: 'AlainPlantec 12/11/2009 09:31'!
useMultipleUndo: aBoolean 
	UseMultipleUndo := aBoolean! !

!TextMorphEditor methodsFor: 'menu messages' stamp: 'di 4/21/1998 20:30'!
accept
	"Save the current text of the text being edited as the current acceptable version for purposes of canceling.  Allow my morph to take appropriate action"
	morph acceptContents! !

!TextMorphEditor methodsFor: 'multi level undo' stamp: 'AlainPlantec 12/1/2010 10:13'!
addEditCommand: anEditCommand

	"self editHistory rememberCommand: anEditCommand."
"
	Debug dShow: anEditCommand newText.
	Debug dShow: anEditCommand replacedText.
"


! !

!TextMorphEditor methodsFor: 'private' stamp: 'stephane.ducasse 4/14/2009 10:46'!
againOrSame: bool 

	super againOrSame: bool.
	(morph respondsTo: #editView) 
		ifTrue: [morph editView selectionInterval: self selectionInterval]! !

!TextMorphEditor methodsFor: 'menu messages' stamp: 'ar 12/17/2001 12:55'!
align
	"Align text according to the next greater alignment value,
	cycling among leftFlush, rightFlush, center, and justified."
	self changeAlignment.
	self recomputeInterval! !

!TextMorphEditor methodsFor: 'binding' stamp: 'ls 7/24/1998 21:06'!
bindingOf: aString
	^model bindingOf: aString! !

!TextMorphEditor methodsFor: 'menu messages' stamp: 'di 10/9/1998 16:55'!
cancel
	"Cancel the changes made so far to this text"
	morph cancelEdits! !

!TextMorphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 18:13'!
changeEmphasis: aStream keyEvent: keyEvent
	"Change the emphasis of the current selection."
	| retval |
	retval := super changeEmphasis: aStream keyEvent: keyEvent.
	paragraph composeAll.
	self recomputeInterval.
	morph updateFromParagraph.
	^retval! !

!TextMorphEditor methodsFor: 'attributes' stamp: 'PeterHugossonMiller 9/3/2009 11:44'!
changeEmphasisOrAlignment
	| aList reply code align menuList startIndex alignSymbol |
	self flag: #arNote. "Move this up once we get rid of MVC"

	startIndex := self startIndex.
	aList := #(#normal #bold #italic #narrow #underlined #struckOut #leftFlush #centered #rightFlush #justified ).
	align := paragraph text
				alignmentAt: startIndex
				ifAbsent: [paragraph textStyle alignment].
	alignSymbol := TextAlignment alignmentSymbol: align.
	code := paragraph text emphasisAt: startIndex.
	menuList := Array new writeStream.
	menuList nextPut: (code isZero
			ifTrue: ['<on>']
			ifFalse: ['<off>'])
			, 'normal' translated.
	menuList
		nextPutAll: (#(#bold #italic #underlined #struckOut )
				collect: [:emph | (code anyMask: (TextEmphasis perform: emph) emphasisCode)
						ifTrue: ['<on>' , emph asString translated]
						ifFalse: ['<off>' , emph asString translated]]).
	((paragraph text attributesAt: startIndex forStyle: paragraph textStyle)
			anySatisfy: [:attr | attr isKern
					and: [attr kern < 0]])
		ifTrue: [menuList nextPut: '<on>' , 'narrow' translated]
		ifFalse: [menuList nextPut: '<off>' , 'narrow' translated].
	menuList
		nextPutAll: (#(#leftFlush #centered #rightFlush #justified )
				collect: [:type | type == alignSymbol
						ifTrue: ['<on>' , type asString translated]
						ifFalse: ['<off>' , type asString translated]]).
	aList := #(#normal #bold #italic #underlined #struckOut #narrow #leftFlush #centered #rightFlush #justified ).
	reply := UIManager default chooseFrom: menuList contents values: aList lines: #(1 6 ).
	reply ifNotNil: [
		(#(#leftFlush #centered #rightFlush #justified ) includes: reply)
				ifTrue: [self setAlignment: reply.
					paragraph composeAll.
					self recomputeInterval]
				ifFalse: [self setEmphasis: reply.
					paragraph composeAll.
					self recomputeSelection]].
	^ true! !

!TextMorphEditor methodsFor: 'attributes' stamp: 'BenjaminVanRyseghem 11/28/2010 19:02'!
changeStyle
	"Let user change styles for the current text pane."
	| aList reply style theStyle menuList |
	self flag: #arNote. "Move this up once we get rid of MVC"
	aList := StrikeFont actualFamilyNames.
	theStyle := paragraph textStyle.
	menuList := aList collect:[:styleName|
		"Hack!! use defaultFont for comparison - we have no name that we could use for compare and the style changes with alignment so they're no longer equal."
		(TextSharedInformation at: styleName) defaultFont == theStyle defaultFont
			ifTrue:['<on>', styleName]
			ifFalse:['<off>',styleName]].
	theStyle = TextStyle default
		ifTrue:[menuList addFirst: '<on>DefaultTextStyle']
		ifFalse:[menuList addFirst: '<off>DefaultTextStyle'].
	aList addFirst: 'DefaultTextStyle'.
	reply := UIManager default chooseFrom: menuList  values: aList lines: #(1).
	reply ifNotNil:
		[(style := TextStyle named: reply) ifNil: [Beeper beep. ^ true].
		paragraph textStyle: style copy.
		paragraph composeAll.
		self recomputeSelection.
		].
	^ true! !

!TextMorphEditor methodsFor: 'editing keys' stamp: 'AlainPlantec 4/14/2010 15:06'!
chooseColor
	| attribute |
	"Make a new Text Color Attribute, let the user pick a color, and return the attribute"
	attribute := TextColor color: Color black "default".
	UIManager default chooseColor
		ifNotNil: [:nc | attribute color: nc].
	^ attribute
! !

!TextMorphEditor methodsFor: 'multi level undo' stamp: 'AlainPlantec 1/28/2011 21:53'!
closeTypeIn

	| begin stop rInterval nInterval newText |

	(UndoMessage sends: #noUndoer) ifFalse:[^super closeTypeIn].
	self useMultipleUndo ifTrue: 
		[
		beginTypeInBlock == nil ifFalse:
			[
				begin := self startOfTyping.
				stop := self stopIndex.
				rInterval := (begin "+ UndoMessage argument" 
																to: begin + UndoSelection size - 1).
				nInterval := begin to: stop - 1.
				(nInterval = rInterval) ifTrue:[ ^super closeTypeIn ].
				newText := nInterval size > 0
										ifTrue: [ paragraph text 
																copyFrom: nInterval first 
																to: nInterval last ]
										ifFalse: [ self nullText ]
			]
		].
	
	"Call the super regardless, just to keep the standard undo machine happy"
	^super closeTypeIn
! !

!TextMorphEditor methodsFor: 'controlling' stamp: 'di 4/16/1998 11:33'!
controlInitialize
	"No-op for MVC ParagraphEditor compatibility"! !

!TextMorphEditor methodsFor: 'controlling' stamp: 'di 4/16/1998 11:33'!
controlTerminate
	"No-op for MVC ParagraphEditor compatibility"! !

!TextMorphEditor methodsFor: 'typing support' stamp: 'michael.rueger 3/9/2009 22:43'!
dispatchOnKeyEvent: keyEvent with: typeAheadStream
	"Carry out the action associated with this character, if any.
	Type-ahead is passed so some routines can flush or use it."

	((keyEvent keyCharacter = Character cr) and: [morph acceptOnCR])
		ifTrue: [
			self closeTypeIn.
			^ true].

	^ super dispatchOnKeyEvent: keyEvent with: typeAheadStream! !

!TextMorphEditor methodsFor: 'multi level undo' stamp: 'AlainPlantec 12/1/2010 10:12'!
editHistory
	"^morph editHistory"
	^ nil
! !

!TextMorphEditor methodsFor: 'menu messages' stamp: 'di 10/5/1998 21:48'!
find
	super find.
	morph installEditorToReplace: self! !

!TextMorphEditor methodsFor: 'displaying' stamp: 'di 4/22/1998 10:21'!
flash
	^ morph flash! !

!TextMorphEditor methodsFor: 'editing keys' stamp: 'michael.rueger 2/23/2009 13:32'!
inspectIt: characterStream 
	"Inspect the selection -- invoked via cmd-i.  If there is no current selection, use the current line."

	self inspectIt.
	^ true! !

!TextMorphEditor methodsFor: 'multi level undo' stamp: 'sps 7/24/2003 12:37'!
isInTypeRun
	^beginTypeInBlock ~~ nil
! !

!TextMorphEditor methodsFor: 'typing support' stamp: 'michael.rueger 2/23/2009 17:40'!
keystroke: keyEvent
	super keystroke: keyEvent.
	self storeSelectionInParagraph! !

!TextMorphEditor methodsFor: 'accessing' stamp: 'tk 1/13/1999 07:53'!
morph
	^ morph! !

!TextMorphEditor methodsFor: 'accessing' stamp: 'tk 1/13/1999 07:53'!
morph: aMorph
	"Install a link back to the morph being edited (esp for text links)"
	morph := aMorph ! !

!TextMorphEditor methodsFor: 'events' stamp: 'th 9/18/2002 11:15'!
mouseDown: evt 
	"An attempt to break up the old processRedButton code into threee phases"
	| clickPoint |

	oldInterval := self selectionInterval.
	clickPoint := evt cursorPoint.
	(paragraph clickAt: clickPoint for: model controller: self) ifTrue: [
		pivotBlock := paragraph characterBlockAtPoint: clickPoint.
		self markBlock: pivotBlock.
		self pointBlock: pivotBlock.
		evt hand releaseKeyboardFocus: self.
		^ self].
	evt shiftPressed
		ifFalse:
			[self closeTypeIn.
			pivotBlock := paragraph characterBlockAtPoint: clickPoint.
			self markBlock: pivotBlock.
			self pointBlock: pivotBlock.]
		ifTrue:
			[self closeTypeIn.
			self mouseMove: evt].
	self storeSelectionInParagraph! !

!TextMorphEditor methodsFor: 'events' stamp: 'th 9/17/2002 16:45'!
mouseMove: evt 
	"Change the selection in response to moue-down drag"

	pivotBlock ifNil: [^ self].  "Patched during clickAt: repair"
	self pointBlock: (paragraph characterBlockAtPoint: (evt cursorPoint)).
	self storeSelectionInParagraph! !

!TextMorphEditor methodsFor: 'events' stamp: 'th 9/19/2002 18:29'!
mouseUp: evt
	"An attempt to break up the old processRedButton code into threee phases"
	oldInterval ifNil: [^ self].  "Patched during clickAt: repair"
	(self hasCaret 
		and: [oldInterval = self selectionInterval])
		ifTrue: [self selectWord].
	self setEmphasisHere.
	(self isDisjointFrom: oldInterval) ifTrue:
		[otherInterval := oldInterval].
	self storeSelectionInParagraph! !

!TextMorphEditor methodsFor: 'multi level undo' stamp: 'sps 7/24/2003 17:24'!
multiUndo
	^self multiUndoWithCount: 1
! !

!TextMorphEditor methodsFor: 'multi level undo' stamp: 'md 8/15/2005 11:18'!
multiUndoError: eString

	Beeper beep
! !

!TextMorphEditor methodsFor: 'multi level undo' stamp: 'AlainPlantec 1/28/2011 21:45'!
multiUndoWithCount: count

	^ self! !

!TextMorphEditor methodsFor: 'multi level undo' stamp: 'sps 7/24/2003 13:45'!
noUndoReplace: anInterval with: aText
"This is the zap that multilevel undo uses to do edits. This method bypasses any undo/redo plumbing (in contrast to zapSelection:).  This method is called by an EditCommand (which wants to carry out its paragraph surgery without adding another command to the editHistory)"

	| start stop |
	self deselect.
	start := (anInterval first max: 1).
	stop := (anInterval last min: paragraph text size).
	(aText isEmpty and: [stop > start]) ifTrue:
		["If deleting, then set emphasisHere from 1st character of the deletion"
		emphasisHere := (paragraph text attributesAt: start forStyle: paragraph textStyle)
					select: [:att | att mayBeExtended]].
"Debug dShow: ('zap start->stop: ', (start to: stop) asString)."
	paragraph 
		replaceFrom: start 
		to: stop 
		with: aText 
		displaying: false.  

	UndoMessage sends: #noUndoer . "Keep the normal undo machine happy"
	self userHasEdited  " -- note text now dirty"
! !

!TextMorphEditor methodsFor: 'attributes' stamp: 'alain.plantec 2/6/2009 17:36'!
offerFontMenu
	"Present a menu of available fonts, and if one is
	chosen, apply it to the current selection. 
	Use only names of Fonts of this paragraph "
	| aList reply curFont menuList | 
	true
		ifTrue: [^ self changeTextFont].
	self flag: #arNote. "Move this up once we get rid of MVC"
	curFont := (paragraph text fontAt: self startIndex withStyle: paragraph textStyle) fontNameWithPointSize.
	aList := paragraph textStyle fontNamesWithPointSizes.
	menuList := aList
				collect: [:fntName | fntName = curFont
						ifTrue: ['<on>' , fntName]
						ifFalse: ['<off>' , fntName]].
	reply := UIManager default chooseFrom: menuList  values: aList.
	reply ifNotNil:[
		self replaceSelectionWith: (Text
			  	string: self selection asString
			 	attribute: (TextFontChange fontNumber: (aList indexOf: reply)))]! !

!TextMorphEditor methodsFor: 'menu commands' stamp: 'sw 12/9/2001 18:55'!
offerMenuFromEsc: characterStream 
	"The escape key was hit while the receiver has the keyboard focus; take action"

	^ ActiveEvent shiftPressed 
		ifTrue:
			[self escapeToDesktop: characterStream]
		ifFalse:
			[self raiseContextMenu: characterStream]! !

!TextMorphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'michael.rueger 2/23/2009 13:32'!
raiseContextMenu: characterStream 
	(morph respondsTo: #editView)
		ifTrue: [morph editView yellowButtonActivity: ActiveEvent shiftPressed]
		ifFalse: [
			morph yellowButtonActivity: false].
	^ true! !

!TextMorphEditor methodsFor: 'scrolling' stamp: 'di 10/2/97 09:08'!
scrollBy: ignore 
	"Ignore scroll requests."! !

!TextMorphEditor methodsFor: 'current selection' stamp: ''!
select
	"Ignore selection redraw requests."! !

!TextMorphEditor methodsFor: 'current selection' stamp: 'jm 10/28/97 18:31'!
selectAndScroll
	"Ignore scroll requests."! !

!TextMorphEditor methodsFor: 'new selection' stamp: 'ls 11/10/2002 12:26'!
selectFrom: start to: stop
	"Select the specified characters inclusive."
	self selectInvisiblyFrom: start to: stop.
	self closeTypeIn.
	self storeSelectionInParagraph.
	self setEmphasisHere.
! !

!TextMorphEditor methodsFor: 'mvc compatibility' stamp: 'th 9/19/2002 18:17'!
storeSelectionInParagraph
	paragraph selectionStart: self startBlock selectionStop: self stopBlock! !

!TextMorphEditor methodsFor: 'editing keys' stamp: 'sw 10/18/1998 10:17'!
tempCommand: characterStream 
	"Experimental.  Triggered by Cmd-t; put trial cmd-key commands here to see how they work, before hanging them on their own cmd accelerators."
	Sensor keyboard.
	morph tempCommand.
	^ true! !

!TextMorphEditor methodsFor: 'attributes' stamp: 'nk 7/3/2003 18:33'!
textAlignment
	"Answer 1..4, representing #leftFlush, #rightFlush, #centered, or #justified"
	^paragraph text alignmentAt: startBlock stringIndex
		ifAbsent: [paragraph textStyle alignment]! !

!TextMorphEditor methodsFor: 'attributes' stamp: 'nk 7/3/2003 18:33'!
textAlignmentSymbol
	^#(leftFlush rightFlush centered justified) at: self textAlignment
	! !

!TextMorphEditor methodsFor: 'as yet unclassified' stamp: 'sbw 10/13/1999 22:41'!
totalTextHeight

	^paragraph lines last bottom! !

!TextMorphEditor methodsFor: 'accessing' stamp: 'ar 9/22/2001 16:16'!
transformFrom: owner
	^morph transformFrom: owner! !

!TextMorphEditor methodsFor: 'multi level undo' stamp: 'AlainPlantec 12/11/2009 09:32'!
undo
	"Reset the state of the paragraph prior to the previous edit.
	 If another ParagraphEditor instance did that edit, UndoInterval is invalid;
	 just recover the contents of the undo-buffer at the start of the paragraph."

	self useMultipleUndo
		ifTrue: [ ^self multiUndo ]
		ifFalse:[ ^super undo ].
! !

!TextMorphEditor methodsFor: 'settings' stamp: 'AlainPlantec 12/11/2009 09:31'!
useMultipleUndo
	^ self class useMultipleUndo! !

!TextMorphEditor methodsFor: 'accessing' stamp: 'di 4/21/1998 14:11'!
userHasEdited
	"Note that my text is free of user edits."

	morph hasUnacceptedEdits: true! !

!TextMorphEditor methodsFor: 'as yet unclassified' stamp: 'sbw 10/13/1999 22:43'!
visibleHeight

	^morph owner bounds height! !

!TextMorphEditor methodsFor: 'menu messages' stamp: 'AlainPlantec 1/28/2011 21:52'!
zapSelectionWith: aText
	"**overridden to inhibit old-style display"
	| start stop rText rInterval isInTypeRun |
	self deselect.
	start := self startIndex.
	stop := self stopIndex.
	(aText isEmpty and: [stop > start]) ifTrue:
		["If deleting, then set emphasisHere from 1st character of the deletion"
		emphasisHere := (paragraph text attributesAt: start forStyle: paragraph textStyle)
					select: [:att | att mayBeExtended]].
	(start = stop and: [aText size = 0]) ifFalse:
		[
		"===Support for multilevel undo start ==="
		rText := (paragraph text copyFrom: start to: (stop - 1)).
		rInterval := start to: (stop - 1).
		isInTypeRun := self isInTypeRun.
		"===Support for multilevel undo end ==="
		
		paragraph replaceFrom: start to: stop - 1
			with: aText displaying: false.  "** was true in super"
		self computeIntervalFrom: start to: start + aText size - 1.
		UndoInterval := otherInterval := self selectionInterval.

		"===Support for multilevel undo start ==="
		"===Support for multilevel undo end ==="].

	self userHasEdited  " -- note text now dirty"! !

Object subclass: #PointerFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!PointerFinder commentStamp: '<historical>' prior: 0!
I can search for reasons why a certain object isn't garbage collected.  I'm a quick port of a VisualWorks program written by Hans-Martin Mosner.  Call me as shown below.  I'll search for a path from a global variable to the given object, presenting it in a small morphic UI.

Examples:
	PointerFinder on: self currentHand
	PointerFinder on: StandardSystemView someInstance

Now, let's see why this image contains more HandMorphs as expected...

HandMorph allInstancesDo: [:e | PointerFinder on: e]!

!PointerFinder class methodsFor: 'utilities' stamp: 'SeanDeNigris 8/31/2011 14:20'!
pointersTo: anObject
	self deprecated: 'Use ProtoObject>>pointersTo instead.' on: '11 June 2010' in: 'Pharo1.2'! !

!PointerFinder class methodsFor: 'utilities' stamp: 'SeanDeNigris 8/31/2011 14:20'!
pointersTo: anObject except: objectsToExclude
	self deprecated: 'Use ProtoObject>>pointersToExcept: instead.' on: '11 June 2010' in: 'Pharo1.2'! !

!PointerFinder class methodsFor: 'utilities' stamp: 'SeanDeNigris 8/31/2011 14:20'!
pointersToItem: index of: anArray
	self deprecated: 'Use ProtoObject>>pointersTo instead.' on: '11 June 2010' in: 'Pharo1.2'! !

Object subclass: #StandardToolSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated13'!

!StandardToolSet commentStamp: '<historical>' prior: 0!
Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

!StandardToolSet class methodsFor: 'inspecting' stamp: 'IgorStasenko 4/26/2011 16:04'!
basicInspect: anObject
	"Open an inspector on the given object. The tool set must know which inspector type to use for which object - the object cannot possibly know what kind of inspectors the toolset provides."
	^Smalltalk tools basicInspector openOn: anObject! !

!StandardToolSet class methodsFor: 'browsing' stamp: 'md 3/10/2006 21:43'!
browse: aClass selector: aSelector
	"Open a browser"
	^SystemBrowser default fullOnClass: aClass selector: aSelector! !

!StandardToolSet class methodsFor: 'browsing' stamp: 'IgorStasenko 4/26/2011 16:05'!
browseChangeSetsWithClass: aClass selector: aSelector
	"Browse all the change sets with the given class/selector"
	^Smalltalk tools changeSorter browseChangeSetsWithClass: aClass selector: aSelector! !

!StandardToolSet class methodsFor: 'browsing' stamp: 'MarcusDenker 2/16/2010 16:22'!
browseHierarchy: aClass selector: aSelector
	"Open a browser"
	aClass ifNil: [^ self].
	(SystemBrowser default new setClass: aClass selector: aSelector) spawnHierarchy.! !

!StandardToolSet class methodsFor: 'browsing' stamp: 'davidroethlisberger 2/11/2009 12:00'!
browseImplementorsOf: aSymbol name: titleString autoSelect: autoSelectString
	^self browseMessageSet: (SystemNavigation default allImplementorsOf: aSymbol) asSortedCollection name: titleString autoSelect: autoSelectString! !

!StandardToolSet class methodsFor: 'browsing' stamp: 'IgorStasenko 4/26/2011 16:05'!
browseMessageNames: aString
	^(Smalltalk tools messageNames methodBrowserSearchingFor: aString) openInWorld! !

!StandardToolSet class methodsFor: 'browsing' stamp: 'IgorStasenko 4/26/2011 16:05'!
browseMessageSet: messageList name: title autoSelect: autoSelectString
	"Open a message set browser"
	^Smalltalk tools messageSet
		openMessageList: messageList 
		name: title 
		autoSelect: autoSelectString! !

!StandardToolSet class methodsFor: 'browsing' stamp: 'JB 2/18/2010 13:52'!
browseSendersOf: aSymbol name: titleString autoSelect: autoSelectString
	
	^self 
		browseMessageSet: (SystemNavigation default allCallsOn: aSymbol) asSortedCollection
		name: titleString 
		autoSelect: autoSelectString! !

!StandardToolSet class methodsFor: 'browsing' stamp: 'IgorStasenko 4/26/2011 16:06'!
browseVersionsOf: aClass selector: aSelector
	"Open a browser"
	Smalltalk tools versionBrowser
		browseVersionsOf: (aClass compiledMethodAt: aSelector)
		class: aClass theNonMetaClass
		meta: aClass isMeta
		category: (aClass organization categoryOfElement: aSelector)
		selector: aSelector! !

!StandardToolSet class methodsFor: 'completion' stamp: 'damiencassou 7/29/2009 16:12'!
codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: evt
	^ aBlock value! !

!StandardToolSet class methodsFor: 'debugging' stamp: 'IgorStasenko 4/26/2011 16:03'!
debug: aProcess context: aContext label: aString contents: contents fullView: aBool
	"Open a debugger on the given process and context."
	^Smalltalk tools debugger openOn: aProcess context: aContext label: aString contents: contents fullView: aBool! !

!StandardToolSet class methodsFor: 'debugging' stamp: 'IgorStasenko 4/26/2011 16:12'!
debug: aGuineaPig controller: aController context: aContext

	^Smalltalk tools debugger new
		process: aGuineaPig
		controller: aController
		context: aContext! !

!StandardToolSet class methodsFor: 'debugging' stamp: 'IgorStasenko 4/26/2011 16:11'!
debugContext: aContext

	^Smalltalk tools debugger context: aContext! !

!StandardToolSet class methodsFor: 'debugging' stamp: 'IgorStasenko 4/26/2011 16:04'!
debugContext: aContext label: aString contents: contents
	"Open a debugger on the given process and context."
	^Smalltalk tools debugger openContext: aContext label: aString contents: contents! !

!StandardToolSet class methodsFor: 'debugging' stamp: 'ar 7/17/2005 11:16'!
debugError: anError
	"Handle an otherwise unhandled error"
	^Processor activeProcess
		debug: anError signalerContext
		title: anError description! !

!StandardToolSet class methodsFor: 'debugging' stamp: 'IgorStasenko 4/26/2011 16:57'!
debugSyntaxError: anError
	"Handle a syntax error"
	| notifier |
	notifier :=  Smalltalk tools syntaxError new
		setClass: anError errorClass
		code: anError errorCode
		debugger: (Smalltalk tools debugger context: anError signalerContext)
		doitFlag: anError doitFlag.
	notifier category: anError category.
	Smalltalk tools syntaxError open: notifier.! !

!StandardToolSet class methodsFor: 'inspecting' stamp: 'IgorStasenko 4/26/2011 16:05'!
explore: anObject
	"Open an explorer on the given object."
	^Smalltalk tools objectExplorer new openExplorerFor: anObject! !

!StandardToolSet class methodsFor: 'initialization' stamp: 'AlainPlantec 12/16/2009 21:26'!
initialize
	ToolSet register: self.
! !

!StandardToolSet class methodsFor: 'inspecting' stamp: 'ar 7/15/2005 18:58'!
inspect: anObject
	"Open an inspector on the given object. The tool set must know which inspector type to use for which object - the object cannot possibly know what kind of inspectors the toolset provides."
	^(self inspectorClassOf: anObject) openOn: anObject! !

!StandardToolSet class methodsFor: 'inspecting' stamp: 'ar 7/15/2005 19:57'!
inspect: anObject label: aString
	"Open an inspector on the given object. The tool set must know which inspector type to use for which object - the object cannot possibly know what kind of inspectors the toolset provides."
	^(self inspectorClassOf: anObject) openOn: anObject withEvalPane: true withLabel: aString! !

!StandardToolSet class methodsFor: 'inspecting' stamp: 'lr 3/14/2010 21:13'!
inspectorClassOf: anObject
	"Answer the inspector class for the given object. The tool set must know which inspector type to use for which object - the object cannot possibly know what kind of inspectors the toolset provides."

	| map |
	map := Dictionary new.
	#(#(#CompiledMethod #CompiledMethodInspector) #(#CompositeEvent #OrderedCollectionInspector) #(#Dictionary #DictionaryInspector) #(#ExternalStructure #ExternalStructureInspector) #(#FloatArray #OrderedCollectionInspector) #(#OrderedCollection #OrderedCollectionInspector) #(#Set #SetInspector) #(#WeakSet #WeakSetInspector))
		do: [ :spec | map at: spec first put: spec last ].
	anObject class
		withAllSuperclassesDo: [ :cls | map at: cls name ifPresent: [ :inspectorName | ^ Smalltalk globals classNamed: inspectorName ] ].
	^ Inspector! !

!StandardToolSet class methodsFor: 'debugging' stamp: 'IgorStasenko 4/26/2011 16:05'!
interrupt: aProcess label: aString
	"Open a debugger on the given process and context."
	Smalltalk tools debugger
		openInterrupt: aString
		onProcess: aProcess! !

!StandardToolSet class methodsFor: 'debugging' stamp: 'MikeRoberts 4/1/2009 21:18'!
isDebugger: aModel

	^aModel isKindOf: Debugger! !

!StandardToolSet class methodsFor: 'menu' stamp: 'DavidRoethlisberger 12/23/2009 16:53'!
mainMenuItems
	"Answer the most important menu items available for this tool set"
	^#(
		('System Browser' 			#openClassBrowser)
		('Workspace'				#openWorkspace)
		('Test Runner'				#openTestRunner)
		('Monticello Browser'		#openMonticelloBrowser)
	)
! !

!StandardToolSet class methodsFor: 'menu' stamp: 'StephaneDucasse 1/28/2011 16:42'!
menuItems
	"Answer the menu items available for this tool set"
	
	^#(
		('System Browser' 			#openClassBrowser)
		('Message Names'				#openMessageNames)
		-
		('Workspace'					#openWorkspace)
		('Transcript' 				#openTranscript)
		('File Browser'				#openFileList)
		-
		('Test Runner'				#openTestRunner)
		('Process Browser' 			#openProcessBrowser)
		-
		('Monticello Browser'		#openMonticelloBrowser)
		"('Monticello Configurations' #openMonticelloConfigurations)"
		('Recover lost changes...'	#openRecentChangesLog)
		"('Simple Change Sorter'		#openChangeSorter)"
		('Change Sorter'				#openDualChangeSorter)
	)
! !

!StandardToolSet class methodsFor: 'browsing' stamp: 'IgorStasenko 4/26/2011 16:04'!
openChangedMessageSet: aChangeSet
	"Open a ChangedMessageSet for aChangeSet"
	Smalltalk tools changedMessageSet openFor: aChangeSet! !

!StandardToolSet class methodsFor: 'menu' stamp: 'md 3/10/2006 21:47'!
openClassBrowser
	SystemBrowser default open! !

!StandardToolSet class methodsFor: 'browsing' stamp: 'IgorStasenko 4/26/2011 16:04'!
openClassListBrowser: anArray title: aString
	"Open a class list browser"
	^Smalltalk tools classListBrowser new initForClassesNamed: anArray title: aString
! !

!StandardToolSet class methodsFor: 'menu' stamp: 'JuanVuletich 10/21/2010 17:09'!
openDualChangeSorter
	DualChangeSorter new openAsMorph! !

!StandardToolSet class methodsFor: 'menu' stamp: 'IgorStasenko 4/26/2011 16:12'!
openFileList
	Smalltalk tools fileList open! !

!StandardToolSet class methodsFor: 'menu' stamp: 'IgorStasenko 4/26/2011 16:06'!
openMessageNames
	"Bring a MessageNames tool to the front"
	Smalltalk tools messageNames openMessageNames! !

!StandardToolSet class methodsFor: 'menu' stamp: 'IgorStasenko 4/26/2011 16:06'!
openProcessBrowser
	Smalltalk tools processBrowser open! !

!StandardToolSet class methodsFor: 'menu' stamp: 'IgorStasenko 4/26/2011 16:07'!
openRecentChangesLog
	Smalltalk tools changeList browseRecentLog! !

!StandardToolSet class methodsFor: 'menu' stamp: 'BartGauquie 11/1/2009 10:55'!
openTestRunner
	TestRunnerBrowser default ifNotNil: [^ TestRunnerBrowser default open].
	self inform: 'No test runner installed.'! !

!StandardToolSet class methodsFor: 'menu' stamp: 'FernandoOlivero 3/29/2011 12:44'!
openTranscript
	UIManager default openTranscript! !

!StandardToolSet class methodsFor: 'menu' stamp: 'IgorStasenko 4/26/2011 16:06'!
openWorkspace
	Smalltalk tools workspace open! !

!StandardToolSet class methodsFor: 'browsing' stamp: 'FernandoOlivero 4/12/2011 10:31'!
theme
	^ UITheme current ! !

!StandardToolSet class methodsFor: 'initialization' stamp: 'ar 7/16/2005 16:18'!
unload
	ToolSet unregister: self.! !

Object subclass: #TextPrinter
	instanceVariableNames: 'form para paperSize landscape resolution depth offset columns docTitle noHeader noFooter'
	classVariableNames: 'DefaultPaperSize DefaultTextPrinter'
	poolDictionaries: ''
	category: 'Deprecated13'!

!TextPrinter class methodsFor: 'accessing' stamp: 'ar 4/30/98 18:31'!
defaultPaperSize
	^DefaultPaperSize! !

!TextPrinter class methodsFor: 'accessing' stamp: 'ar 4/30/98 18:31'!
defaultPaperSize: aPoint
	DefaultPaperSize := aPoint! !

!TextPrinter class methodsFor: 'accessing' stamp: 'lr 7/4/2009 10:42'!
defaultTextPrinter
	"This is the global default TextPrinter instance."
	DefaultTextPrinter isNil ifTrue: [ DefaultTextPrinter := self new ].
	^ DefaultTextPrinter! !

!TextPrinter class methodsFor: 'initialization' stamp: 'ar 4/30/98 18:30'!
initialize
	"TextPrinter initialize"
	self defaultPaperSize: self paperSizeA4.! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:30'!
mm2in: aPoint
	"Convert aPoint from millimeters to inches"
	^aPoint / 25.4! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:27'!
paperSize10x14
	^10.0@14.0! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:27'!
paperSize11x17
	^11.0@17.0! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:27'!
paperSizeA3
	^self mm2in: 297@420! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:27'!
paperSizeA4
	^self mm2in: 210@297! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:27'!
paperSizeA5
	^self mm2in: 148@210! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:27'!
paperSizeB4
	^self mm2in: 250@354! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:27'!
paperSizeB5
	^self mm2in: 182@257! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:28'!
paperSizeCSheet
	^17.0@22.0! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:28'!
paperSizeDSheet
	^22.0@34.0! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:29'!
paperSizeESheet
	^34.0@44.0! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:28'!
paperSizeEnvelope10
	^4.125@9.5
! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:28'!
paperSizeEnvelope11
	^4.5@10.375! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:28'!
paperSizeEnvelope12
	^4.75@11! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:28'!
paperSizeEnvelope14
	^5.0@11.5! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:28'!
paperSizeEnvelope9
	^3.875@8.875! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:28'!
paperSizeEnvelopeB4
	^self mm2in: 250@353! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:28'!
paperSizeEnvelopeB5
	^self mm2in: 176@250! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:28'!
paperSizeEnvelopeB6
	^self mm2in: 176@125! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:28'!
paperSizeEnvelopeC3
	^self mm2in: 324@458! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:29'!
paperSizeEnvelopeC4
	^self mm2in: 229@324! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:29'!
paperSizeEnvelopeC5
	^self mm2in: 162@229! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:29'!
paperSizeEnvelopeC6
	^self mm2in: 114@162! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:29'!
paperSizeEnvelopeC65
	^self mm2in: 114@229! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:29'!
paperSizeFanfoldGerman
	"German standard fanfold"
	^8.5@12.0! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:29'!
paperSizeFanfoldLegalGerman
	"German legal fanfold"
	^8.5@13.0! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:29'!
paperSizeFanfoldUS
	"US standard fanfold"
	^14.875@11.0! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:29'!
paperSizeFolio
	^8.5@13.0! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:29'!
paperSizeLegal
	^8.5@14.0! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:29'!
paperSizeLetter
	^8.5@11.0! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:29'!
paperSizeNote
	^8.5@11.0! !

!TextPrinter class methodsFor: 'paper sizes' stamp: 'ar 4/30/98 18:30'!
paperSizeTabloid
	^11.0@17.0! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 18:42'!
bestColor
	"Set the reproduction quality to true color"
	depth := 32.! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 18:42'!
blackAndWhite
	"Set the reproduction quality to black and white"
	depth := 1.! !

!TextPrinter methodsFor: 'formatting' stamp: 'ar 4/30/98 19:25'!
columnRect: n
	"Return a rectangle describing the n-th column"
	| area left right |
	area := self textArea.
	left := area left + ((n-1) * self columnWidth).
	left := left + ((n-1) * self columnSkip).
	right := left + self columnWidth.
	^(self in2pix: left @ area top) corner: 
		(self in2pix: right @ area bottom)! !

!TextPrinter methodsFor: 'formatting' stamp: 'ar 4/30/98 19:20'!
columnSkip
	"Return the separating space between two columns in inches"
	^0.2! !

!TextPrinter methodsFor: 'formatting' stamp: 'ar 4/30/98 19:21'!
columnWidth
	^(self textWidth - ((self columns-1) * self columnSkip)) / self columns! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 18:50'!
columns
	^columns! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 18:50'!
columns: aNumber
	columns := aNumber asInteger max: 1.! !

!TextPrinter methodsFor: 'initialize' stamp: 'ar 4/30/98 19:26'!
defaultPaperSize
	"Return the default paper size (inches) for printing"
	^self class defaultPaperSize! !

!TextPrinter methodsFor: 'initialize' stamp: 'nk 4/2/2004 11:32'!
defaultResolution
	"Return the default resolution (DPI) for printing"
	^TextStyle pixelsPerInch asPoint! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 20:14'!
documentTitle
	^docTitle! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 20:14'!
documentTitle: aString
	docTitle := aString! !

!TextPrinter methodsFor: 'printing' stamp: 'ar 4/30/98 20:41'!
flushPage
	"The current page has been set up. Send it to the printer."
	form primPrintHScale: self resolution x vScale: self resolution y landscape: self landscape.
	"Uncomment the following for testing"
	"form displayOn: Display. (Delay forSeconds: 5) wait."
! !

!TextPrinter methodsFor: 'footer' stamp: 'ar 4/30/98 19:23'!
footerHeight
	"Return the (additional) height of the footer in inches."
	self noFooter ifTrue:[^0.0].
	^(self pix2in: 0@TextStyle default lineGrid) y * 2! !

!TextPrinter methodsFor: 'footer' stamp: 'ar 4/30/98 20:11'!
footerParagraph
	"Return a paragraph for the footer"
	| fPara rect |
	fPara := Paragraph new.
	fPara destinationForm: form.
	rect := (self in2pix: self textArea bottomLeft) corner: 
				(self in2pix: self textArea bottomRight + (0.0@self footerHeight)).
	fPara clippingRectangle: rect.
	fPara compositionRectangle: rect.
	^fPara! !

!TextPrinter methodsFor: 'formatting' stamp: 'ar 4/30/98 19:29'!
formatColumn: columnNum startingWith: anIndex
	"Format a new column starting at the given string index. Return the string index indicating the start of the next column or nil if no more columns need printing."
	| colRect blk |
	colRect := self columnRect: columnNum.
	anIndex > 1 ifTrue:[para text: (para text copyFrom: anIndex to: para text size)].
	para compositionRectangle: colRect.
	para clippingRectangle: colRect.
	para composeAll.
	para displayOn: form.
	para visibleRectangle corner y <= colRect extent y ifTrue:[^nil].
	"More columns -- find the character block of the last line and adjust clip rect"
	blk := para characterBlockAtPoint: para visibleRectangle bottomLeft.
	para clearVisibleRectangle. "Make sure that the background is clean"
	para clippingRectangle: (colRect topLeft corner: colRect right@blk top).
	para displayOn: form.
	^blk stringIndex.! !

!TextPrinter methodsFor: 'formatting' stamp: 'ar 4/30/98 19:29'!
formatPage: pageNum startingWith: anIndex
	"Format a new page starting at the given string index. Return the string index indicating the start of the next page or nil if no more pages need printing."
	| nextIndex |
	nextIndex := anIndex.
	1 to: self columns do:[:i|
		nextIndex := self formatColumn: i startingWith: nextIndex.
		nextIndex isNil ifTrue:[^nil].
	].
	^nextIndex! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 18:42'!
goodColor
	"Set the reproduction quality to 8 bit color depth"
	depth := 8.! !

!TextPrinter methodsFor: 'header' stamp: 'ar 4/30/98 19:23'!
headerHeight
	"Return the (additional) height of the header in inches."
	self noHeader ifTrue:[^0.0].
	^(self pix2in: 0@TextStyle default lineGrid) y * 2! !

!TextPrinter methodsFor: 'header' stamp: 'ar 4/30/98 20:11'!
headerParagraph
	"Return a paragraph for the footer"
	| hPara rect |
	hPara := Paragraph new.
	hPara destinationForm: form.
	rect := (self in2pix: self textArea topLeft - (0.0@self headerHeight)) corner: 
				(self in2pix: self textArea topRight).
	hPara clippingRectangle: rect.
	hPara compositionRectangle: rect.
	^hPara! !

!TextPrinter methodsFor: 'other' stamp: 'ar 4/30/98 18:39'!
in2mm: aPoint
	"Convert aPoint from millimeters to inches"
	^aPoint * 25.4! !

!TextPrinter methodsFor: 'other' stamp: 'ar 4/30/98 18:38'!
in2pix: aPoint
	"Convert aPoint from inches to actual pixels"
	^(aPoint * self resolution) rounded! !

!TextPrinter methodsFor: 'initialize' stamp: 'adrian_lienhard 7/18/2009 16:03'!
initialize
	self paperSize: self defaultPaperSize.
	self resolution: self defaultResolution.
	self blackAndWhite.
	self landscape: false.
	self offsetRect: (1.0@1.0 corner: 1.0@1.0).
	self columns: 1.
	self noHeader: false.
	self noFooter: false.
	self documentTitle: 'Pharo Document (from ', Date today printString,')'.! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 18:42'!
landscape
	^landscape! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 18:42'!
landscape: aBoolean
	landscape := aBoolean! !

!TextPrinter methodsFor: 'other' stamp: 'ar 4/30/98 18:38'!
mm2in: aPoint
	"Convert aPoint from millimeters to inches"
	^aPoint / 25.4! !

!TextPrinter methodsFor: 'other' stamp: 'ar 4/30/98 18:40'!
mm2pix: aPoint
	"Convert aPoint from millimeters to actual pixels"
	^self in2pix: (self mm2in: aPoint)! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 19:23'!
noFooter
	^noFooter! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 19:22'!
noFooter: aBoolean
	"Turn off footer printing"
	noFooter := aBoolean.! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 19:22'!
noHeader
	^noHeader! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 19:22'!
noHeader: aBoolean
	"Turn off header printing"
	noHeader := aBoolean.! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 19:27'!
offsetRect
	^offset! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 19:27'!
offsetRect: aRectangle
	"Set the offset rectangle"
	offset := aRectangle! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 18:42'!
paperSize
	^paperSize! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 18:42'!
paperSize: aPoint
	paperSize := aPoint! !

!TextPrinter methodsFor: 'other' stamp: 'ar 4/30/98 18:39'!
pix2in: aPoint
	"Convert aPoint from a pixel value to inches"
	^aPoint / self resolution! !

!TextPrinter methodsFor: 'other' stamp: 'ar 4/30/98 18:40'!
pix2mm: aPoint
	"Convert aPoint from a pixel value to millimeters"
	^self in2mm: (self pix2in: aPoint)! !

!TextPrinter methodsFor: 'private' stamp: 'ar 4/30/98 19:40'!
pixelSize
	"Return the size of the page in pixels"
	^self in2pix: (self realPaperSize)! !

!TextPrinter methodsFor: 'footer' stamp: 'ar 4/30/98 19:24'!
printFooter: pageNumber
	"Print the footer for the given page number"
	| fPara |
	self noFooter ifTrue:[^self].
	fPara := self footerParagraph.
	fPara centered.
	fPara text: ('Page ', pageNumber printString) asText.
	fPara displayOn: form.! !

!TextPrinter methodsFor: 'header' stamp: 'ar 4/30/98 19:23'!
printHeader: pageNumber
	"Print the header for the given page number"
	| fPara |
	self noHeader ifTrue:[^self].
	fPara := self headerParagraph.
	fPara centered.
	fPara text: self documentTitle asText.
	fPara displayOn: form.! !

!TextPrinter methodsFor: 'printing' stamp: 'ar 4/30/98 19:19'!
printParagraph
	| pageNum nextIndex |
	para destinationForm: form.
	pageNum := 1.
	nextIndex := 1.
	[form fillColor: Color white.
	self printHeader: pageNum.
	self printFooter: pageNum.
	nextIndex := self formatPage: pageNum startingWith: nextIndex.
	self flushPage.
	nextIndex isNil] whileFalse:[pageNum := pageNum + 1].! !

!TextPrinter methodsFor: 'printing' stamp: 'ar 4/30/98 18:55'!
printText: aText
	"Print aText"
	form isNil ifTrue:[
		form := Form extent: self pixelSize depth: depth.
	].
	para := Paragraph withText: aText asText.
	Cursor wait showWhile:[
		self printParagraph.
	].! !

!TextPrinter methodsFor: 'private' stamp: 'ar 4/30/98 19:39'!
realPaperSize
	^self landscape
		ifTrue:[self paperSize y @ self paperSize x]
		ifFalse:[self paperSize]! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 18:43'!
resolution
	^resolution! !

!TextPrinter methodsFor: 'accessing' stamp: 'ar 4/30/98 18:43'!
resolution: aPoint
	resolution := aPoint! !

!TextPrinter methodsFor: 'formatting' stamp: 'ar 4/30/98 19:58'!
textArea
	^(self offsetRect origin + (0.0@self headerHeight)) corner:
		(self realPaperSize - self offsetRect corner - (0.0@self footerHeight))! !

!TextPrinter methodsFor: 'formatting' stamp: 'ar 4/30/98 19:23'!
textWidth
	^self textArea extent x! !

!PluggableTextMorph methodsFor: '*deprecated13' stamp: 'AlainPlantec 11/8/2010 22:10'!
setTextColor: aColor
	"Set the color of my text to the given color"

	self deprecated: 'Use #textColor:' on: '17 August 2010' in: 'Pharo1.2'.
	self textColor: aColor! !
StandardToolSet initialize!
TextPrinter initialize!
ParagraphEditor initialize!
CrLfFileStream initialize!
